<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: admin-config.php,v 1.12 2005/06/28 20:14:54 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "admin-templates");

//# Setting templates and requiring core
$bb_templates = '1,12,85,135,136,137,138,139,140,141,142,143';
require("core.php");

if($user->userdata['admin_cp'] != 1){
    bb_error("You do not have permission to use the administrator control panel.");
}

$action = prepValue($_GET['a']);

$breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"admin-config.php\">AdminCP</a>";

//# Admin Message
if($_GET['msg'] != ""){
    $msg = str_replace("+", " ", $_GET['msg']);
    $msg = prepValue($msg);
    eval("\$admin_message = \"".$template->getTemplate('143')."\";");
}

//# Switchboard
switch($action){
    case '':
        eval("\$cpinclude = \"".$template->getTemplate('135')."\";");
    break;
    case 'editconfigform':
        //usergroup stuff
        $grabdefaultgid = $SQL->query("SELECT * FROM `".$database['prefix']."usergroups` ORDER BY `id`");
        while($defgroup = $SQL->fetch_array($grabdefaultgid)){
            $defaultgid_area .= $template->getTemplate('137');
            $defaultgid_area = stripslashes($defaultgid_area);
            if($config['defaultgid'] == $defgroup['id']){
                $defgroup['selected'] = $template->getVar('group_selected');
            }
            $defaultgid_area = $template->cacheArray($defaultgid_area, $defgroup);
        }
        $defgroup = $template->releaseCache();
        eval("\$defaultgid_area = \"".addslashes($defaultgid_area)."\";");

        $grabguestgid = $SQL->query("SELECT * FROM `".$database['prefix']."usergroups` ORDER BY `id`");
        while($guestgroup = $SQL->fetch_array($grabguestgid)){
            $guestgid_area .= $template->getTemplate('138');
            $guestgid_area = stripslashes($guestgid_area);
            if($config['guestgid'] == $guestgroup['id']){
                $guestgroup['selected'] = $template->getVar('group_selected');
            }
            $guestgid_area = $template->cacheArray($guestgid_area, $guestgroup);
        }
        $guestgroup = $template->releaseCache();
        eval("\$guestgid_area = \"".addslashes($guestgid_area)."\";");

        //skinarea
        $grabskins = $SQL->query("SELECT * FROM `".$database['prefix']."skins` ORDER BY `name`");
        while($skin = $SQL->fetch_array($grabskins)){
            $skinarea .= $template->getTemplate('139');
            $skinarea = stripslashes($skinarea);
            if($config['skindefault'] == $skin['id']){
                $skin['selected'] = "selected";
            }
            $skinarea = $template->cacheArray($skinarea, $skin);
        }
        $skin = $template->releaseCache();
        eval("\$skinarea = \"".addslashes($skinarea)."\";");

        //checked items
        $gz[$config['gzlevel']] = "selected";

        if($config['usegz'] == 1){
            $checked['usegz'] = $template->getVar('config_checked');
        }
        if($config['remembertopicloc'] == 1){
            $checked['remembertopicloc'] = $template->getVar('config_checked');
        }
        if($config['remembertopicloc'] == 1){
            $checked['remembertopicloc'] = $template->getVar('config_checked');
        }
        if($config['sendpm'] == 1){
            $checked['sendpm'] = $template->getVar('config_checked');
        }
        if($config['viewsiggies'] == 1){
            $checked['viewsiggies'] = $template->getVar('config_checked');
        }
        if($config['viewavatars'] == 1){
            $checked['viewavatars'] = $template->getVar('config_checked');
        }
        if($config['viewhistory'] == 1){
            $checked['viewhistory'] = $template->getVar('config_checked');
        }
        if($config['parseurls'] == 1){
            $checked['parseurls'] = $template->getVar('config_checked');
        }
        if($config['disableemoticons'] == 1){
            $checked['disableemoticons'] = $template->getVar('config_checked');
        }
        if($config['censor'] == 1){
            $checked['censor'] = $template->getVar('config_checked');
        }
        if($config['locked'] == 1){
            $checked['locked'] = $template->getVar('config_checked');
        }
        if($config['mail_srv_auth'] == 1){
            $checked['mail_srv_auth'] = $template->getVar('config_checked');
        }

        $checked['regtype'.$config['regtype']] = $template->getVar('config_checked');
        $checked['mail_type'.$config['mail_type']] = $template->getVar('config_checked');

        eval("\$cpinclude = \"".$template->getTemplate('136')."\";");
    break;
    case 'editconfig':
        //prepping all values
        $emailifpm = addslashes($_POST['emailifpm']);
        $emaillink = addslashes($_POST['emaillink']);
        $emailpass = addslashes($_POST['emailpass']);
        $emailapprove = addslashes($_POST['emailapprove']);
        $emaildecline = addslashes($_POST['emaildecline']);
        $adminapprove = addslashes($_POST['adminapprove']);
        $subscriptionmail = addslashes($_POsT['subscriptionmail']);

        $emailifpm = str_replace("\n", "\\n", $emailifpm);
        $emailifpm = str_replace("\r", "\\r", $emailifpm);
        $emaillink = str_replace("\n", "\\n", $emaillink);
        $emaillink = str_replace("\r", "\\r", $emaillink);
        $emailpass = str_replace("\n", "\\n", $emailpass);
        $emailpass = str_replace("\r", "\\r", $emailpass);
        $emailapprove = str_replace("\n", "\\n", $emailapprove);
        $emailapprove = str_replace("\r", "\\r", $emailapprove);
        $emaildecline = str_replace("\n", "\\n", $emaildecline);
        $emaildecline = str_replace("\r", "\\r", $emaildecline);
        $adminapprove = str_replace("\n", "\\n", $adminapprove);
        $adminapprove = str_replace("\r", "\\r", $adminapprove);
        $subscriptionmail = str_replace("\n", "\\n", $subscriptionmail);
        $subscriptionmail = str_replace("\r", "\\r", $subscriptionmail);

        $_POST = prepValue($_POST);

        //for checkbox values
        if($_POST['remembertopicloc'] == ""){
            $_POST['remembertopicloc'] = 0;
        }
        if($_POST['$sendpm'] == ""){
            $_POST['sendpm'] = 0;
        }
        if($_POST['usegz'] == ""){
            $_POST['usegz'] = 0;
        }
        if($_POST['viewsiggies'] == ""){
            $_POST['viewsiggies'] = 0;
        }
        if($_POST['viewavatars'] == ""){
            $_POST['viewavatars'] = 0;
        }
        if($_POST['viewhistory'] == ""){
            $_POST['viewhistory'] = 0;
        }
        if($_POST['parseurls'] == ""){
            $_POST['parseurls'] = 0;
        }
        if($_POST['disableemoticons'] == ""){
            $_POST['disableemoticons'] = 0;
        }
        if($_POST['censor'] == ""){
            $_POST['censor'] = 0;
        }
        if($_POST['locked'] == ""){
            $_POST['locked'] = 0;
        }
        if($_POST['mail_type'] != 1){
            $_POST['mail_type'] = 1;
        }
        if($_POST['mail_srv_auth'] == ""){
            $_POST['mail_srv_auth'] = 0;
        }

        //checking for trailing slash paths
        if(substr($_POST['boardurl'], -1) != "/"){
            $_POST['boardurl'] .= "/";
        }
        if(substr($_POST['avatarpath'], -1) != "/"){
            $_POST['avatarpath'] .= "/";
        }
        if(substr($_POST['emoticonpath'], -1) != "/"){
            $_POST['emoticonpath'] .= "/";
        }
        if(substr($_POST['posticonpath'], -1) != "/"){
            $_POST['posticonpath'] .= "/";
        }

        //writing file
        if(!($fp = @fopen('configuration/config.inc.php', 'w'))){
            bb_error("Couldn't open config file for writing.");
        }
        fwrite($fp, "<?php\r\n");
        fwrite($fp, "\$config = array(\"boardname\"        => \"".$_POST['boardname']."\",\r\n");
        fwrite($fp, "                \"boardurl\"         => \"".$_POST['boardurl']."\",\r\n");
        fwrite($fp, "                \"ckprefix\"         => \"".$_POST['ckprefix']."\",\r\n");
        fwrite($fp, "                \"cookiepath\"       => \"".$_POST['cookiepath']."\",\r\n");
        fwrite($fp, "                \"cookiedomain\"     => \"".$_POST['cookiedomain']."\",\r\n");
        fwrite($fp, "                \"skindefault\"      => ".$_POST['skindefault'].",\r\n");
        fwrite($fp, "                \"defaultgid\"       => ".$_POST['defaultgid'].",\r\n");
        fwrite($fp, "                \"guestgid\"         => ".$_POST['guestgid'].",\r\n");
        fwrite($fp, "                \"maxpolloptions\"   => ".$_POST['maxpolloptions'].",\r\n");
        fwrite($fp, "                \"emoticonspost\"    => ".$_POST['emoticonspost'].",\r\n");
        fwrite($fp, "                \"postsperpage\"     => ".$_POST['postsperpage'].",\r\n");
        fwrite($fp, "                \"topicsperpage\"    => ".$_POST['topicsperpage'].",\r\n");
        fwrite($fp, "                \"membersperpage\"   => ".$_POST['membersperpage'].",\r\n");
        fwrite($fp, "                \"remembertopicloc\" => ".$_POST['remembertopicloc'].",\r\n");
        fwrite($fp, "                \"avatarbytes\"      => ".$_POST['avatarbytes'].",\r\n");
        fwrite($fp, "                \"avatarwidth\"      => ".$_POST['avatarwidth'].",\r\n");
        fwrite($fp, "                \"avatarheight\"     => ".$_POST['avatarheight'].",\r\n");
        fwrite($fp, "                \"avatarextensions\" => \"".$_POST['avatarextensions']."\",\r\n");
        fwrite($fp, "                \"acceptedurlproto\" => \"".$_POST['acceptedurlproto']."\",\r\n");
        fwrite($fp, "                \"avatarpath\"       => \"".$_POST['avatarpath']."\",\r\n");
        fwrite($fp, "                \"emoticonpath\"     => \"".$_POST['emoticonpath']."\",\r\n");
        fwrite($fp, "                \"posticonpath\"     => \"".$_POST['posticonpath']."\",\r\n");
        fwrite($fp, "                \"badcharpool\"      => \"".$_POST['badcharpool']."\",\r\n");
        fwrite($fp, "                \"badwordpool\"      => \"".$_POST['badwordpool']."\",\r\n");
        fwrite($fp, "                \"regtype\"          => ".$_POST['regtype'].",\r\n");
        fwrite($fp, "                \"sendpm\"           => ".$_POST['sendpm'].",\r\n");
        fwrite($fp, "                \"pmsub\"            => \"".$_POST['pmsub']."\",\r\n");
        fwrite($fp, "                \"pmmsg\"            => \"".$_POST['pmmsg']."\",\r\n");
        fwrite($fp, "                \"emailifpm\"        => \"$emailifpm\",\r\n");
        fwrite($fp, "                \"emaillink\"        => \"$emaillink\",\r\n");
        fwrite($fp, "                \"emailpass\"        => \"$emailpass\",\r\n");
        fwrite($fp, "                \"emailapprove\"     => \"$emailapprove\",\r\n");
        fwrite($fp, "                \"emaildecline\"     => \"$emaildecline\",\r\n");
        fwrite($fp, "                \"adminapprove\"     => \"$adminapprove\",\r\n");
        fwrite($fp, "                \"subscriptionmail\" => \"$subscriptionmail\",\r\n");
        fwrite($fp, "                \"viewsiggies\"      => ".$_POST['viewsiggies'].",\r\n");
        fwrite($fp, "                \"viewavatars\"      => ".$_POST['viewavatars'].",\r\n");
        fwrite($fp, "                \"viewhistory\"      => ".$_POST['viewhistory'].",\r\n");
        fwrite($fp, "                \"parseurls\"        => ".$_POST['parseurls'].",\r\n");
        fwrite($fp, "                \"disableemoticons\" => ".$_POST['disableemoticons'].",\r\n");
        fwrite($fp, "                \"censor\"           => ".$_POST['censor'].",\r\n");
        fwrite($fp, "                \"usegz\"            => ".$_POST['usegz'].",\r\n");
        fwrite($fp, "                \"gzlevel\"          => ".$_POST['gzlevel'].",\r\n");
        fwrite($fp, "                \"floodlimit\"       => ".$_POST['floodlimit'].",\r\n");
        fwrite($fp, "                \"uploadbytes\"      => ".$_POST['uploadbytes'].",\r\n");
        fwrite($fp, "                \"uploadext\"        => \"".$_POST['uploadext']."\",\r\n");
        fwrite($fp, "                \"locked\"           => ".$_POST['locked'].",\r\n");
        fwrite($fp, "                \"lockedmsg\"        => \"".$_POST['lockedmsg']."\",\r\n");
        fwrite($fp, "                \"mail_type\"        => ".$_POST['mail_type'].",\r\n");
        fwrite($fp, "                \"mail_from\"        => \"".$_POST['mail_from']."\",\r\n");
        fwrite($fp, "                \"mail_srv_auth\"    => ".$_POST['mail_srv_auth'].",\r\n");
        fwrite($fp, "                \"mail_hostname\"    => \"".$_POST['mail_hostname']."\",\r\n");
        fwrite($fp, "                \"mail_username\"    => \"".$_POST['mail_username']."\",\r\n");
        fwrite($fp, "                \"mail_password\"    => \"".$_POST['mail_password']."\"\r\n");
        fwrite($fp, ");\r\n");
        fwrite($fp, "?>");
        fclose($fp);

        die_header("Location: ".$config['boardurl']."admin-config.php?msg=Configuration+was+successfully+updated.");
    break;
    case 'manageimages':
        //# Emoticons
        $grabemoticons = $SQL->query("SELECT * FROM `".$database['prefix']."emoticons`");
        while($emoticon = $SQL->fetch_array($grabemoticons)){
            $emoticonarea .= $template->getTemplate('140');
            $emoticonarea = $template->cacheArray($emoticonarea, $emoticon);
        }
        $emoticon = $template->releaseCache();
        eval("\$emoticonarea = \"$emoticonarea\";");

        //# Posticons
        $grabposticons = $SQL->query("SELECT * FROM `".$database['prefix']."posticons`");
        while($posticon = $SQL->fetch_array($grabposticons)){
            $posticonarea .= $template->getTemplate('141');
            $posticonarea = $template->cacheArray($posticonarea, $posticon);
        }
        $posticon = $template->releaseCache();
        eval("\$posticonarea = \"$posticonarea\";");

        eval("\$cpinclude = \"".$template->getTemplate('142')."\";");
    break;
    case 'addemoticon':
        if(!is_writable($config['emoticonpath'])){
            bb_error("Cannot write the the current emoticon directory. Please set the permissions to allow writing in the emoticon directory.");
        }
        $emoticon = prepValue($_POST['emoticon']);
        if($emoticon == ""){
            bb_error("You didn't enter an emoticon.");
        }
        $checkexist = $SQL->query("SELECT * FROM `".$database['prefix']."emoticons` WHERE `emoticon` = '$emoticon'");
        if($SQL->num_rows($checkexist) > 0){
            bb_error("That emoticon (<b>$emoticon</b>) already exists.");
        }
        if(file_exists($config['emoticonpath'].$_FILES['emoticonfile']['name'])){
            bb_error("Emoticon image already exists. Try renaming image and re-uploading.");
        }
        if(!move_uploaded_file($_FILES['emoticonfile']['tmp_name'], $config['emoticonpath'].basename($_FILES['emoticonfile']['name']))){
            bb_error("Emoticon failed to be uploaded. Check the permissions of the emoticon directory.");
        }
        $insert = $SQL->query("INSERT INTO `".$database['prefix']."emoticons` (`id`, `emoticon`, `image`) VALUES ('', '$emoticon', '".basename($_FILES['emoticonfile']['name'])."')");
        die_header("Location: ".$config['boardurl']."admin-config.php?a=manageimages&msg=Emoticon+was+successfully+added.");
    break;
    case 'deleteemoticon':
        if(!is_writable($config['emoticonpath'])){
            bb_error("Cannot write the the current emoticon directory. Please set the permissions to allow writing in the emoticon directory.");
        }
        $id = prepValue($_GET['id']);
        $grabemoticon = $SQL->query("SELECT * FROM `".$database['prefix']."emoticons` WHERE `id` = '$id'");
        if($SQL->num_rows($grabemoticon) < 1){
            bb_error("Emoticon doesn't exist.");
        }
        $emoticon = $SQL->fetch_array($grabemoticon);
        unlink($config['emoticonpath'].$emoticon['image']);
        $delete = $SQL->query("DELETE FROM `".$database['prefix']."emoticons` WHERE `id` = '$id'");
        die_header("Location: ".$config['boardurl']."admin-config.php?a=manageimages&msg=Emoticon+was+successfully+deleted.");
    break;
    case 'addposticon':
        if(!is_writable($config['posticonpath'])){
            bb_error("Cannot write the the current post icon directory. Please set the permissions to allow writing on the post icon directory.");
        }
        if(file_exists($config['posticonpath'].$_FILES['posticonfile']['name'])){
            bb_error("Post icon image already exists. Try renaming image and re-uploading.");
        }
        if(!move_uploaded_file($_FILES['posticonfile']['tmp_name'], $config['posticonpath'].basename($_FILES['posticonfile']['name']))){
            bb_error("Post icon failed to be uploaded. Check the permissions of the post icon directory.");
        }
        $insert = $SQL->query("INSERT INTO `".$database['prefix']."posticons` (`id`, `value`) VALUES ('', '".basename($_FILES['posticonfile']['name'])."')");
        die_header("Location: ".$config['boardurl']."admin-config.php?a=manageimages&msg=Post+icon+was+successfully+added.");
    break;
    case 'deleteposticon':
        if(!is_writable($config['posticonpath'])){
            bb_error("Cannot write the the current post icon directory. Please set the permissions to allow writing on the post icon directory.");
        }
        $id = prepValue($_GET['id']);
        $grabposticon = $SQL->query("SELECT * FROM `".$database['prefix']."posticons` WHERE `id` = '$id'");
        if($SQL->num_rows($grabposticon) < 1){
            bb_error("Emoticon doesn't exist.");
        }
        $posticon = $SQL->fetch_array($grabposticon);
        unlink($config['posticonpath'].$posticon['value']);
        $delete = $SQL->query("DELETE FROM `".$database['prefix']."posticons` WHERE `id` = '$id'");
        die_header("Location: ".$config['boardurl']."admin-config.php?a=manageimages&msg=Post+icon+was+successfully+deleted.");
    break;
    default:
        die_header("Location: ".$config['boardurl']."admin-config.php?a=");
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$include = \"".$template->templates['85']."\";");
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>