<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: timer.class.php,v 1.4 2005/06/10 02:02:41 mokkan Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


class Timer {
    //# Vars
    var $start  = 0;
    var $finish = 0;

    //# Starts the timer
    function startTimer() {
        $this->start = explode(" ", microtime());
        $this->start = $this->start[1] + $this->start[0];
    }

    //# Stops the timer and returns how long it took
    function stopTimer() {
        $this->finish = explode(" ", microtime());
        $this->finish = $this->finish[1] + $this->finish[0];
        return round($this->finish - $this->start, 4);
    }

    //# Function like above but for the SQL class
    function getTimer() {
        return ($this->finish - $this->start);
    }

    //# Resets the timer
    function resetTimer() {
        $this->start = 0;
        $this->finish = 0;
        return true;
    }
}
?>