<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: mod.php,v 1.14 2005/07/06 18:32:13 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "mod");

//# Templates:
$bb_templates = '1,12,20,25,23,34,60,63,65,66,67,68,69,70';
require("core.php");

$a = prepValue($_GET['a']);
//# Is there a preview?
if(isset($_POST['preview'])){
    $_POST['title'] = addslashes(addslashes($_POST['title']));
    $_POST = prepValue($_POST);

    //grabbing the post icon
    $grabicon = $SQL->query("SELECT * FROM `".$database['prefix']."posticons` WHERE `id` = '".prepValue($_POST['icon'])."'");
    $previcon = $SQL->fetch_array($grabicon);

    //building preview
    $post['title'] = $_POST['title'];
    $message = addslashes(addslashes($_POST['message']));

    //censoring bad words if needed
    if($user->getData('censor') == 1){
        $message = censor($message);
    }

    //parsing emoticons in post
    $grabemoticons = $SQL->query("SELECT `id`,`emoticon`,`image` FROM `".$database['prefix']."emoticons`");
    while($grab = $SQL->fetch_array($grabemoticons)){
        $emoticons[$grab['id']] = $grab['emoticon'];
        $emoticonimages[$grab['id']] = "<img src=\"$config[emoticonpath]$grab[image]\" alt=\"$grab[emoticon]\" />";
    }
    if($_POST['disableemoticons'] == 0){
        $message = parse_emoticons($message, $emoticons, $emoticonimages, $config['emoticonsperpost']);
    }

    //replacing newlines and tabs with html friendly characters
    $message = parse_breaks($message);
    //calling the function to parse bbcode
    $message = parse_bbcode($message);
    //parsing backslash replacments
    $message = str_replace("/me","<font color='#DD0000'>".$user->getData('username')."</font>",$message);
    $message = str_replace("/maim","<font color='#DD0000'>".$user->getData('aim')."</font>",$message);
    $message = str_replace("/mmsn","<font color='#DD0000'>".$user->getData('msn')."</font>",$message);
    $message = str_replace("/micq","<font color='#DD0000'>".$user->getData('icq')."</font>",$message);
    $message = str_replace("/myim","<font color='#DD0000'>".$user->getData('yim')."</font>",$message);
    $message = str_replace("/you","<font color='#007700'>".$user->getData('username')."</font>",$message);
    $message = str_replace("/ygroup","<font color='#007700'>".$user->getData('name')."</font>",$message);
    $message = str_replace("/ybday","<font color='#007700'>".$user->getData('bday').".".$user->getData('bmonth').".".$user->getData('byear')."</font>",$message);

    //autoparsing urls in post
    if($_POST['parseurls'] == 1){
        $message = parse_urls($message);
    }

    //setting the actual preview
    if(($post['title'] != "") || ($_POST['icon'] != "")){
        if($_POST['icon'] != ""){
            $post['posticon'] = "<img src=\"$config[posticonpath]".$previcon['value']."\" alt=\"\" />";
        }
        eval("\$preview = \"".$template->cleanTemplate('23') . addslashes($message)."\";");
    } else {
        $preview  = $message;
    }
    eval("\$previewdata = \"".$template->templates['34']."\";");
    $previewdata = stripslashes($previewdata);

    //prepping everything to go back to the form
    $a = "editpostform";
    $titlenew = $_POST['title'];
    $messagenew = addslashes($_POST['message']);
    $descriptionnew = addslashes($_POST['description']);
    $preview = 1;
}

switch($a){
    case 'editpostform': //Edit post form
        $pid = prepValue($_GET['pid']);

        $postquery = $SQL->query("SELECT p.*, t.fid, t.title AS topictitle, t.description, t.iconid AS posticon, t.locked FROM `".$database['prefix']."posts` AS p RIGHT JOIN `".$database['prefix']."topics` AS t ON(p.tid = t.id) WHERE p.id = '$pid'");
        $post = $SQL->fetch_array($postquery);
        $post['preview'] = $previewdata;
        $post['message'] = addslashes(addslashes($post['message']));
        $post['title'] = addslashes(addslashes($post['title']));

        //# Some forum vars
        $grabfrmname = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS c ON(f.parent = c.id) WHERE f.id='".$post['fid']."'");
        $crumbdata = $SQL->fetch_array($grabfrmname);

        //# Grabbing forum permissions
        $user->setForumPerms($crumbdata['fid']);

        //# Breadcrumbs
        if($crumbdata['class'] == "subforum"){
            $crumbdataq = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname,p.id AS pid, p.name AS pname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS p ON(p.id=f.parent) LEFT JOIN `".$database['prefix']."forums` AS c ON(p.parent = c.id) WHERE f.id='$crumbdata[id]'");
            $crumbdata = $SQL->fetch_array($crumbdataq);
            $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$crumbdata[cid]\">$crumbdata[cname]</a> " . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[pid]\">$crumbdata[pname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[id]\">$crumbdata[name]</a>" . $template->getVar('crumbsseperator') . "<a href=\"read.php?tid=$post[tid]\">$post[topictitle]</a>" . $template->getVar('crumbsseperator') . "Edit Post";
        } else {
            $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$crumbdata[cid]\">$crumbdata[cname]</a> " . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[id]\">$crumbdata[name]</a>" . $template->getVar('crumbsseperator') . "<a href=\"read.php?tid=$post[tid]\">$post[topictitle]</a>" . $template->getVar('crumbsseperator') . "Edit Post";
        }

        if(($post['posterid'] != $user->getData('id') && $user->getData('edit_others') != 1) || ($post['posterid'] == $user->getData('id') && $user->getData('edit_own') != 1)){
            bb_error("You do not have permission to edit this post.");
        }

        if($post['locked'] == 1 && $user->getData('use_locked') != 1){
            bb_error("You aren't allowed to edit replies in a locked topic.");
        }

        if ($preview == 1) {
            $post['title'] = stripslashes($titlenew);
            $post['message'] = $messagenew;
            $post['description'] = $descriptionnew;
            $post['posticon'] = $_POST['icon'];

            if($_POST['parseurls'] == 1){
                $checked['parseurls'] = "checked";
            }
            if($_POST['disableemoticons'] == 1){
                $checked['disableemoticons'] = "checked";
            }
            if($_POST['disablesiggy'] == 1){
                $checked['disablesiggy'] = "checked";
            }
            if($_POST['attachpoll'] == 1){
                $checked['attachpoll'] = "checked";
            }
        } else {
            if($post['parseurls'] == 1){
                $checked['parseurls'] = "checked";
            }
            if($post['disableemoticons'] == 1){
                $checked['disableemoticons'] = "checked";
            }
            if($post['disablesiggy'] == 1){
                $checked['disablesiggy'] = "checked";
            }
        }

        $post['javascript'] = $template->templates['20'];
        $post['maxfilesize'] = $config['uploadbytes'];
        $post['extensions'] = $config['uploadext'];
        $post['iconchecked'] = "checked";
        $grabposticons = $SQL->query("SELECT `id`,`value` FROM `".$database['prefix']."posticons`");
        while($grab = $SQL->fetch_array($grabposticons)){
            $iconchecked = "";
            if($post['posticon'] == $grab['id']){
                $iconchecked = "checked";
                $post['iconchecked'] = "";
            }
            $post['icons'] .= "<input type=\"radio\" name=\"icon\" value=\"$grab[id]\" $iconchecked><img src=\"$config[posticonpath]$grab[value]\" alt=\"\" /> ";
        }

        $grabemoticons = $SQL->query("SELECT `id`,`emoticon`,`image` FROM `".$database['prefix']."emoticons` LIMIT ".$template->getVar('emoticonsshown'));
        $counter = 0;
        while($grab = $SQL->fetch_array($grabemoticons)){
            if($counter == $template->getVar('emoticonsrow')){
                $post['emoticons'] .= "<br />";
                $counter = 0;
            }
            $post['emoticons'] .= "$spacer<a href=\"javascript:addEmoticon('$grab[emoticon]')\"><img src=\"$config[emoticonpath]$grab[image]\" border=\"0\" alt=\"$grab[emoticon]\" /></a>";
            $spacer = " ";
            $counter++;
        }

        $checkisfirstpost = $SQL->query("SELECT `id` FROM `".$database['prefix']."posts` WHERE `tid` = '".$post['tid']."' ORDER BY `dateline` ASC LIMIT 1");
        $firstpost = $SQL->fetch_array($checkisfirstpost);
        if($pid == $firstpost['id']){
            eval("\$include = \"".$template->templates['68']."\";");
        } else {
            eval("\$include = \"".$template->templates['63']."\";");
        }
        $include = stripslashes($include);

        //# Updating active table
        $user->updateActive("Editing Post For Topic: <a href=\"read.php?tid=$post[tid]\">$post[topictitle]</a>");
    break;
    case 'editpost': //Edit post action
        $pid = prepValue($_GET['pid']);
        $postquery = $SQL->query("SELECT p.*, t.fid, t.locked FROM `".$database['prefix']."posts` AS p RIGHT JOIN `".$database['prefix']."topics` AS t ON(p.tid = t.id) WHERE p.id = '$pid'");
        $post = $SQL->fetch_array($postquery);
        $_POST = prepValue($_POST);

        //# Grabbing forum permissions
        $user->setForumPerms($post['fid']);

        if(($post['posterid'] != $user->getData('id') && $user->getData('edit_others') != 1) || ($post['posterid'] == $user->getData('id') && $user->getData('edit_own') != 1)){
            bb_error("You do not have permission to edit this post.");
        }
        if($post['locked'] == 1 && $user->getData('use_locked') != 1){
            bb_error("You aren't allowed to edit replies in a locked topic.");
        }
        if(($_POST['message'] == "")){
            bb_error("You didn't input a message for the post.");
        }

        $title = $_POST['title'];
        $icon = $_POST['icon'];
        $message = $_POST['message'];
        $parseurls = $_POST['parseurls'];
        $disableemoticons = $_POST['disableemoticons'];
        $disablesiggy = $_POST['disablesiggy'];
        $attachid = $post['attachmentid'];
        $editname = $user->getData('username');
        $editdate = time();

        $checkisfirstpost = $SQL->query("SELECT `id` FROM `".$database['prefix']."posts` WHERE `tid` = '".$post['tid']."' ORDER BY `id` ASC LIMIT 1");
        $firstpost = $SQL->fetch_array($checkisfirstpost);

        if($pid == $firstpost['id']){
            if(($title == "")){
                bb_error("You didn't input a title for the post.");
            }
            $description = $_POST['description'];
            $updatetopic = $SQL->query("UPDATE `".$database['prefix']."topics` SET `iconid` = '$icon', `title` = '$title', `description` = '$description' WHERE `id` = '".$post['tid']."'");
            $checklastposttopic = $SQL->query("SELECT `lptopicid` FROM `".$database['prefix']."forums` WHERE `id` = '".$post['fid']."'");
            $lastposttopic = $SQL->fetch_array($checklastposttopic);
            if($lastposttopic['lptopicid'] == $post['tid']){
                $updatelpinfo = $SQL->query("UPDATE `".$database['prefix']."forums` SET `lptopicname` = '$title' WHERE `id` = '".$post['fid']."'");
            }
        }

        if(is_uploaded_file($_FILES['attachment']['tmp_name'])){ //is there an attached file?
            if($_FILE['attachment']['size'] > $config['uploadbytes']){ //checking if the attachment is too big or not
                bb_error("File is too big.");
            } elseif(strlen($_FILE['attachment']['name'] > 100)) { //checking if the filename will fit in db
                bb_error("File name is too big.");
            } else { //checking if file extension is valid
                $fileextension = strtolower(substr($_FILES['attachment']['name'], strrpos($_FILES['attachment']['name'], ".")));
                $extensions = explode(',', $config['uploadext']);
                foreach($extensions as $ext){
                    if($fileextension == $ext){
                        $clear = 1;
                    }
                    $msg = "File extension not allowed.";
                }
                if($user->getData('post_attachments') != 1){
                    $clear = 0;
                    $msg = "You are not allowed to post attachments.";
                }
                if($clear != 1){
                    bb_error($msg);
                }
                $uploadfile = str_replace("mod.php", "temp/", $_SERVER['SCRIPT_FILENAME']) . str_replace(' ', '', strtolower(basename($_FILES['attachment']['name'])));
                move_uploaded_file($_FILES['attachment']['tmp_name'], $uploadfile);
                $handle = fopen($uploadfile, "rb");
                $attachmentcontent = "";
                while (!feof($handle)) {
                    $attachmentcontent .= fread($handle, 1024);
                }
                fclose($handle);
                if ($attachid == 0) {
                    $insertattachment = $SQL->query("INSERT INTO `".$database['prefix']."attachments` (`id`,`name`,`size`,`content`,`downloads`,`date`) VALUES('','".$_FILES['attachment']['name']."','".$_FILES['attachment']['size']."','".$SQL->escape_string($attachmentcontent)."','0','".time()."')");
                    $grabattachid = $SQL->query("SELECT `id` FROM `".$database['prefix']."attachments` ORDER BY `id` DESC LIMIT 1");
                    $tempfetch = $SQL->fetch_array($grabattachid);
                    $attachid = $tempfetch['id'];
                } else {
                    $updateattachment = $SQL->query("UPDATE `".$database['prefix']."attachments` SET `name` = '".$_FILES['attachment']['name']."', `size` = '".$_FILES['attachment']['size']."',`content` = '".mysql_escape_string($attachmentcontent)."', `downloads` = '0', `date` = '".time()."' WHERE `id` = '".$attachid."'");
                }

                unlink($uploadfile);
            }
        }

        $updatepost = $SQL->query("UPDATE `".$database['prefix']."posts` SET `iconid` = '$icon', `title` = '$title', `message` = '$message', `parseurls` = '$parseurls', `disableemoticons` = '$disableemoticons', `disablesiggy` = '$disablesiggy', `attachmentid` = '$attachid', `editname` = '$editname', `editdate` = '$editdate' WHERE `id` = '$pid'");

        if ($_POST['attachpoll'] == 1) {
            if($pid != $firstpost['id'] || $user->getData('post_poll') != 1) {
                bb_error("You do not have access to this poll.");
            }
            $pollquery = $SQL->query("SELECT `id` FROM `".$database['prefix']."polls` WHERE `tid` = '".$post['tid']."'");
            $pollcheck = $SQL->num_rows($pollquery);

            if ($pollcheck >= 1) {
                die_header("Location: ".$config['boardurl']."mod.php?a=editpollform&tid=".$post['tid']);
            } else {
                die_header("Location: ".$config['boardurl']."post.php?a=attachpoll&pa=pollform&tid=".$post['tid']);
            }
        }

        die_header("Location: ".$config['boardurl']."read.php?tid=".$post['tid']."&a=specificpost&pid=$pid");
    break;
    case 'editpollform': //Edit poll form
        $tid = prepValue($_GET['tid']);
        if ($tid == "" || !is_numeric($tid)) {
            $tid = 1;
        }
        $tid = round($tid);

        $pollq = $SQL->query("SELECT p.id, p.title, p.multichoice, t.fid, t.authorid, t.title AS topictitle, t.locked FROM `".$database['prefix']."polls` AS p RIGHT JOIN `".$database['prefix']."topics` AS t ON(t.id = $tid) WHERE `tid` = '$tid'");
        $poll = $SQL->fetch_array($pollq);

        if($poll == ""){
            bb_error("There is no poll here to edit.");
        }

        //# Some forum vars
        $grabfrmname = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS c ON(f.parent = c.id) WHERE f.id='".$poll['fid']."'");
        $crumbdata = $SQL->fetch_array($grabfrmname);

        //# Grabbing forum permissions
        $user->setForumPerms($poll['fid']);

        //# Breadcrumbs
        if($crumbdata['class'] == "subforum"){
            $crumbdataq = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname,p.id AS pid, p.name AS pname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS p ON(p.id=f.parent) LEFT JOIN `".$database['prefix']."forums` AS c ON(p.parent = c.id) WHERE f.id='$crumbdata[id]'");
            $crumbdata = $SQL->fetch_array($crumbdataq);
            $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$crumbdata[cid]\">$crumbdata[cname]</a> " . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[pid]\">$crumbdata[pname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[id]\">$crumbdata[name]</a>" . $template->getVar('crumbsseperator') . "<a href=\"read.php?tid=$tid\">$poll[topictitle]</a>" . $template->getVar('crumbsseperator') . "Edit Poll";
        } else {
            $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$crumbdata[cid]\">$crumbdata[cname]</a> " . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[id]\">$crumbdata[name]</a>" . $template->getVar('crumbsseperator') . "<a href=\"read.php?tid=$tid\">$poll[topictitle]</a>" . $template->getVar('crumbsseperator') . "Edit Poll";
        }

        if(($user->getData('edit_own') != 1 && $user->getData('id') == $poll['authorid']) || ($user->getData('edit_others') != 1 && $user->getData('id') != $poll['authorid']) || ($poll['locked'] == 1  && $user->getData('use_locked') != 1)){
            bb_error("You do not have permission to edit this poll.");
        }

        if($poll['multichoice'] == 1){
            $poll['multiyes'] = "checked";
        } else {
            $poll['multino'] = "checked";
        }

        $loop = 1;
        $optq = $SQL->query("SELECT `name` FROM `".$database['prefix']."polloptions` WHERE `pollid`='".$poll['id']."'");
        while(($option = $SQL->fetch_array($query)) || ($loop <= $config['maxpolloptions'])){
            $options = stripslashes($options);
            $options .= stripslashes($template->templates['66']);
            eval("\$options = \"".addslashes($options)."\";");
            $loop++;
        }
        eval("\$include = \"".$template->templates['65']."\";");

        //# Updating active table
        $user->updateActive("Editing Poll For Topic: <a href=\"read.php?tid=$poll[tid]\">$poll[topictitle]</a>");
    break;
    case 'editpoll': //Edit poll action
        $pid = prepValue($_GET['pid']);
        if ($pid == "" || !is_numeric($pid)) {
            bb_error("There is no poll here to edit.");
        }
        $pid = round($pid);

        $pollq = $SQL->query("SELECT p.id, p.title, p.multichoice, t.id AS tid, t.fid, t.authorid, t.title AS topictitle, t.locked FROM `".$database['prefix']."polls` AS p RIGHT JOIN `".$database['prefix']."topics` AS t ON(p.tid = t.id) WHERE p.id = '$pid'");
        $poll = $SQL->fetch_array($pollq);

        if($poll == ""){
            bb_error("There is no poll here to edit.");
        }

        //# Grabbing forum permissions
        $user->setForumPerms($poll['fid']);

        if(($user->getData('edit_own') != 1 && $user->getData('id') == $poll['authorid']) || ($user->getData('edit_others') != 1 && $user->getData('id') != $poll['authorid'])){
            bb_error("You do not have permission to edit this poll.");
        }

        if($poll['locked'] == 1 && $user->getData('use_locked') != 1){
            bb_error("You can not edit a locked poll.");
        }

        if(($_POST['title'] == "") || ($_POST[1] == "" || $_POST[2] == "")){
            bb_error("You either forgot to enter a title, enter more that one option, or did not start listing your options at the first input box. If you ment to delete the poll, click <a href=\"mod.php?a=deletepoll&pid=$pid\">here</a>.");
        }

        $loop = 1;
        $optq = $SQL->query("SELECT `id`, `name`, `votes` FROM `".$database['prefix']."polloptions` WHERE `pollid`='$pid'");
        while(($option = $SQL->fetch_array($optq)) || ($loop <= $config['maxpolloptions'])){
            if(prepvalue($_POST[$loop]) != "") {
                if($option['name'] == "") {
                    $append = $SQL->query("INSERT INTO `".$database['prefix']."polloptions` VALUES('','$pid','".prepvalue($_POST[$loop])."','0')");
                } elseif($_POST[$loop] != $option['name']) {
                    $updateopt = $SQL->query("UPDATE `".$database['prefix']."polloptions` SET `name`='".prepvalue($_POST[$loop])."', `votes`='0' WHERE `id` = '".$option['id']."'");
                    $deletevotes = $SQL->query("DELETE FROM `".$database['prefix']."pollvotes` WHERE `pollid`='$pid' AND `optionid`='".$option['id']."'");
                    $updatevotes = $SQL->query("UPDATE `".$database['prefix']."polls` SET totalvotes=totalvotes-".$option['votes']." WHERE `id`='$pid'");
                }
            } elseif($option['name'] != "" && $_POST[$loop] == ""){
                $deleteopt = $SQL->query("DELETE FROM `".$database['prefix']."polloptions` WHERE `id`='".$option['id']."' AND `pollid`='$pid'");
                $deletevotes = $SQL->query("DELETE FROM `".$database['prefix']."pollvotes` WHERE `pollid`='$pid' AND `optionid`='".$option['id']."'");
                $updatevotes = $SQL->query("UPDATE `".$database['prefix']."polls` SET totalvotes=totalvotes-".$option['votes']." WHERE `id`='$pid'");
            } else {
                $loop = $config['maxpolloptions'];
            }
            $loop++;
        }
        $updateother = $SQL->query("UPDATE `".$database['prefix']."polls` SET title='".prepvalue($_POST['title'])."', multichoice='".$_POST['multi']."' WHERE `id`='$pid'");

        die_header("Location: ".$config['boardurl']."read.php?tid=".$poll['tid']);
    break;
    case 'deletepoll': //Delete poll action
        $pid = prepValue($_GET['pid']);
        if ($pid == "" || !is_numeric($pid)) {
            $pid = 1;
        }
        $pid = round($pid);

        $pollq = $SQL->query("SELECT t.id AS tid, t.fid, t.authorid FROM `".$database['prefix']."polls` AS p LEFT JOIN `".$database['prefix']."topics` AS t ON(p.tid = t.id) WHERE p.id='$pid'");
        $poll = $SQL->fetch_array($pollq);

        //# Grabbing forum permissions
        $user->setForumPerms($location['fid']);

        if(($user->getData('delete_own') != 1 && $user->getData('id') == $poll['authorid']) || ($user->getData('delete_others') != 1 && $user->getData('id') != $poll['authorid'])){
            bb_error("You do not have permission to delete this poll.");
        }

        $deletepoll = $SQL->query("DELETE FROM `".$database['prefix']."polls` WHERE `id` = '$pid' LIMIT 1");
        $deletepollvotes = $SQL->query("DELETE FROM `".$database['prefix']."pollvotes` WHERE `pollid` = '$pid'");
        $deletepolloptions = $SQL->query("DELETE FROM `".$database['prefix']."polloptions` WHERE `pollid` = '$pid'");

        die_header("Location: ".$config['boardurl']."read.php?tid=".$poll['tid']);
    break;
    case 'movetopicform': //Move topic Form
        $tid = prepValue($_GET['tid']);
        if ($tid == "" || !is_numeric($tid)) {
            $tid = 1;
        }
        $tid = round($tid);

        $tdata = $SQL->query("SELECT t.authorid, t.title AS name, f.id AS fid, f.class AS fclass, f.name AS fname,c.id AS cid,c.name AS cname FROM `".$database['prefix']."topics` AS t LEFT JOIN `".$database['prefix']."forums` as f ON(t.fid=f.id) LEFT JOIN `".$database['prefix']."forums` AS c ON(f.parent = c.id) WHERE t.id='$tid'");
        $topic = $SQL->fetch_array($tdata);

        //# Breadcrumbs
        if($topic['fclass'] == "subforum"){
            $crumbdataq = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname,p.id AS pid, p.name AS pname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS p ON(p.id=f.parent) LEFT JOIN `".$database['prefix']."forums` AS c ON(p.parent = c.id) WHERE f.id='$topic[fid]'");
            $crumbdata = $SQL->fetch_array($crumbdataq);
            $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$crumbdata[cid]\">$crumbdata[cname]</a> " . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[pid]\">$crumbdata[pname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[id]\">$crumbdata[name]</a>" . $template->getVar('crumbsseperator') . "<a href=\"read.php?tid=$tid\">$poll[topictitle]</a>" . $template->getVar('crumbsseperator') . "Move Topic";
        } else {
            $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$topic[cid]\">$topic[cname]</a> " . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$topic[fid]\">$topic[fname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"read.php?tid=$tid\">$topic[name]</a>" . $template->getVar('crumbsseperator') . "Move Topic";
        }

        //# Grabbing forum permissions
        $user->setForumPerms($topic['fid']);

        if(($user->getData('move_topics') != 1) || ($user->getData('view_forum') != 1)) {
            bb_error("You do not have permission to move this topic.");
        }

        $latestcid = "";
        $latestfid = "";
        $optq = $SQL->query("SELECT c.id AS cid, c.name AS cname, c.class AS cclass, f.id AS fid, f.name AS fname, f.class AS fclass, s.id AS sid, s.name AS sname, s.class AS sclass, fp.view_forum AS viewforum, sp.view_forum AS viewsubforum FROM `".$database['prefix']."forums` AS c LEFT JOIN `".$database['prefix']."forums` AS f ON(f.parent = c.id AND f.class = 'forum') LEFT JOIN `".$database['prefix']."forums` AS s ON(s.parent = f.id AND s.class = 'subforum') LEFT JOIN `".$database['prefix']."permissions` AS fp ON(fp.fid = f.id AND fp.gid = '".$user->getData('gid')."') LEFT JOIN `".$database['prefix']."permissions` AS sp ON(sp.fid = s.id AND sp.gid = '".$user->getData('gid')."') WHERE c.class = 'category' ORDER BY c.order,f.order,f.id,s.order,s.id");
        while($grab = $SQL->fetch_array($optq)){
            if($grab['cid'] != $latestcid && $grab['cid'] != ""){
                $options .= $template->templates['70'];
                $options = stripslashes($options);

                $option['disabled'] = "disabled";
                $option['name'] = $grab['cname'];

                eval("\$options = \"".addslashes($options)."\";");
                $latestcid = $grab['cid'];
            }
            if (($grab['fid'] != $latestfid) && ($grab['viewforum'] == "" || $grab['viewforum'] == "1") && $grab['fid'] != "") {
                $options .= $template->templates['70'];
                $options = stripslashes($options);

                $option['fid'] = $grab['fid'];
                $option['disabled'] = "";
                if ($grab['fid'] == $topic['fid']) {
                    $option['disabled'] = "disabled";
                }
                $option['name'] = "&nbsp;&nbsp;&nbsp;".$grab['fname'];

                eval("\$options = \"".addslashes($options)."\";");
                $latestfid = $grab['fid'];
            }
            if (($grab['sid'] != "") && ($grab['viewforum'] == "" || $grab['viewforum'] == "1") && ($grab['viewsubforum'] == "" || $grab['viewsubforum'] == "1")) {
                $options .= $template->templates['70'];
                $options = stripslashes($options);

                $option['fid'] = $grab['sid'];
                $option['disabled'] = "";
                if ($grab['sid'] == $topic['fid']) {
                    $option['disabled'] = "disabled";
                }
                $option['name'] = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".$grab['sname'];

                eval("\$options = \"".addslashes($options)."\";");
                $latestfid = $grab['fid'];
            }
        }
        eval("\$include = \"".$template->templates['69']."\";");

        //# Updating active table
        $user->updateActive("Moving Topic: <a href=\"read.php?tid=$tid\">$topic[name]</a>");
    break;
    case 'movetopic': //Move topic action
        $tid = prepValue($_GET['tid']);
        if ($tid == "" || !is_numeric($tid)) {
            $tid = 1;
        }
        $tid = round($tid);

        $fid = prepValue($_POST['fid']);
        if(!is_numeric($fid) || $fid == "") {
            bb_error("You did not select a forum to move this topic to.");
        }

        //# Grabbing current topic info
        $grabtopic = $SQL->query("SELECT * FROM `".$database['prefix']."topics` WHERE id = '$tid'");
        $topic = $SQL->fetch_array($grabtopic);
        $topic['posts'] = $topic['replies'] + 1;

        //# Grabbing current forum data
        $grabforum = $SQL->query("SELECT * FROM `".$database['prefix']."forums` WHERE `id` = '".$topic['fid']."'");
        $currentforum = $SQL->fetch_array($grabforum);
        if($currentforum['updateparent'] == '1'){
            $grabcurrentparent = $SQL->query("SELECT * FROM `".$database['prefix']."forums` WHERE `id` = '".$currentforum['parent']."'");
            $currentparent = $SQL->fetch_array($grabcurrentparent);
        }

        //# Grabbing current forum permissions
        $user->setForumPerms($topic['fid']);

        //# Grabbing destination forum permissions
        $destinfoq = $SQL->query("SELECT f.*,p.view_forum FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."permissions` AS p ON (f.id = p.fid) WHERE f.id = '$fid'");
        $destforum = $SQL->fetch_array($destinfoq);
        if($destforum['updateparent'] == '1'){
            $grabdestparent = $SQL->query("SELECT * FROM `".$database['prefix']."forums` WHERE `id` = '".$destforum['parent']."'");
            $destparent = $SQL->fetch_array($grabdestparent);
        }
        if(($user->getData('move_topics') != 1) || ($user->getData('view_forum') != 1) || ($destinfo['view_forum'] != "" && $destinfo['view_forum'] != "1")) {
            bb_error("You do not have permission to move this topic.");
        }

        $updateTforum = $SQL->query("UPDATE `".$database['prefix']."topics` SET `fid`='$fid', `moved` = '1' WHERE `id`='$tid'");

        //# Updating past forum
        if($currentforum['lptopicid'] == $topic['id']){
            $grabnewrecenttopic = $SQL->query("SELECT * FROM `".$database['prefix']."topics` WHERE `fid` = '".$topic['fid']."' ORDER BY `lpdate` DESC LIMIT 1");
            if($SQL->num_rows($grabnewrecenttopic) > 0){
                $newrecent = $SQL->fetch_array($grabnewrecenttopic);
                $updateoldforum = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = topics - 1, `posts` = posts - ".$topic['posts'].", `lpdate` = '".$newrecent['lpdate']."', `lptopicid` = '".$newrecent['lptopicid']."', `lptopicname` = '".$newrecent['title']."', `lpuserid` = '".$newrecent['lpuserid']."', `lpusername` = '".$newrecent['lpusername']."' WHERE `id` = '".$topic['fid']."'");
            } else {
                $updateoldforum = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = '0', `posts` = '0', `lpdate` = NULL, `lptopicid` = NULL, `lptopicname` = NULL, `lpuserid` = NULL, `lpusername` = NULL WHERE `id` = '".$currentforum['id']."'");
            }
        } else {
            $counttopics = $SQL->query("SELECT * FROM `".$database['prefix']."topics` WHERE `fid` = '".$topic['fid']."'");
            if($SQL->num_rows($counttopics) > 0){
                $updateoldparent = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = topics - 1, `posts` = posts - ".$topic['posts']." WHERE `id` = '".$topic['fid']."'");
            } else {
                $updateoldparent = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = '0', `posts` = posts - '0' WHERE `id` = '".$topic['fid']."'");
            }
        }

        //# Updating past parent
        if($currentforum['updateparent'] == '1' && $currentparent['lptopicid'] == $topic['id']){
            $grabnewrecenttopic = $SQL->query("SELECT * FROM `".$database['prefix']."topics` WHERE `fid` = '".$currentparent['id']."' ORDER BY `lpdate` DESC LIMIT 1");
            if($SQL->num_rows($grabnewrecenttopic) > 0){
                $newrecent = $SQL->fetch_array($grabnewrecenttopic);
                $updateoldparent = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = topics - 1, `posts` = posts - ".$topic['posts'].", `lpdate` = '".$newrecent['lpdate']."', `lptopicid` = '".$newrecent['lptopicid']."', `lptopicname` = '".$newrecent['lptopicname']."', `lpuserid` = '".$newrecent['lpuserid']."', `lpusername` = '".$newrecent['lpusername']."' WHERE `id` = '".$currentparent['id']."'");
            } else {
                $updateoldparent = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = '0', `posts` = '0', `lpdate` = NULL, `lptopicid` = NULL, `lptopicname` = NULL, `lpuserid` = NULL, `lpusername` = NULL WHERE `id` = '".$currentparent['id']."'");
            }
        } elseif($currentforum['updateparent'] == '1') {
            $counttopics = $SQL->query("SELECT * FROM `".$database['prefix']."topics` WHERE `fid` = '".$currentparent['id']."'");
            if($SQL->num_rows($counttopics) > 0){
                $updateoldparent = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = topics - 1, `posts` = posts - ".$topic['posts']." WHERE `id` = '".$currentparent['id']."'");
            } else {
                $updateoldparent = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = '0', `posts` = '0' WHERE `id` = '".$currentforum['parent']."'");
            }
        }

        //# Updating new forum
        if($destforum['lpdate'] < $topic['lpdate']){
            $updatenewforum = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = topics + 1, `posts` = posts + ".$topic['posts'].", `lpdate` = '".$topic['lpdate']."', `lptopicid` = '".$topic['id']."', `lptopicname` = '".$topic['title']."', `lpuserid` = '".$topic['lpuserid']."', `lpusername` = '".$topic['lpusername']."' WHERE `id` = '$fid'");
        } else {
            $updatenewparent = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = topics + 1, `posts` = posts + ".$topic['posts']." WHERE `id` = '$fid'");
        }

        //# Updating new parent
        if($destparent['lpdate'] < $topic['lpdate'] && $destforum['updateparent'] == '1'){
            $updatenewforum = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = topics + 1, `posts` = posts + ".$topic['posts'].", `lpdate` = '".$topic['lpdate']."', `lptopicid` = '".$topic['id']."', `lptopicname` = '".$topic['title']."', `lpuserid` = '".$topic['lpuserid']."', `lpusername` = '".$topic['lpusername']."' WHERE `id` = '".$destparent['id']."'");
        } elseif($destforum['updateparent'] == '1') {
            $updatenewparent = $SQL->query("UPDATE `".$database['prefix']."forums` SET `topics` = topics + 1, `posts` = posts + ".$topic['posts']." WHERE `id` = '".$destparent['id']."'");
        }
        die_header("Location: ".$config['boardurl']."read.php?tid=$tid");
    break;
    case 'deletetopic': //delete topic action
        $tid = prepValue($_GET['tid']);
        if ($tid == "" || !is_numeric($tid)) {
            bb_error("No topic specified.");
        }
        $tid = round($tid);

        $tdata = $SQL->query("SELECT `id`, `fid`, `authorid` FROM `".$database['prefix']."topics` WHERE `id` = '$tid'");
        $topic = $SQL->fetch_array($tdata);

        $fdata = $SQL->query("SELECT * FROM `".$database['prefix']."forums` WHERE `id` = '".$topic['fid']."'");
        $forum = $SQL->fetch_array($fdata);

        //# Grabbing forum permissions
        $user->setForumPerms($topic['fid']);

        if(($user->getData('delete_own') != 1 && $user->getData('id') == $topic['authorid']) || ($user->getData('delete_others') != 1 && $user->getData('id') != $topic['authorid'])){
            bb_error("You do not have permission to delete this topic.");
        }

        $topicposts = 0;
        $deleteq = $SQL->query("SELECT `id`,`posterid`,`attachmentid` FROM `".$database['prefix']."posts` WHERE `tid` = '$tid'");
        while ($delete = $SQL->fetch_array($deleteq)) {
            if ($delete['attachmentid'] != 0) {
                $deleteatachment = $SQL->query("DELETE FROM `".$database['prefix']."attachments` WHERE `id` = '".$delete['attachmentid']."'");
            }
            if($forum['disablepc'] != 1){
                $lowerpostcount = $SQL->query("UPDATE `".$database['prefix']."users` SET `posts`=posts - 1 WHERE `id` = '".$delete['posterid']."'");
            }
            $deletepost = $SQL->query("DELETE FROM `".$database['prefix']."posts` WHERE `id` = '".$delete['id']."' AND `tid` = '$tid' AND `posterid` = '".$delete['posterid']."' LIMIT 1");

            $topicposts += 1;
        }

        $pollq = $SQL->query("SELECT `id` FROM `".$database['prefix']."polls` WHERE `tid` = '$tid'");
        $poll = $SQL->fetch_array($deletepollq);
        if ($poll['id'] != "") {
            $deletepoll = $SQL->query("DELETE FROM `".$database['prefix']."polls` WHERE `id` = '".$poll['id']."' LIMIT 1");
            $deletepollvotes = $SQL->query("DELETE FROM `".$database['prefix']."pollvotes` WHERE `pollid` = '".$poll['id']."'");
            $deletepolloptions = $SQL->query("DELETE FROM `".$database['prefix']."polloptions` WHERE `pollid` = '".$poll['id']."'");
        }

        if($forum['disablepc'] != 1){
            $lowerforumposts = $SQL->query("UPDATE `".$database['prefix']."forums` SET `posts`=posts - $topicposts, `topics`=topics - 1 WHERE `id` = '".$topic['fid']."'");
        }

        $lasttopicq = $SQL->query("SELECT `lptopicid` FROM `".$database['prefix']."forums` WHERE `id` = '".$topic['fid']."' ORDER BY `lpdate` LIMIT 1");
        $lasttopic = $SQL->fetch_array($lasttopicq);
        $deletetopic = $SQL->query("DELETE FROM `".$database['prefix']."topics` WHERE `id` = '$tid' LIMIT 1");
        if ($tid == $lasttopic['lptopicid']) {
            $firsttopicq = $SQL->query("SELECT `id`, `title`, `lpdate`, `lpuserid`, `lpusername` FROM `".$database['prefix']."topics` WHERE `fid` = '".$topic['fid']."' ORDER BY `lpdate` DESC LIMIT 1");
            $firstt = $SQL->fetch_array($firsttopicq);

            if($firstt['id'] != ""){
                $updatelpforum = $SQL->query("UPDATE `".$database['prefix']."forums` SET `lpdate` = '".$firstt['lpdate']."', `lptopicid` = '".$firstt['id']."', `lptopicname` = '".$firstt['title']."', `lpuserid` = '".$firstt['lpuserid']."', `lpusername` = '".$firstt['lpusername']."' WHERE `id` = '".$topic['fid']."'");
            } else {
                $updatelpforum = $SQL->query("UPDATE `".$database['prefix']."forums` SET `lpdate` = NULL, `lptopicid` = NULL, `lptopicname` = NULL, `lpuserid` = NULL, `lpusername` = NULL WHERE `id` = '".$topic['fid']."'");
            }
        }

        if($forum['class'] == "subforum" && $forum['updateparent'] == 1){
            $parentq = $SQL->query("SELECT * FROM `".$database['prefix']."forums` WHERE `id` = '".$forum['parent']."'");
            $parent = $SQL->fetch_array($parentq);

            if($forum['disablepc'] != 1){
                $lowerforumposts = $SQL->query("UPDATE `".$database['prefix']."forums` SET `posts`=posts - $topicposts, `topics`=topics - 1 WHERE `id` = '".$parent['id']."'");
            }

            $ids = "";
            $idq = $SQL->query("SELECT `id`,`class`,`updateparent` FROM `".$database['prefix']."forums` WHERE `parent` = '".$parent['id']."' OR `id` = '".$parent['id']."'");
            while($id = $SQL->fetch_array($idq)){
                if($id['class'] == "forum" || $id['updateparent'] == 1){
                    $ids .= $id['id'].",";
                }
            }
            $ids = substr($ids, 0, -1);
            $ids = str_replace(',', "','", $ids);

            $lasttopicq = $SQL->query("SELECT `lptopicid` FROM `".$database['prefix']."forums` WHERE `id` = '".$parent['id']."' ORDER BY `lpdate` LIMIT 1");
            $lasttopic = $SQL->fetch_array($lasttopicq);
            if ($tid == $lasttopic['lptopicid']) {
                $firsttopicq = $SQL->query("SELECT `id`, `title`, `lpdate`, `lpuserid`, `lpusername` FROM `".$database['prefix']."topics` WHERE (`fid` IN('$ids')) ORDER BY `lpdate` DESC LIMIT 1");
                $firstt = $SQL->fetch_array($firsttopicq);

                if($firstt['id'] != ""){
                    $updatelpforum = $SQL->query("UPDATE `".$database['prefix']."forums` SET `lpdate` = '".$firstt['lpdate']."', `lptopicid` = '".$firstt['id']."', `lptopicname` = '".$firstt['title']."', `lpuserid` = '".$firstt['lpuserid']."', `lpusername` = '".$firstt['lpusername']."' WHERE `id` = '".$parent['id']."'");
                } else {
                    $updatelpforum = $SQL->query("UPDATE `".$database['prefix']."forums` SET `lpdate` = NULL, `lptopicid` = NULL, `lptopicname` = NULL, `lpuserid` = NULL, `lpusername` = NULL WHERE `id` = '".$parent['id']."'");
                }
            }
        }

        $killsubscriptions = $SQL->query("DELETE FROM `".$database['prefix']."subscriptions` WHERE `tid`='".$tid."'");
        $lowerpostBrelpies = $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `posts` = posts - $topicposts, `topics` = topics - 1");

        die_header("Location: ".$config['boardurl']."board.php?fid=".$topic['fid']);
    break;
    case 'deletepost': //delete post action
        $pid = prepValue($_GET['pid']);
        if ($pid == "" || !is_numeric($pid)) {
            bb_error("No post specified.");
        }
        $pid = round($pid);

        $topandforq = $SQL->query("SELECT p.id AS pid, p.tid, p.posterid, p.dateline, t.fid, t.id, t.replies FROM `".$database['prefix']."posts` AS p RIGHT JOIN `".$database['prefix']."topics` AS t ON(p.tid = t.id) WHERE p.id = '$pid'");
        $location = $SQL->fetch_array($topandforq);

        $fdata = $SQL->query("SELECT * FROM `".$database['prefix']."forums` WHERE `id` = '".$location['fid']."'");
        $forum = $SQL->fetch_array($fdata);

        $firstpostcheckq = $SQL->query("SELECT `dateline` FROM `".$database['prefix']."posts` WHERE `dateline`<'".$location['dateline']."' AND `tid`='".$location['tid']."'");
        $firstpostcheck = $SQL->num_rows($firstpostcheckq);

        //# Grabbing forum permissions
        $user->setForumPerms($location['fid']);

        if($location['replies'] < 1 || $firstpostcheck <= 0){
            die_header("Location: ".$config['boardurl']."mod.php?a=deletetopic&tid=".$location['tid']);
        }

        if(($user->getData('delete_own') != 1 && $user->getData('id') == $location['posterid']) || ($user->getData('delete_others') != 1 && $user->getData('id') != $location['posterid'])){
            bb_error("You do not have permission to delete this post.");
        }

        if($forum['disablepc'] != 1){
            $lowerpostcount = $SQL->query("UPDATE `".$database['prefix']."users` SET `posts`=posts - 1 WHERE `id` = '".$location['posterid']."'");
        }
        $lowerpostTreplies = $SQL->query("UPDATE `".$database['prefix']."topics` SET `replies`=replies - 1 WHERE `id` = '".$location['tid']."'");
        $lowerpostFreplies = $SQL->query("UPDATE `".$database['prefix']."forums` SET `posts`=posts - 1 WHERE `id` = '".$location['fid']."'");
        $lowerpostBrelpies = $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `posts` = posts - 1");

        $temp = 0;
        $checklpquery = $SQL->query("SELECT `id`,`posterid`,`postername`,`dateline` FROM `".$database['prefix']."posts` WHERE `tid` = '".$location['tid']."' ORDER BY `id` DESC LIMIT 2");
        while($lpinfo = $SQL->fetch_array($checklpquery)){
            if($temp == 0){
                $lastpost = $lpinfo;
            } else {
                $nexttolast = $lpinfo;
            }
            $temp++;
        }
        if($lastpost['id'] == $pid){
            $updatelpinfo = $SQL->query("UPDATE `".$database['prefix']."topics` SET `lpdate` = '".$nexttolast['dateline']."', `lpuserid` = '".$nexttolast['posterid']."', `lpusername` = '".$nexttolast['postername']."' WHERE `id` = '".$location['tid']."'");
            $queryforumlpinfo = $SQL->query("SELECT `lptopicid` FROM `".$database['prefix']."forums` WHERE `id` = '".$location['fid']."'");
            $forum = $SQL->fetch_array($queryforumlpinfo);
            if($forum['lptopicid'] == $location['tid']){
                $updatefrmlpinfo = $SQL->query("UPDATE `".$database['prefix']."forums` SET `lpdate` = '".$nexttolast['dateline']."', `lpuserid` = '".$nexttolast['posterid']."', `lpusername` = '".$nexttolast['postername']."' WHERE `id` = '".$location['fid']."'");
            }
        }

        $delete = $SQL->query("DELETE FROM `".$database['prefix']."posts` WHERE `id` = '$pid' LIMIT 1");

        die_header("Location: ".$config['boardurl']."read.php?tid=".$location['tid']);
    break;
    case 'locktopic': //Lock topic
        $tid = prepValue($_GET['tid']);
        if ($tid == "" || !is_numeric($tid)) {
            $tid = 1;
        }
        $tid = round($tid);

        $grabtopicdata = $SQL->query("SELECT `fid` FROM `".$database['prefix']."topics` WHERE `id` = '$tid'");
        $topic = $SQL->fetch_array($grabtopicdata);

        //# Grabbing forum permissions
        $user->setForumPerms($topic['fid']);

        if($user->getData('lock_topics') != 1){
            bb_error("You do not have permission to lock this topic.");
        }

        $lock = $SQL->query("UPDATE `".$database['prefix']."topics` SET `locked` = '1' WHERE `id` = '$tid'");
        die_header("Location: ".$config['boardurl']."read.php?tid=$tid");
    break;
    case 'unlocktopic': //Unlock topic
        $tid = prepValue($_GET['tid']);
        if ($tid == "" || !is_numeric($tid)) {
            $tid = 1;
        }
        $tid = round($tid);

        $grabtopicdata = $SQL->query("SELECT `fid` FROM `".$database['prefix']."topics` WHERE `id` = '$tid'");
        $topic = $SQL->fetch_array($grabtopicdata);

        //# Grabbing forum permissions
        $user->setForumPerms($topic['fid']);
        if($user->getData('lock_topics') != 1){
            bb_error("You do not have permission to unlock this topic.");
        }

        $unlock = $SQL->query("UPDATE `".$database['prefix']."topics` SET `locked` = '0' WHERE `id` = '$tid'");
        die_header("Location: ".$config['boardurl']."read.php?tid=$tid");
    break;
    case 'stickytopic': //Sticky topic
        $tid = prepValue($_GET['tid']);
        if ($tid == "" || !is_numeric($tid)) {
            $tid = 1;
        }
        $tid = round($tid);

        $grabtopicdata = $SQL->query("SELECT `fid` FROM `".$database['prefix']."topics` WHERE `id` = '$tid'");
        $topic = $SQL->fetch_array($grabtopicdata);

        //# Grabbing forum permissions
        $user->setForumPerms($topic['fid']);

        if($user->getData('stick_topics') != 1){
            bb_error("You do not have permission to sticky this topic.");
        }

        $sticky = $SQL->query("UPDATE `".$database['prefix']."topics` SET `sticky` = '1' WHERE `id` = '$tid'");
        die_header("Location: ".$config['boardurl']."read.php?tid=$tid");
    break;
    case 'unstickytopic': //Unsticky topic
        $tid = prepValue($_GET['tid']);
        if ($tid == "" || !is_numeric($tid)) {
            $tid = 1;
        }
        $tid = round($tid);

        $grabtopicdata = $SQL->query("SELECT `fid` FROM `".$database['prefix']."topics` WHERE `id` = '$tid'");
        $topic = $SQL->fetch_array($grabtopicdata);

        //# Grabbing forum permissions
        $user->setForumPerms($topic['fid']);

        if($user->getData('stick_topics') != 1){
            bb_error("You do not have permission to unsticky this topic.");
        }

        $unsticky = $SQL->query("UPDATE `".$database['prefix']."topics` SET `sticky` = '0' WHERE `id` = '$tid'");
        die_header("Location: ".$config['boardurl']."read.php?tid=$tid");
    break;
    default: //In case no action is specified...
        die_header("Location: ".$config['boardurl']."index.php");
    break;
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>