<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: search.php,v 1.7 2005/06/10 02:02:07 mokkan Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "search");

//# Templates:
$bb_templates = '1,12,60,67,71,72,73,74';
require("core.php");

$breadcrumbs .= $template->getVar('crumbsseperator') . "Forum Search";

$action = prepValue($_GET['a']);
if($action == "search"){
    $page = prepValue($_GET['page']);
    if ($page == "" || !is_numeric($page)) {
        $page = 1;
    }
    $page = round($page);
    $start = ($page * prepValue($_GET['limit'])) - prepValue($_GET['limit']);

    //# Turning $_GET values into easier-to-use vars
    $orderby = prepValue($_GET['orderby']);
    $sort = prepValue($_GET['sort']);
    $limit = prepValue($_GET['limit']);
    $gettime = prepValue($_GET['time']);
    $text = prepValue(urldecode($_GET['text']));
    $getusername = prepValue(urldecode($_GET['username']));
    $match = prepValue($_GET['match']);
    $messages = prepValue($_GET['messages']);
    $getfid = prepValue($_GET['fid']);
    $submit = prepValue($_GET['submit']);
    
    //# Setting forum permissions
    if($getfid != ""){
        $user->setForumPerms($getfid);
    }

    if($orderby == "" || $sort == "" || $limit == "" || $gettime == "" || ($text == "" && $getusername == "") || $getfid == "" || ($messages == "" && $subjects == "") || $match == "" || $user->getData('view_forum') != 1){
        bb_error("You either did not fill in all the required fields or you do not have permission to view this forum.");
    }

    if($gettime == "all"){
        $time = 0;
    }else{
        $time = time() - $gettime;
    }
    if($getfid == "all"){
        $fid = "(p.tid=t.id AND t.fid=f.id)";
    }else{
        $fid = "(p.tid=t.id AND t.fid=f.id AND (f.id=".$getfid." OR f.parent=".$getfid."))";
    }
    if($getusername != ""){
        $username = "AND p.postername LIKE '%".$getusername."%'";
    }
    if($text != ""){
        $goodtext = trim($text);
        $goodtext = preg_replace("/\ +/", " ", $goodtext);

        $message = trim($text);
        if($match == "all"){
            $message = preg_replace("/\ +/", "%", $message);
            if($messages == "on" && $subjects != "on"){
                $message = "p.message LIKE '%".$message."%'";
            }else if($messages == "on" && $subjects == "on"){
                $message = "p.message LIKE '%".$message."%' OR p.title LIKE '%".$message."%'";
            }else{
                $message = "p.title LIKE '%".$message."%'";
            }
        }else{
            $message = preg_replace("/\ +/", " ", $message);
            $words = explode(" ", $message);
            $message = "";

            for($i=0; $i<count($words); $i++){
                if($i != 0){
                    $message .= " OR ";
                }

                if($messages == "on" && $subjects != "on"){
                    $message .= "p.message LIKE '%".$words[$i]."%'";
                }else if($messages == "on" && $subjects == "on"){
                    $message .= "p.message LIKE '%".$words[$i]."%' OR p.title LIKE '%".$words[$i]."%' OR t.title LIKE '%".$words[$i]."%'";
                }else if($messages != "on" && $subjects == "on"){
                    $message .= "p.title LIKE '%".$words[$i]."%' OR t.title LIKE '%".$words[$i]."%'";
                }
            }
        }
        $message = "AND ($message)";
    }

    $searchq = $SQL->query("SELECT p.id AS pid, p.posterid, p.postername, p.title AS subject,
                            p.message, p.dateline, u.gid AS postergid, g.style AS posterstyle,
                            t.id AS tid, t.title AS topictitle, t.authorid AS tposterid, t.authorname AS tpostername,
                            f.id AS fid, f.class, f.parent, a.view_topic, a.view_forum
                            FROM `".$database['prefix']."posts` AS p
                            LEFT JOIN `".$database['prefix']."users` AS u ON (u.id = p.posterid)
                            LEFT JOIN `".$database['prefix']."usergroups` AS g ON (g.id = u.gid)
                            LEFT JOIN `".$database['prefix']."topics` AS t ON(p.tid=t.id)
                            LEFT JOIN `".$database['prefix']."forums` AS f ON(t.fid=f.id)
                            LEFT JOIN `".$database['prefix']."permissions` AS a ON(a.fid=f.id AND a.gid='".$user->getData('gid')."')
                            WHERE $fid AND p.dateline>'$time' $message $username ORDER BY $orderby $sort LIMIT $start, $limit");
    while($search = $SQL->fetch_array($searchq)){
        if(($search['view_forum'] == 1 || $search['view_forum'] == "") && ($search['view_topic'] == 1 || $search['view_topic'] == "")){
            $results .= stripslashes($template->templates['74']);

            $search['time'] = gmdate($template->getVar('postdateformat'), $search['dateline'] + ($user->getData('offset') * 3600));
            $search['message'] = stripslashes($search['message']);
            if($user->getData('censor') == 1){
                $search['message'] = censor($search['message']);
            }
            $search['message'] = parse_breaks($search['message']);

            if($search['subject'] == ""){
                $search['subject'] = $search['topictitle'];
            }
            if($messages == "on" && $goodtext != ""){
                $words = explode(" ", $goodtext);
                $reppre = str_replace(" ", "[/s]|[s]", $goodtext);
                $reppre = "[s]".$reppre."[/s]";
                $replace = explode("|", $reppre);

                $search['message'] = str_replace($words, $replace, $search['message']);
                $search['message'] = str_replace("[s]", "<span class=\"cellhead2\">", $search['message']);
                $search['message'] = str_replace("[/s]", "</span>", $search['message']);
            }
            if($subjects == "on" && $goodtext != ""){
                $words = explode(" ", $goodtext);
                $reppre = str_replace(" ", "[/s]|[s]", $goodtext);
                $reppre = "[s]".$reppre."[/s]";
                $replace = explode("|", $reppre);

                $search['subject'] = str_replace($words, $replace, $search['subject']);
                $search['subject'] = str_replace("[s]", "<span class=\"cellhead2\">", $search['subject']);
                $search['subject'] = str_replace("[/s]", "</span>", $search['subject']);
            }
            $results = $template->cacheArray($results, $search);
        }
    }
    $search = $template->releaseCache();
    eval("\$results = \"".addslashes($results)."\";");

    //counts results
    $lastq = $SQL->query("SELECT p.id AS pid, p.posterid, p.postername, p.title AS subject, p.message, p.dateline, t.id AS tid, t.authorid AS tposterid, t.authorname AS tpostername, t.title AS topictitle, f.id AS fid, f.class, f.parent, a.view_topic, a.view_forum FROM `".$database['prefix']."posts` AS p LEFT JOIN `".$database['prefix']."topics` AS t ON(p.tid=t.id) LEFT JOIN `".$database['prefix']."forums` AS f ON(t.fid=f.id) LEFT JOIN `".$database['prefix']."permissions` AS a ON(a.fid=f.id AND a.gid='".$user->getData('gid')."') WHERE $fid AND p.dateline>'$time' $message $username ORDER BY $orderby $sort");

    //set some informative vars
    $totalresults = $SQL->num_rows($lastq);
    $from = ceil(($page - 1) * $limit) + 1;
    $to = $from + $limit - 1;

    if ($totalresults <= 0) {
        $lastpage = 1;
    } else {
        $lastpage = ceil($totalresults / $limit);
    }
    if ($page > $lastpage) {
        die_header("Location: ".$config['boardurl']."search.php?orderby=$orderby&sort=$sort&limit=$limit&time=$gettime&text=$text&username=$getusername&fid=$getfid&messages=$messages&match=$match&a=search&page=$lastpage");
    }
    if ($page < 1) {
        die_header("Location: ".$config['boardurl']."search.php?orderby=$orderby&sort=$sort&limit=$limit&time=$gettime&text=$text&username=$getusername&fid=$getfid&messages=$messages&match=$match&a=search&page=1");
    }
    $pagevars = array();
    $pagevars['totalpages'] = $lastpage;
    if($page == $pagevars['totalpages']){
        $to = $totalresults;
    }
    $pagevars['first'] = "";
    $pagevars['middle'] = "";
    $pagevars['last'] = "";
    if(($page - 3) >= 2){
        $pagevars['first'] = "<a href=\"search.php?orderby=$orderby&sort=$sort&limit=$limit&time=$gettime&text=$text&username=$getusername&fid=$getfid&messages=$messages&match=$match&a=search&page=1\">".$template->getVar('firstpagetext')."</a> ... ";
        for($i = $page - 3; $i < $page; $i++){
            $pagevars['middle'] .= "<a href=\"search.php?orderby=$orderby&sort=$sort&limit=$limit&time=$gettime&text=$text&username=$getusername&fid=$getfid&messages=$messages&match=$match&a=search&page=$i\">$i</a>, ";
        }
    } else {
        for($i = 1; $i < $page; $i++){
            $pagevars['middle'] .= "<a href=\"search.php?orderby=$orderby&sort=$sort&limit=$limit&time=$gettime&text=$text&username=$getusername&fid=$getfid&messages=$messages&match=$match&a=search&page=$i\">$i</a>, ";
        }
    }
    $pagevars['middle'] .= $page;
    if(($page + 3) < $pagevars['totalpages']){
        $pagevars['last'] = " ... <a href=\"search.php?orderby=$orderby&sort=$sort&limit=$limit&time=$gettime&text=$text&username=$getusername&fid=$getfid&messages=$messages&match=$match&a=search&page=$pagevars[totalpages]\">".$template->getVar('lastpagetext')."</a>";
        for($i = $page + 1; $i < $page + 4; $i++){
            $pagevars['middle'] .= " ,<a href=\"search.php?orderby=$orderby&sort=$sort&limit=$limit&time=$gettime&text=$text&username=$getusername&fid=$getfid&messages=$messages&match=$match&a=search&page=$i\">$i</a>";
        }
    } else {
        for($i = $page + 1; $i <= $pagevars['totalpages']; $i++){
            $pagevars['middle'] .= " ,<a href=\"search.php?orderby=$orderby&sort=$sort&limit=$limit&time=$gettime&text=$text&username=$getusername&fid=$getfid&messages=$messages&match=$match&a=search&page=$i\">$i</a>";
        }
    }
    $choosepage = $pagevars['first'] . $pagevars['middle'] . $pagevars['last'];
    if($pagevars['totalpages'] < 2){
        $choosepage = "";
    }

    if($SQL->num_rows($searchq) <= 0){
        $breadcrumbs = "<a href=\"$config[boardurl]\">$config[boardname]</a>" . $template->getVar('crumbsseperator') . "Search";
        $cellhead = "<center>Search Results</center>";
        $cellmessage = "Your search did not turn up any results.<br><a href=\"#\" onClick=\"history.go(-1);return true;\">Back</a>";
        eval("\$include = \"".$template->templates['12']."\";");
    }else{
        eval("\$include = \"".$template->templates['73']."\";");
    }
    $user->updateActive("Viewing search results.");
}else{
    $latestcid = "";
    $latestfid = "";
    $optq = $SQL->query("SELECT c.id AS cid, c.name AS cname, c.class AS cclass, f.id AS fid, f.name AS fname, f.class AS fclass, s.id AS sid, s.name AS sname, s.class AS sclass, fp.view_forum AS viewforum, sp.view_forum AS viewsubforum FROM `".$database['prefix']."forums` AS c LEFT JOIN `".$database['prefix']."forums` AS f ON(f.parent = c.id AND f.class = 'forum') LEFT JOIN `".$database['prefix']."forums` AS s ON(s.parent = f.id AND s.class = 'subforum') LEFT JOIN `".$database['prefix']."permissions` AS fp ON(fp.fid = f.id AND fp.gid = '".$user->getData('gid')."') LEFT JOIN `".$database['prefix']."permissions` AS sp ON(sp.fid = s.id AND sp.gid = '".$user->getData('gid')."') WHERE c.class = 'category' ORDER BY c.order,f.order,f.id,s.order,s.id");
    while($grab = $SQL->fetch_array($optq)){
        if($grab['cid'] != $latestcid && $grab['cid'] != ""){
            $options .= $template->templates['72'];
            $options = stripslashes($options);
            $option['name'] = $grab['cname'];
            $option['disabled'] = "disabled";
            $options = $template->cacheArray($options, $option);
            $latestcid = $grab['cid'];
            $option['disabled'] = "";
        }
        if (($grab['fid'] != $latestfid) && ($grab['viewforum'] == "" || $grab['viewforum'] == "1") && $grab['fid'] != "") {
            $options .= $template->templates['72'];
            $options = stripslashes($options);
            $option['fid'] = $grab['fid'];
            $option['name'] = "&nbsp;&nbsp;&nbsp;".$grab['fname'];
            $latestfid = $grab['fid'];
            $options = $template->cacheArray($options, $option);
        }
        if (($grab['sid'] != "") && ($grab['viewforum'] == "" || $grab['viewforum'] == "1") && ($grab['viewsubforum'] == "" || $grab['viewsubforum'] == "1")) {
            $options .= $template->templates['72'];
            $options = stripslashes($options);
            $option['fid'] = $grab['sid'];
            $option['name'] = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".$grab['sname'];
            $latestfid = $grab['fid'];
            $options = $template->cacheArray($options, $option);
        }
    }
    $option = $template->releaseCache();
    eval("\$options = \"".addslashes($options)."\";");
    eval("\$include = \"".$template->templates['71']."\";");
    $user->updateActive("Viewing search.");
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>