<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: usercp.php,v 1.17 2005/07/06 18:32:13 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "usercp");

//# Templates:
$bb_templates = '1,12,25,37,38,39,40,49,50,51,52,54,55,56,58,59,60,61,62,75,78,81,82,83,84';
require("core.php");

//# If user isn't logged in, they can't access the UserCP
if($user->getData('id') == 0){
    bb_error("You aren't allowed to access the UserCP.");
}

//# Setting breadcrumbs
$breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"usercp.php\">UserCP</a>";

//# CP Message
if($_GET['msg'] != ""){
    $msg = str_replace("+", " ", $_GET['msg']);
    $msg = prepValue($msg);
    eval("\$cp_message = \"".$template->templates['75']."\";");
}

//# Switchboard
switch(prepValue($_GET['a'])){
    case '':
        //# Updating active table
        $user->updateActive("Viewing UserCP");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Main";

        $query = $SQL->query("SELECT `email`,`posts`,`joindate` FROM `".$database['prefix']."users` WHERE `id` = '".$user->getData('id')."'");
        $summary = $SQL->fetch_array($query);
        $summary['postsperday'] = (!empty($summary['posts']) && $summary['posts'] != "0") ? round($summary['posts'] / ceil((time() - $summary['joindate']) / 60 / 60 / 24), 2) : "0.00";
        $summary['joined'] = gmdate($template->getVar('joindateformat'), $summary['joindate']+(3600 * $user->getData('offset')));
        eval("\$cpinclude = \"".$template->templates['39']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'editprofile':
        //# Updating active table
        $user->updateActive("Editing Profile");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Profile";

        $query = $SQL->query("SELECT * FROM `".$database['prefix']."users` WHERE `id` = '".$user->getData('id')."'");
        $profile = $SQL->fetch_array($query);
        $day[$profile['bday']] = "selected";
        $month[$profile['bmonth']] = "selected";
        eval("\$cpinclude = \"".$template->templates['38']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'updateprofile':
        $query = $SQL->query("UPDATE `".$database['prefix']."users` SET `title` = '".prepValue($_POST['title'])."', `bday` = '".prepValue($_POST['day'])."', `bmonth` = '".prepValue($_POST['month'])."', `byear` = '".prepValue($_POST['year'])."', `occupation` = '".prepValue($_POST['occupation'])."',
                                               `location` = '".prepValue($_POST['location'])."', `interests` = '".prepValue($_POST['interests'])."', `pageurl` = '".prepValue($_POST['siteurl'])."', `pagename` = '".prepValue($_POST['sitename'])."', `aim` = '".prepValue($_POST['aim'])."',
                                               `icq` = '".prepValue($_POST['icq'])."', `msn` = '".prepValue($_POST['msn'])."', `yim` = '".prepValue($_POST['yim'])."' WHERE `id` = '".$user->getData('id')."'");
        die_header("Location: ".$config['boardurl']."usercp.php?a=editprofile&msg=Your+profile+was+successfully+updated.");
    break;
    case 'editsignature':
        //# Updating active table
        $user->updateActive("Editing Signature");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Signature";

        $query = $SQL->query("SELECT `signature` FROM `".$database['prefix']."users` WHERE `id` = '".$user->getData('id')."'");
        $signature = $SQL->fetch_array($query);
        $signature['signature'] = addslashes($signature['signature']);
        if($user->getData('censor') == 1){
            $signature['signature'] = censor($signature['signature']);
        }
        $signature['current'] = addslashes(addslashes($signature['signature']));
        $signature['current'] = parse_breaks($signature['current']);
        $signature['current'] = parse_bbcode($signature['current']);
        $signature['current'] = stripslashes(stripslashes($signature['current']));

        $signature['value'] = $signature['signature'];
        eval("\$cpinclude = \"".$template->templates['40']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'updatesignature':
        $query = $SQL->query("UPDATE `".$database['prefix']."users` SET `signature` = '".prepValue($_POST['signature'])."' WHERE `id` = '".$user->getData('id')."'");
        die_header("Location: ".$config['boardurl']."usercp.php?a=editsignature&msg=Your+signature+was+successfully+updated.");
    break;
    case 'editavatar':
        //# Updating active table
        $user->updateActive("Editing Avatar");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Avatar";

        $avararq = $SQL->query("SELECT `avatar` FROM `".$database['prefix']."users` WHERE `id` = '".$user->getData('id')."'");
        $avatar = $SQL->fetch_array($avararq);

        $avrules['kilobytes'] = filesize_format($config['avatarbytes']);
        $extensions = explode(",",$config['avatarextensions']);
        $extnum = count($extensions);
        for ($loop = 0; $loop < $extnum; $loop ++) {
            $extensions[$loop] = substr($extensions[$loop],1);
            $avrules['extensions'] .= "<b>" . $extensions[$loop] . "</b>";
            if (($loop + 1) != $extnum) {
                $avrules['extensions'] .= ", ";
            }
            if (($loop + 2) == $extnum) {
                $avrules['extensions'] .= "and ";
            }
        }

        if(file_exists($config[avatarpath] . $avatar['avatar'])){
            $avatar['avatar'] = $config[avatarpath] . $avatar['avatar'];
        }

        eval("\$cpinclude = \"".$template->templates['49']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'updateavatar':
        if ($_POST['url'] != "" && $_FILES['file']['name'] != "") {
            bb_error("You can only upload or link to a file. You cannot do both.");
        }
        if ($_POST['url'] == "" && $_FILES['file']['name'] == "") {
            bb_error("You must either upload or link to a file.");
        }

        if ($_FILES['file']['name'] != "") {
            if ($_FILES['file']['size'] > $config['avatarbytes']) {
                bb_error("The file is to large, the maximum size is <b>".filesize_format($config['avatarbytes'])."</b>.");
            }
            $ext = strtolower(substr($_FILES['file']['name'], strrpos($_FILES['file']['name'], ".")));
            $allowedexts = explode(',', $config['uploadext']);
            $allowed = 0;
            foreach($allowedexts as $exts){
                if ($ext == $exts) {
                    $allowed = 1;
                }
            }
            if ($allowed != 1) {
                bb_error("The extension is not allowed.");
            }

            $path = str_replace("usercp.php", $config['avatarpath'], $_SERVER['SCRIPT_FILENAME']);
            $avatar = $path . $user->getData('id') . $ext;
            $file = $user->getData('id') . $ext;
            if (!move_uploaded_file($_FILES['file']['tmp_name'], $avatar)) {
                bb_error("There was an unexpected error. Please try again or contact the admin.");
            }
            list($width, $height) = getimagesize($file);
            if ($width > $config['avatarwidth'] || $height > $config['avatarheight']) {
                unlink($file);
                bb_error("The dimensions of the image are too large.");
            }
            $existcheck = explode(",",$config['avatarextensions']);
            foreach($existcheck as $exts) {
                if ($exts != $ext) {
                    if (is_file($config['avatarpath'] . $user->getData('id') . $exts)) {
                        unlink($config['avatarpath'] . $user->getData('id') . $exts);
                    }
                }
            }
            $SQL->query("UPDATE `".$database['prefix']."users` SET `avatar`='".$user->getData('id').$ext."' WHERE `id`='".$user->getData('id')."'");
       } else {
            $avatar = prepValue($_POST['url']);

            $ext = substr($avatar, strrpos($avatar, "."));
            $allowedexts = explode(',', $config['uploadext']);
            $allowed = 0;
            foreach($allowedexts as $exts){
                if ($ext == $exts) {
                    $allowed = 1;
                }
            }
            if ($allowed != 1) {
                bb_error("The extension is not allowed.");
            }
            list($width, $height) = getimagesize($avatar);
            if ($width > $config['avatarwidth'] || $height > $config['avatarheight']) {
                bb_error("The dimensions of the image are too large.");
            }
            $existcheck = explode(",",$config['avatarextensions']);
            foreach($existcheck as $exts) {
                if (is_file($config['avatarpath'] . $user->getData('id') . $exts)) {
                    unlink($config['avatarpath'] . $user->getData('id') . $exts);
                }
            }
            $SQL->query("UPDATE `".$database['prefix']."users` SET `avatar`='$avatar' WHERE `id`='".$user->getData('id')."'");
        }

        die_header("Location: ".$config['boardurl']."usercp.php?a=editavatar&msg=Your+avatar+was+successfully+updated.");
    break;
    case 'deleteavatar':
        $SQL->query("UPDATE `".$database['prefix']."users` SET `avatar`='' WHERE `id`='".$user->getData('id')."'");

        die_header("Location: ".$config['boardurl']."usercp.php?a=editavatar&msg=Your+avatar+was+successfully+deleted.");
    break;
    case 'boardsettings':
        //# Updating active table
        $user->updateActive("Editing Board Settings");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Board Settings";

        $query = $SQL->query("SELECT * FROM `".$database['prefix']."users` WHERE `id` = '".$user->getData('id')."'");
        $settings = $SQL->fetch_array($query);

        $settings['currenttime'] = gmdate("g:ia", time() + ($user->getData('offset') * 3600));
        $settings['offset'] = "n" . $settings['offset'];
        $settings['offset'] = str_replace("-", "minus", $settings['offset']);
        $settings['offset'] = str_replace(".", "point", $settings['offset']);
        $offset[$settings['offset']] = $template->getVar('bsselected');
        $parseurls[$settings['parseurls']] = $template->getVar('bsselected');
        $viewsiggies[$settings['viewsiggies']] = $template->getVar('bsselected');
        $viewavatars[$settings['viewavatars']] = $template->getVar('bsselected');
        $viewhistory[$settings['viewhistory']] = $template->getVar('bsselected');
        $subscribe[$settings['subscribe']] = $template->getVar('bsselected');
        $emailifpm[$settings['emailifpm']] = $template->getVar('bsselected');
        $notificationifpm[$settings['notificationifpm']] = $template->getVar('bsselected');
        $hideemail[$settings['hideemail']] = $template->getVar('bsselected');
        $censor[$settings['censor']] = $template->getVar('bsselected');
        $disableemoticons[$settings['disableemoticons']] = $template->getVar('bsselected');

        $skinquery = $SQL->query("SELECT * FROM `".$database['prefix']."skins`");
        while($skin = $SQL->fetch_array($skinquery)){
            $skinopts .= stripslashes($template->templates['81']);

            if($skin['id'] == $settings['skin']){
                $skin['selected'] = "selected";
            }

            $skinopts = $template->cacheArray($skinopts, $skin);
        }
        $skin = $template->releaseCache();
        eval("\$skinopts = \"".addslashes($skinopts)."\";");
        eval("\$cpinclude = \"".addslashes($template->templates['50'])."\";"); // dunno why i needed to do this either
        $cpinclude = stripslashes($cpinclude); // dunno why i need to do this...
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'updateboardsettings':
        if($_POST['postsperpage'] < 1){
            bb_error("Must have at least 1 post per page.");
        }
        if($_POST['topicsperpage'] < 1){
            bb_error("Must have at least 1 topic per page.");
        }
        if($_POST['membersperpage'] < 1){
            bb_error("Must have at least 1 member per page.");
        }
        $query = $SQL->query("UPDATE `".$database['prefix']."users` SET
                                              `skin` = '".prepValue($_POST['skin'])."', `offset` = '".prepValue($_POST['offset'])."',
                                              `parseurls` = '".prepValue($_POST['parseurls'])."', `viewsiggies` = '".prepValue($_POST['viewsiggies'])."',
                                              `viewavatars` = '".prepValue($_POST['viewavatars'])."', `viewhistory` = '".prepValue($_POST['viewhistory'])."',
                                              `subscribe` = '".prepValue($_POST['subscribe'])."', `emailifpm` = '".prepValue($_POST['emailifpm'])."',
                                              `notificationifpm` = '".prepValue($_POST['notificationifpm'])."', `hideemail` = '".prepValue($_POST['hideemail'])."',
                                              `censor` = '".prepValue($_POST['censor'])."', `disableemoticons` = '".prepValue($_POST['disableemoticons'])."',
                                              `postsperpage` = '".prepValue($_POST['postsperpage'])."', `topicsperpage` = '".prepValue($_POST['topicsperpage'])."',
                                              `membersperpage` = '".prepValue($_POST['membersperpage'])."'
                                              WHERE `id` = '".$user->getData('id')."'");

        die_header("Location: ".$config['boardurl']."usercp.php?a=boardsettings&msg=Your+board+settings+were+successfully+updated.");
    break;
    case 'editpass':
        //# Updating active table
        $user->updateActive("Editing Password");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Password";

        eval("\$cpinclude = \"".$template->templates['51']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'upadatepass':
        if ($_POST['newpass'] == "") {
            bb_error("You must input a password.");
        }
        $_POST['newpass'] = md5($_POST['newpass']);
        $_POST['newpassconfirm'] = md5($_POST['newpassconfirm']);
        if ($_POST['newpass'] != $_POST['newpassconfirm']) {
            bb_error("Password entries did not match.");
        }
        $SQL->query("UPDATE `".$database['prefix']."users` SET `password` = '".$_POST['newpass']."' WHERE `id` = '".$user->getData('id')."'");
        setcookie($config['ckprefix']."user", $user->getData('id')."&&".$_POST['newpass'], time() + 31536000, $config['cookiepath'], $config['cookiedomain']);

        die_header("Location: ".$config['boardurl']."usercp.php?a=editpass&msg=Your+password+was+successfully+changed.");
    break;
    case 'editemail':
        //# Updating active table
        $user->updateActive("Editing E-mail Address");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit E-mail Address";

        $query = $SQL->query("SELECT `email` FROM `".$database['prefix']."users` WHERE `id` = '".$user->getData('id')."'");
        $email = $SQL->fetch_array($query);

        eval("\$cpinclude = \"".$template->templates['52']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'updateemail':
        if ($_POST['email'] == "") {
            bb_error("You must input an e-mail address.");
        }
        if (!preg_match("/^[a-zA-Z0-9\_\-\.]+\@[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,4}$/i",$_POST['email'])) {
            bb_error("E-mail address is invalid.");
        }
        if ($_POST['email'] != $_POST['emailconfirm']) {
            bb_error("E-mail address entries did not match.");
        }

        $SQL->query("UPDATE `".$database['prefix']."users` SET `email` = '".$_POST['email']."' WHERE `id` = '".$user->getData('id')."'");

        die_header("Location: ".$config['boardurl']."usercp.php?a=editemail&msg=Your+email+address+was+successfully+changed.");
    break;
    case 'inbox':
        //# Updating active table
        $user->updateActive("Viewing Inbox");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Inbox";

        $pmq = $SQL->query("SELECT pm.*, u.gid, g.style
                            FROM `".$database['prefix']."pmessages` AS pm
                            LEFT JOIN `".$database['prefix']."users` AS u ON (u.id = pm.fromid)
                            LEFT JOIN `".$database['prefix']."usergroups` AS g ON (g.id = u.gid)
                            WHERE pm.toid = '".$user->getData('id')."' AND pm.status = 'inbox' ORDER BY pm.id DESC");
        $messages = $SQL->num_rows($pmq);
        if ($messages <= 0) {
            eval("\$pmessages = \"".$template->templates['55']."\";");
        } else {
            $checks = 0;
            while($pm = $SQL->fetch_array($pmq)) {
                $pmessages .= stripslashes($template->templates['56']);
                $pm['subject'] = stripslashes($pm['subject']);
                if ($pm['read'] == "0") {
                    $pm['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconon');
                } else {
                    $pm['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconoff');
                }
                $checks++;
                $pmessages = $template->cacheArray($pmessages, $pm);
            }
            $pm = $template->releaseCache();
            eval("\$pmessages = \"".addslashes($pmessages)."\";");
        }

        eval("\$cpinclude = \"".$template->templates['54']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'saved':
        //# Updating active table
        $user->updateActive("viewing saved PM's");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Saved PM's";

        $pmq = $SQL->query("SELECT pm.*, u.gid, g.style
                            FROM `".$database['prefix']."pmessages` AS pm
                            LEFT JOIN `".$database['prefix']."users` AS u ON (u.id = pm.fromid)
                            LEFT JOIN `".$database['prefix']."usergroups` AS g ON (g.id = u.gid)
                            WHERE pm.toid = '".$user->getData('id')."' AND pm.status = 'saved' ORDER BY pm.id DESC");
        $messages = $SQL->num_rows($pmq);
        if ($messages <= 0) {
           eval("\$pmessages = \"".$template->templates['55']."\";");
        } else {
            $checks = 0;
            while($pm = $SQL->fetch_array($pmq)) {
                $pmessages .= stripslashes($template->templates['56']);
                $pm['subject'] = stripslashes($pm['subject']);
                if ($pm['read'] == "0") {
                    $pm['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconon');
                } else {
                    $pm['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconoff');
                }
                $checks++;
                $pmessages = $template->cacheArray($pmessages, $pm);
            }
            $pm = $template->releaseCache();
            eval("\$pmessages = \"".addslashes($pmessages)."\";");
        }

        eval("\$cpinclude = \"".$template->templates['62']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'sent':
        //# Updating active table
        $user->updateActive("viewing sent PM's");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Sent PM's";

        $pmq = $SQL->query("SELECT pm.*, u.gid, g.style
                            FROM `".$database['prefix']."pmessages` AS pm
                            LEFT JOIN `".$database['prefix']."users` AS u ON (u.id = pm.fromid)
                            LEFT JOIN `".$database['prefix']."usergroups` AS g ON (g.id = u.gid)
                            WHERE pm.fromid = '".$user->getdata('id')."' AND pm.status = 'sent' ORDER BY pm.id DESC");
        $messages = $SQL->num_rows($pmq);
        if ($messages <= 0) {
           eval("\$pmessages = \"".$template->templates['55']."\";");
        } else {
            $checks = 0;
            while($pm = $SQL->fetch_array($pmq)) {
                $pmessages .= stripslashes($template->templates['56']);
                $pm['subject'] = stripslashes($pm['subject']);
                if ($pm['read'] == "0") {
                    $pm['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconon');
                } else {
                    $pm['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconoff');
                }
                $checks++;
                $pmessages = $template->cacheArray($pmessages, $pm);
            }
            $pm = $template->releaseCache();
            eval("\$pmessages = \"".addslashes($pmessages)."\";");
        }

        eval("\$cpinclude = \"".$template->templates['62']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'readpm':
        //# Updating active table
        $user->updateActive("Reading a PM");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Reading PM";

        $pmid = prepValue($_GET['id']);
        if (!is_numeric($pmid) || $pmid == "") {
            $pmid = 1;
        }
        $pmid = round($pmid);
        $pmq = $SQL->query("SELECT pm.*, fu.gid AS fromgid, fg.style AS fromstyle, tu.gid AS togid, tg.style AS tostyle
                            FROM `".$database['prefix']."pmessages` AS pm
                            LEFT JOIN `".$database['prefix']."users` AS fu ON (fu.id = pm.fromid)
                            LEFT JOIN `".$database['prefix']."usergroups` AS fg ON (fg.id = fu.gid)
                            LEFT JOIN `".$database['prefix']."users` AS tu ON (tu.id = pm.toid)
                            LEFT JOIN `".$database['prefix']."usergroups` AS tg ON (tg.id = tu.gid)
                            WHERE (pm.fromid = '".$user->getData('id')."' OR pm.toid = '".$user->getData('id')."')  AND pm.id='$pmid'");

        $exist = $SQL->num_rows($pmq);

        if ($exist >= 1) {
            $pm = $SQL->fetch_array($pmq);

            if ($pm['read'] == "0") {
                $SQL->query("UPDATE `".$database['prefix']."pmessages` SET `read`='1' WHERE `id`='$pmid'");
            }

            $pm['subject'] = stripslashes($pm['subject']);
            $pm['message'] = stripslashes($pm['message']);
            $pm['senddate'] = gmdate($template->getVar('pmdateformat'), $pm['senddate'] + ($user->getData('offset') * 3600));

            //censoring words
            if($user->getData('censor') == 1){
                $pm['message'] = censor($pm['message']);
            }
            //calling the function to parse bbcode
            $pm['message'] = parse_breaks($pm['message']);
            $pm['message'] = parse_bbcode($pm['message']);
            //parsing slash replacements
            $pm['message'] = str_replace("/me","<font color='#DD0000'>".$pm['username']."</font>",$pm['message']);
            $pm['message'] = str_replace("/maim","<font color='#DD0000'>".$pm['aim']."</font>",$pm['message']);
            $pm['message'] = str_replace("/mmsn","<font color='#DD0000'>".$pm['msn']."</font>",$pm['message']);
            $pm['message'] = str_replace("/micq","<font color='#DD0000'>".$pm['icq']."</font>",$pm['message']);
            $pm['message'] = str_replace("/myim","<font color='#DD0000'>".$pm['yim']."</font>",$pm['message']);
            $pm['message'] = str_replace("/you","<font color='#007700'>".$user->getData('username')."</font>",$pm['message']);
            $pm['message'] = str_replace("/ygroup","<font color='#007700'>".$user->getData('name')."</font>",$pm['message']);
            $pm['message'] = str_replace("/ybday","<font color='#007700'>".$user->getData('bday').".".$user->getData('bmonth').".".$user->getData('byear')."</font>",$pm['message']);
            //parsing emoticons in post
            if($pm['disableemoticons'] == 0){
                //# Grabbing emoticons
                $grabemoticons = $SQL->query("SELECT `id`,`emoticon`,`image` FROM `".$database['prefix']."emoticons`");
                while($grab = $SQL->fetch_array($grabemoticons)){
                    $emoticons[$grab['id']] = $grab['emoticon'];
                    $emoticonimages[$grab['id']] = "<img src=\"$config[emoticonpath]$grab[image]\" alt=\"$grab[emoticon]\" />";
                }
                $pm['message'] = parse_emoticons($pm['message'], $emoticons, $emoticonimages, 0);
            }
            //autoparsing urls in post
            if($pm['parseurls'] == 1){
                $pm['message'] = parse_urls($pm['message']);
            }
            if($pm['status'] == "sent"){
                eval("\$cpinclude = \"".$template->templates['61']."\";");
            } else {
                eval("\$cpinclude = \"".$template->templates['58']."\";");
            }
        } else {
            bb_error("The private message doesn't exist.");
        }

        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'outbox':
        //# Updating active table
        $user->updateActive("Writing a PM");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Writing a PM";

        $pmid = prepValue($_GET['id']);
        if (is_numeric($pmid)) {
            $pmid = round($pmid);
            $quoteq = $SQL->query("SELECT `fromname`,`subject`,`message` FROM `".$database['prefix']."pmessages` WHERE `toid` = '".$user->getData('id')."' AND `id`='$pmid'");

            $exist = $SQL->num_rows($pmq);
            if ($exist >= 1) {
                $pm = $SQL->fetch_array($quoteq);
                $pm['toname'] = $pm['fromname'];
                $pm['subject'] = stripslashes($pm['subject']);
                $pm['subject'] = "RE: " . $pm['subject'];
                $pm['message'] = stripslashes($pm['message']);
                $pm['quote'] = "[quote=".$pm['fromname']."]".$pm['message']."[/quote]";
            }
        }

        //# Checking if we should preset some PM vars with $_GET ;)
        if($_GET['to'] != ""){
            $pm['toname'] = prepValue($_GET['to']);
        }
        if($_GET['subject'] != ""){
            $pm['subject'] = prepValue(stripslashes($_GET['subject']));
        }
        if($_GET['message'] != ""){
            $pm['quote'] = prepValue(stripslashes($_GET['message']));
        }

        //# Checking if user is sending PM from a post
        $postid = prepValue($_GET['postid']);
        if($postid != ""){// && !is_numeric($postid)){
            $grabpost = $SQL->query("SELECT * FROM `".$database['prefix']."posts` WHERE `id` = '".$postid."'");
            if($SQL->num_rows($grabpost) > 0){
                $post = $SQL->fetch_array($grabpost);
                $pm['toname'] = $post['postername'];
                $pm['subject'] = "RE: " . stripslashes($post['title']);
                $pm['quote'] = "[quote=".$post['postername']."]".stripslashes($post['message'])."[/quote]";
            }
        }

        if($user->getData('parseurls') == 1){
            $pm['parseurls'] = "checked";
        }
        if($user->getData('disableemoticons') == 1){
            $pm['disableemoticons'] = "checked";
        }

        eval("\$cpinclude = \"".$template->templates['59']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'sendpm':
        if($_POST['toname'] == ""){ //is there message for the topic?
            bb_error("You didn't input a user to send you message to.");
        }
        if($_POST['subject'] == ""){ //is there message for the topic?
            bb_error("You didn't input a subject.");
        }
        if($_POST['message'] == ""){ //is there message for the topic?
            bb_error("You didn't input a message.");
        }
        $toq = $SQL->query("SELECT u.id,u.emailifpm,u.email,a.email AS aemail FROM `".$database['prefix']."users` AS u LEFT JOIN `".$database['prefix']."users` AS a ON(a.id = '1') WHERE u.username='".$_POST['toname']."'");
        if($SQL->num_rows($toq) <= 0) {
            bb_error("The user ".$_POST['toname']." does not exist.");
        }
        $toid = $SQL->fetch_array($toq);

        $SQL->query("INSERT INTO `".$database['prefix']."pmessages` (`id`, `fromid`, `fromname`, `toid`, `toname`, `subject`, `message`, `senddate`, `parseurls`, `disableemoticons`, `read`, `status`) VALUES('','".$user->getData('id')."','".$user->getData('username')."','".$toid['id']."','".prepValue($_POST['toname'])."','".prepValue($_POST['subject'])."','".prepValue($_POST['message'])."','".time()."','".prepValue($_POST['parseurls'])."','".prepValue($_POST['disableemoticons'])."','0','inbox')");
        $SQL->query("INSERT INTO `".$database['prefix']."pmessages` (`id`, `fromid`, `fromname`, `toid`, `toname`, `subject`, `message`, `senddate`, `parseurls`, `disableemoticons`, `read`, `status`) VALUES('','".$user->getData('id')."','".$user->getData('username')."','".$toid['id']."','".prepValue($_POST['toname'])."','".prepValue($_POST['subject'])."','".prepValue($_POST['message'])."','".time()."','".prepValue($_POST['parseurls'])."','".prepValue($_POST['disableemoticons'])."','0','sent')");

        if($toid['emailifpm'] == 1 && function_exists('mail')){
            $config['emailifpm'] = str_replace("%boardurl%", $config['boardurl'], $config['emailifpm']);
            $config['emailifpm'] = str_replace("%boardname%", $config['boardname'], $config['emailifpm']);

            bb_sendmail($toid['email'], "New PM at ".$config['boardname'], $config['emailifpm']);
        }

        die_header("Location: ".$config['boardurl']."usercp.php?a=inbox&msg=The+private+message+was+sent+successfully.");
    break;
    case 'markpm':
        $id = prepValue($_GET['id']);

        $pmnumq = $SQL->query("SELECT `id` FROM `".$database['prefix']."pmessages` WHERE `toid` = '".$user->getData('id')."'");
        $pmnum = $SQL->num_rows($pmnumq);
        $sentnumq = $SQL->query("SELECT `id` FROM `".$database['prefix']."pmessages` WHERE `fromid` = '".$user->getData('id')."' AND `status` = '3'");
        $sentnum = $SQL->num_rows($pmnumq);
        $pmnum += $sentnum;
        if(isset($_POST['save'])){
            if(is_numeric($id) && $id != ""){
                $checkq = $SQL->query("SELECT `id` FROM `".$database['prefix']."pmessages` WHERE `id` = '$id'");
                if($SQL->num_rows($checkq)<=0){
                    bb_error("The specified PM does not exist.");
                }
                $SQL->query("UPDATE `".$database['prefix']."pmessages` SET `status` = 'saved' WHERE `id` = '$id'");
            }else{
                for($loop = 0; $loop <= $pmnum; $loop++){
                    if ($_POST['n'.$loop] != "") {
                        $SQL->query("UPDATE `".$database['prefix']."pmessages` SET `status` = 'saved' WHERE `id` = '".$_POST['n'.$loop]."'");
                    }
                }
            }
            die_header("Location: ".$config['boardurl']."usercp.php?a=inbox&msg=The+selected+PMs+were+successfully+saved.");
        }else if(isset($_POST['delete'])){
            if(is_numeric($id) && $id != ""){
                $checkq = $SQL->query("SELECT `id` FROM `".$database['prefix']."pmessages` WHERE `id` = '$id'");
                if($SQL->num_rows($checkq)<=0){
                    bb_error("The specified PM does not exist.");
                }
                $SQL->query("DELETE FROM `".$database['prefix']."pmessages` WHERE `id` = '$id' LIMIT 1");
            }else{
                for($loop = 0; $loop <= $pmnum; $loop++){
                    if ($_POST['n'.$loop] != "") {
                        $SQL->query("DELETE FROM `".$database['prefix']."pmessages` WHERE `id` = '".$_POST['n'.$loop]."' LIMIT 1");
                    }
                }
            }
            die_header("Location: ".$config['boardurl']."usercp.php?a=inbox&msg=The+selected+PMs+were+successfully+deleted.");
        }
    break;
    case 'subscriptions':
        //# Updating active table
        $user->updateActive("Viewing Subscriptions");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Manage Subscriptions";

        $checks = 0;
        $subgrab = $SQL->query("SELECT s.tid, t.title FROM `".$database['prefix']."subscriptions` AS s LEFT JOIN `".$database['prefix']."topics` AS t ON(s.tid=t.id) WHERE s.userid='".$user->getData('id')."'");
        while($sub = $SQL->fetch_array($subgrab)){
            $subscriptions .= stripslashes($template->templates['83']);
            $checks++;
            $subscriptions = $template->cacheArray($subscriptions, $sub);
        }
        $sub = $template->releaseCache();
        if($SQL->num_rows($subgrab) < 1){
            $subscriptions = stripslashes($template->templates['84']);
        }

        eval("\$subscriptions = \"".addslashes($subscriptions)."\";");
        eval("\$cpinclude = \"".$template->templates['82']."\";");
        eval("\$include = \"".$template->templates['37']."\";");
    break;
    case 'subscribe':
        $tid = prepValue($_GET['tid']);
        if(!is_numeric($tid) || $tid == "" || $user->getData('view_topic') == 0){
            bb_error("That is not a valid topic, or you are not allowed to view topics.");
        }
        $grabsubs = $SQL->query("INSERT INTO `".$database['prefix']."subscriptions` (`tid`,`userid`) VALUES('".$tid."','".$user->getData('id')."')");

        die_header("Location: ".$config['boardurl']."usercp.php?a=subscriptions&msg=You+have+been+subscribed+to+the+topic.");
    break;
    case 'unsubscribe':
        $subgrab = $SQL->query("SELECT * FROM `".$database['prefix']."subscriptions` WHERE userid='".$user->getData('id')."'");
        $subnum = $SQL->num_rows($subgrab);
        for ($loop = 0; $loop <= $subnum; $loop++) {
            if ($_POST['n'.$loop] != "") {
                $SQL->query("DELETE FROM `".$database['prefix']."subscriptions` WHERE `tid`='".$_POST['n'.$loop]."' AND `userid`='".$user->getData('id')."'");
            }
        }
        die_header("Location: ".$config['boardurl']."usercp.php?a=subscriptions&msg=You+have+been+unsubscribed+from+the+topic.");
    break;
    default:
        die_header("Location: ".$config['boardurl']);
    break;
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>