<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: admin-forums.php,v 1.8 2005/06/10 02:02:07 mokkan Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/

 
//# File ID
define("FILEID", "admin-forums");

//# Templates:
$bb_templates = '1,12,85,90,112,113,114,115,116,117,118,119,120,121,122,123,143';
require("core.php");

if($user->userdata['admin_cp'] != 1){
    bb_error("You do not have permission to use the administrator control panel.");
}

$breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"admin-forums.php\">AdminCP</a>";

//# Admin Message
if($_GET['msg'] != ""){
    $msg = str_replace("+", " ", $_GET['msg']);
    $msg = prepValue($msg);
    eval("\$admin_message = \"".$template->getTemplate('143')."\";");
}

//# Switchboard
switch(prepValue($_GET['a'])){
    case 'manageforums':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Manage Forums";

        $latestcid = "";
        $latestfid = "";
        $forums = "";
        $forumq = $SQL->query("SELECT c.id AS cid, c.name AS cname, f.id AS fid, f.name AS fname, s.id AS sid, s.name AS sname FROM `".$database['prefix']."forums` AS c LEFT JOIN `".$database['prefix']."forums` AS f ON(f.parent = c.id AND f.class = 'forum') LEFT JOIN `".$database['prefix']."forums` AS s ON(s.parent = f.id AND s.class = 'subforum') WHERE c.class = 'category' ORDER BY c.order,f.order,f.id,s.order,s.id");
        while($forum = $SQL->fetch_array($forumq)){
            if($forum['cid'] != $latestcid && $forum['cid'] != ""){
                $forums .= $template->templates['113'];
                $forums = stripslashes($forums);
                $forums = $template->cacheArray($forums, $forum);
                $latestcid = $forum['cid'];
            }
            if($forum['fid'] != $latestfid && $forum['fid'] != ""){
                $forums .= $template->templates['114'];
                $forums = stripslashes($forums);;
                $forums = $template->cacheArray($forums, $forum);
                $latestfid = $forum['fid'];
            }
            if($forum['sid'] != ""){
                $forums .= $template->templates['115'];
                $forums = stripslashes($forums);
                $latestfid = $forum['fid'];
                $forums = $template->cacheArray($forums, $forum);
            }
        }
        $forum = $template->releaseCache();
        eval("\$forums = \"".addslashes($forums)."\";");
        $boardname = $config['boardname'];

        eval("\$cpinclude = \"".$template->templates['112']."\";");
        $user->updateActive("Managing Forums");
    break;
    case 'editcategoryform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Category";

        $cid = prepValue($_GET['id']);
        if($cid == "" || !is_numeric($cid)){
            bb_error("Category not speified");
        }
 
        $catq = $SQL->query("SELECT `id`,`name`,`order` FROM `".$database['prefix']."forums` WHERE `id`='$cid' AND `class`='category'");
        if($SQL->num_rows($catq) <= 0){
            bb_error("There is no category with the specified id.");
        }
        $cat = $SQL->fetch_array($catq);

        eval("\$cpinclude = \"".$template->templates['116']."\";");
        $user->updateActive("Editing a Category");
    break;
    case 'editcategory':
        $_POST = prepValue($_POST);
        $cid = prepValue($_GET['id']);
        if($cid == "" || !is_numeric($cid)){
            bb_error("Category not speified");
        }

        $catq = $SQL->query("SELECT `id`,`name`,`order` FROM `".$database['prefix']."forums` WHERE `id`='$cid' AND `class`='category'");
        if($SQL->num_rows($catq) <= 0){
            bb_error("There is no category with the specified id.");
        }

        $SQL->query("UPDATE `".$database['prefix']."forums` SET `name`='".$_POST['name']."', `order`='".$_POST['order']."' WHERE `id`='$cid'");

        die_header("Location: admin-forums.php?a=manageforums&msg=Category+edited+succesfully");
    break;
    case 'deletecategory':
        $cid = prepValue($_GET['id']);
        if($cid == "" || !is_numeric($cid)){
            bb_error("Category not speified");
        }

        $catq = $SQL->query("SELECT `id` FROM `".$database['prefix']."forums` WHERE `id`='$cid' AND `class`='category'");
        if($SQL->num_rows($catq) <= 0){
            bb_error("There is no category with the specified id.");
        }

        $latestcid = "";
        $latestfid = "";
        $ids = "";
        $forumq = $SQL->query("SELECT c.id AS cid, f.id AS fid, f.disablepc AS fdisablepc, s.id AS sid, s.disablepc AS sdisablepc FROM `".$database['prefix']."forums` AS c LEFT JOIN `".$database['prefix']."forums` AS f ON(f.parent = c.id AND f.class = 'forum') LEFT JOIN `".$database['prefix']."forums` AS s ON(s.parent = f.id AND s.class = 'subforum') WHERE c.id = '$cid' AND c.class = 'category' ORDER BY c.order,f.order,f.id,s.order,s.id");
        while($forum = $SQL->fetch_array($forumq)){
            if($forum['cid'] != $latestcid && $forum['cid'] != ""){
                $ids .= $forum['cid'].",";
                $latestcid = $forum['cid'];
            }
            if($forum['fid'] != $latestfid && $forum['fid'] != ""){
                $ids .= $forum['fid'].",";
                $latestfid = $forum['fid'];

                $topicq = $SQL->query("SELECT `id` FROM `".$database['prefix']."topics` WHERE `fid`='".$forum['fid']."'");
                while($topic = $SQL->fetch_array($topicq)){
                    $tid = $topic['id'];

                    $SQL->query("DELETE FROM `".$database['prefix']."subscriptions` WHERE `tid`='$tid'");

                    $pollq = $SQL->query("SELECT `id` FROM `".$database['prefix']."polls` WHERE `tid`='$tid'");
                    while($poll = $SQL->fetch_array($pollq)){
                        $pollid = $poll['id'];
                        $SQL->query("DELETE FROM `".$database['prefix']."polls` WHERE `id`='$pollid' LIMIT 1");
                        $SQL->query("DELETE FROM `".$database['prefix']."pollvotes` WHERE `pollid`='$pollid'");
                        $SQL->query("DELETE FROM `".$database['prefix']."polloptions` WHERE `pollid`='$pollid'");
                    }

                    $postq = $SQL->query("SELECT `id`,`posterid`,`attachmentid` FROM `".$database['prefix']."posts` WHERE `tid`='$tid'");
                    $posts = $SQL->num_rows($postq);
                    while($post = $SQL->fetch_array($postq)){
                        $pid = $post['id'];
                        if($post['attachmentid'] != ""){
                            $SQL->query("DELETE FROM `".$database['prefix']."attachments` WHERE `id`='".$post['attachmentid']."' LIMIT 1");
                        }

                        if($forum['fdisablepc'] != 1){
                            $exist = $SQL->query("SELECT `id` FROM `".$database['prefix']."users` WHERE `id`='".$post['posterid']."'");
                            if($SQL->num_rows($exist) > 0){
                                $SQL->query("UPDATE `".$database['prefix']."users` SET `posts`=posts-1 WHERE `id`='".$post['posterid']."'");
                            }
                        }
                        $SQL->query("DELETE FROM `".$database['prefix']."posts` WHERE `id`='$pid' LIMIT 1");
                    }
                    $SQL->query("DELETE FROM `".$database['prefix']."topics` WHERE `id`='$tid' LIMIT 1");
                    $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `posts`=posts-$posts, `topics`=topics-1");
                }
            }
            if($forum['sid'] != ""){
                $ids .= $forum['sid'].",";
                $latestfid = $forum['sid'];

                $topicq = $SQL->query("SELECT `id` FROM `".$database['prefix']."topics` WHERE `fid`='".$forum['sid']."'");
                while($topic = $SQL->fetch_array($topicq)){
                    $tid = $topic['id'];

                    $SQL->query("DELETE FROM `".$database['prefix']."subscriptions` WHERE `tid`='$tid'");

                    $pollq = $SQL->query("SELECT `id` FROM `".$database['prefix']."polls` WHERE `tid`='$tid'");
                    while($poll = $SQL->fetch_array($pollq)){
                        $pollid = $poll['id'];
                        $SQL->query("DELETE FROM `".$database['prefix']."polls` WHERE `id`='$pollid' LIMIT 1");
                        $SQL->query("DELETE FROM `".$database['prefix']."pollvotes` WHERE `pollid`='$pollid'");
                        $SQL->query("DELETE FROM `".$database['prefix']."polloptions` WHERE `pollid`='$pollid'");
                    }

                    $postq = $SQL->query("SELECT `id`,`posterid`,`attachmentid` FROM `".$database['prefix']."posts` WHERE `tid`='$tid'");
                    $posts = $SQL->num_rows($postq);
                    while($post = $SQL->fetch_array($postq)){
                        $pid = $post['id'];
                        if($post['attachmentid'] != ""){
                            $SQL->query("DELETE FROM `".$database['prefix']."attachments` WHERE `id`='".$post['attachmentid']."' LIMIT 1");
                        }

                        if($forum['sdisablepc'] != 1){
                            $exist = $SQL->query("SELECT `id` FROM `".$database['prefix']."users` WHERE `id`='".$post['posterid']."'");
                            if($SQL->num_rows($exist) > 0){
                                $SQL->query("UPDATE `".$database['prefix']."users` SET `posts`=posts-1 WHERE `id`='".$post['posterid']."'");
                            }
                        }
                        $SQL->query("DELETE FROM `".$database['prefix']."posts` WHERE `id`='$pid' LIMIT 1");
                    }
                    $SQL->query("DELETE FROM `".$database['prefix']."topics` WHERE `id`='$tid' LIMIT 1");
                    $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `posts`=posts-$posts, `topics`=topics-1");
                }
            }
        }
        $ids = substr($ids, 0, -1);
        $ids = str_replace(',', "','", $ids);
        $SQL->query("DELETE FROM `".$database['prefix']."forums` WHERE (`id` IN('$ids'))");

        die_header("Location: admin-forums.php?a=manageforums&msg=Category+deleted+succesfully");
    break;
    case 'addcategoryform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Add Category";

        eval("\$cpinclude = \"".$template->templates['117']."\";");
        $user->updateActive("Adding a Category");
    break;
    case 'addcategory':
        $_POST = prepValue($_POST);

        $SQL->query("INSERT INTO `".$database['prefix']."forums` (`class`,`name`,`order`) VALUES('category', '".$_POST['name']."', '".$_POST['order']."')");

        die_header("Location: admin-forums.php?a=manageforums&msg=Category+added+succesfully");
    break;
    case 'editforumform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Forum";

        $fid = prepValue($_GET['id']);
        if($fid == "" || !is_numeric($fid)){
            bb_error("Forum not speified");
        }
 
        $forumq = $SQL->query("SELECT `id`,`name`,`description`,`order`,`disablepc` FROM `".$database['prefix']."forums` WHERE `id`='$fid' AND `class`='forum'");
        if($SQL->num_rows($catq) <= 0){
            bb_error("There is no forum with the specified id.");
        }
        $forum = $SQL->fetch_array($forumq);

        if($forum['disablepc'] == 1){
            $forum['disablepc'] = "selected";
        }

        eval("\$cpinclude = \"".$template->templates['118']."\";");
        $user->updateActive("Editing a Forum");
    break;
    case 'editforum':
        $_POST = prepValue($_POST);

        $fid = prepValue($_GET['id']);
        if($fid == "" || !is_numeric($fid)){
            bb_error("Forum not speified");
        }

        $forumq = $SQL->query("SELECT `id` FROM `".$database['prefix']."forums` WHERE `id`='$fid' AND `class`='forum'");
        if($SQL->num_rows($catq) <= 0){
            bb_error("There is no forum with the specified id.");
        }

        $SQL->query("UPDATE `".$database['prefix']."forums` SET `name`='".$_POST['name']."', `description`='".$_POST['description']."', `order`='".$_POST['order']."', `disablepc`='".$_POST['disablepc']."' WHERE `id`='$fid'");

        die_header("Location: admin-forums.php?a=manageforums&msg=Forum+edited+succesfully");
    break;
    case 'deleteforum':
        $fid = prepValue($_GET['id']);
        if($fid == "" || !is_numeric($fid)){
            bb_error("Forum not speified");
        }

        $existq = $SQL->query("SELECT `id` FROM `".$database['prefix']."forums` WHERE `id`='$fid' AND `class`='forum'");
        if($SQL->num_rows($existq) <= 0){
            bb_error("There is no forum with the specified id.");
        }

        $latestfid = "";
        $ids = "";
        $forumq = $SQL->query("SELECT f.id AS fid, f.disablepc AS fdisablepc, s.id AS sid, s.disablepc AS sdisablepc FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS s ON(s.parent=f.id AND s.class='subforum') WHERE f.id='$fid' AND f.class='forum' ORDER BY f.order,f.id,s.order,s.id");
        while($forum = $SQL->fetch_array($forumq)){
            if($forum['fid'] != $latestfid && $forum['fid'] != ""){
                $ids .= $forum['fid'].",";
                $latestfid = $forum['fid'];

                $topicq = $SQL->query("SELECT `id` FROM `".$database['prefix']."topics` WHERE `fid`='".$forum['fid']."'");
                while($topic = $SQL->fetch_array($topicq)){
                    $tid = $topic['id'];

                    $SQL->query("DELETE FROM `".$database['prefix']."subscriptions` WHERE `tid`='$tid'");

                    $pollq = $SQL->query("SELECT `id` FROM `".$database['prefix']."polls` WHERE `tid`='$tid'");
                    while($poll = $SQL->fetch_array($pollq)){
                        $pollid = $poll['id'];
                        $SQL->query("DELETE FROM `".$database['prefix']."polls` WHERE `id`='$pollid' LIMIT 1");
                        $SQL->query("DELETE FROM `".$database['prefix']."pollvotes` WHERE `pollid`='$pollid'");
                        $SQL->query("DELETE FROM `".$database['prefix']."polloptions` WHERE `pollid`='$pollid'");
                    }

                    $postq = $SQL->query("SELECT `id`,`posterid`,`attachmentid` FROM `".$database['prefix']."posts` WHERE `tid`='$tid'");
                    $posts = $SQL->num_rows($postq);
                    while($post = $SQL->fetch_array($postq)){
                        $pid = $post['id'];
                        if($post['attachmentid'] != ""){
                            $SQL->query("DELETE FROM `".$database['prefix']."attachments` WHERE `id`='".$post['attachmentid']."' LIMIT 1");
                        }

                        if($forum['fdisablepc'] != 1){
                            $exist = $SQL->query("SELECT `id` FROM `".$database['prefix']."users` WHERE `id`='".$post['posterid']."'");
                            if($SQL->num_rows($exist) > 0){
                                $SQL->query("UPDATE `".$database['prefix']."users` SET `posts`=posts-1 WHERE `id`='".$post['posterid']."'");
                            }
                        }
                        $SQL->query("DELETE FROM `".$database['prefix']."posts` WHERE `id`='$pid' LIMIT 1");
                    }
                    $SQL->query("DELETE FROM `".$database['prefix']."topics` WHERE `id`='$tid' LIMIT 1");
                    $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `posts`=posts-$posts, `topics`=topics-1");
                }
            }
            if($forum['sid'] != ""){
                $ids .= $forum['sid'].",";
                $latestfid = $forum['sid'];

                $topicq = $SQL->query("SELECT `id` FROM `".$database['prefix']."topics` WHERE `fid`='".$forum['sid']."'");
                while($topic = $SQL->fetch_array($topicq)){
                    $tid = $topic['id'];

                    $SQL->query("DELETE FROM `".$database['prefix']."subscriptions` WHERE `tid`='$tid'");

                    $pollq = $SQL->query("SELECT `id` FROM `".$database['prefix']."polls` WHERE `tid`='$tid'");
                    while($poll = $SQL->fetch_array($pollq)){
                        $pollid = $poll['id'];
                        $SQL->query("DELETE FROM `".$database['prefix']."polls` WHERE `id`='$pollid' LIMIT 1");
                        $SQL->query("DELETE FROM `".$database['prefix']."pollvotes` WHERE `pollid`='$pollid'");
                        $SQL->query("DELETE FROM `".$database['prefix']."polloptions` WHERE `pollid`='$pollid'");
                    }

                    $postq = $SQL->query("SELECT `id`,`posterid`,`attachmentid` FROM `".$database['prefix']."posts` WHERE `tid`='$tid'");
                    $posts = $SQL->num_rows($postq);
                    while($post = $SQL->fetch_array($postq)){
                        $pid = $post['id'];
                        if($post['attachmentid'] != "" && $post['attachmentid'] != "0"){
                            $SQL->query("DELETE FROM `".$database['prefix']."attachments` WHERE `id`='".$post['attachmentid']."' LIMIT 1");
                        }

                        if($forum['sdisablepc'] != 1){
                            $exist = $SQL->query("SELECT `id` FROM `".$database['prefix']."users` WHERE `id`='".$post['posterid']."'");
                            if($SQL->num_rows($exist) > 0){
                                $SQL->query("UPDATE `".$database['prefix']."users` SET `posts`=posts-1 WHERE `id`='".$post['posterid']."'");
                            }
                        }
                        $SQL->query("DELETE FROM `".$database['prefix']."posts` WHERE `id`='$pid' LIMIT 1");
                    }
                    $SQL->query("DELETE FROM `".$database['prefix']."topics` WHERE `id`='$tid' LIMIT 1");
                    $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `posts`=posts-$posts, `topics`=topics-1");
                }
            }
        }
        $ids = substr($ids, 0, -1);
        $ids = str_replace(',', "','", $ids);
        $SQL->query("DELETE FROM `".$database['prefix']."forums` WHERE (`id` IN('$ids'))");

        die_header("Location: admin-forums.php?a=manageforums&msg=Forum+deleted+succesfully");
    break;
    case 'addforumform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Add Forum";

        $cid = prepValue($_GET['id']);
        if($cid == "" || !is_numeric($cid)){
            bb_error("Category not speified");
        }

        $catq = $SQL->query("SELECT `id` FROM `".$database['prefix']."forums` WHERE `id`='$cid' AND `class`='category'");
        if($SQL->num_rows($catq) <= 0){
            bb_error("There is no category with the specified id.");
        }

        eval("\$cpinclude = \"".$template->templates['119']."\";");
        $user->updateActive("Adding a Forum");
    break;
    case 'addforum':
        $_POST = prepValue($_POST);

        $cid = prepValue($_GET['id']);
        if($cid == "" || !is_numeric($cid)){
            bb_error("Category not speified");
        }

        $catq = $SQL->query("SELECT `id` FROM `".$database['prefix']."forums` WHERE `id`='$cid' AND `class`='category'");
        if($SQL->num_rows($catq) <= 0){
            bb_error("There is no category with the specified id.");
        }

        $SQL->query("INSERT INTO `".$database['prefix']."forums` (`class`,`name`,`description`,`parent`,`order`,`disablepc`) VALUES('forum', '".$_POST['name']."', '".$_POST['description']."', '$cid', '".$_POST['order']."', '".$_POST['disablepc']."')");

        die_header("Location: admin-forums.php?a=manageforums&msg=Forum+added+succesfully");
    break;
    case 'moveforumform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Move Forum";

        $fid = prepValue($_GET['id']);
        if($fid == "" || !is_numeric($fid)){
            bb_error("Forum not speified");
        }

        $forumq = $SQL->query("SELECT c.name AS cname, c.id as cid, f.name FROM `".$database['prefix']."forums` AS c LEFT JOIN `".$database['prefix']."forums` AS f ON(f.id='$fid' AND f.class='forum') WHERE f.parent=c.id AND c.class='category'");
        if($SQL->num_rows($forumq) <= 0){
            bb_error("There is no forum with the specified id.");
        }

        $forum = $SQL->fetch_array($forumq);

        $foptq = $SQL->query("SELECT id AS fid,`name` FROM `".$database['prefix']."forums` WHERE `class`='category' AND `id`!='".$forum['cid']."' ORDER BY `order`,`id`");
        while($foption = $SQL->fetch_array($foptq)){
            $foptions .= $template->templates['90'];
            $foptions = stripslashes($foptions);

            $foptions = $template->cacheArray($foptions, $foption);
        }
        $foption = $template->releaseCache();
        eval("\$foptions = \"".addslashes($foptions)."\";");

        eval("\$cpinclude = \"".$template->templates['120']."\";");
        $user->updateActive("Moving a Forum");
    break;
    case 'moveforum':
        $_POST = prepValue($_POST);

        $fid = prepValue($_GET['id']);
        if($fid == "" || !is_numeric($fid)){
            bb_error("Forum not speified");
        }

        $forumq = $SQL->query("SELECT c.id FROM `".$database['prefix']."forums` AS c LEFT JOIN `".$database['prefix']."forums` AS f ON(f.id='$fid' AND f.class='forum') WHERE c.id='".$_POST['parent']."' AND c.class='category'");
        if($SQL->num_rows($forumq) <= 0){
            bb_error("The forum or category specified does not exist.");
        }

        $SQL->query("UPDATE `".$database['prefix']."forums` SET `parent`='".$_POST['parent']."' WHERE `id`='$fid'");

        die_header("Location: admin-forums.php?a=manageforums&msg=Forum+moved+succesfully");
    break;
    case 'editsforumform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Subforum";

        $sid = prepValue($_GET['id']);
        if($sid == "" || !is_numeric($sid)){
            bb_error("subforum not speified");
        }
 
        $subforumq = $SQL->query("SELECT `id`,`name`,`description`,`order`,`disablepc`,`updateparent` FROM `".$database['prefix']."forums` WHERE `id`='$sid' AND `class`='subforum'");
        if($SQL->num_rows($catq) <= 0){
            bb_error("There is no subforum with the specified id.");
        }
        $subforum = $SQL->fetch_array($subforumq);

        if($subforum['disablepc'] == 1){
            $subforum['disablepc'] = "selected";
        }

        if($subforum['updateparent'] == 1){
            $subforum['updateparent'] = "selected";
        }

        eval("\$cpinclude = \"".$template->templates['121']."\";");
        $user->updateActive("Editing a Subforum");
    break;
    case 'editsforum':
        $_POST = prepValue($_POST);

        $sid = prepValue($_GET['id']);
        if($sid == "" || !is_numeric($sid)){
            bb_error("Subforum not speified");
        }

        $subforumq = $SQL->query("SELECT `id` FROM `".$database['prefix']."forums` WHERE `id`='$sid' AND `class`='subforum'");
        if($SQL->num_rows($catq) <= 0){
            bb_error("There is no subforum with the specified id.");
        }

        $SQL->query("UPDATE `".$database['prefix']."forums` SET `name`='".$_POST['name']."', `description`='".$_POST['description']."', `order`='".$_POST['order']."', `disablepc`='".$_POST['disablepc']."', `updateparent`='".$_POST['updateparent']."' WHERE `id`='$sid'");

        die_header("Location: admin-forums.php?a=manageforums&msg=Subforum+edited+succesfully");
    break;
    case 'deletesforum':
        $sid = prepValue($_GET['id']);
        if($sid == "" || !is_numeric($sid)){
            bb_error("Subforum not speified");
        }

        $subforumq = $SQL->query("SELECT `id`,`parent`,`updateparent` FROM `".$database['prefix']."forums` WHERE `id`='$sid' AND `class`='subforum'");
        if($SQL->num_rows($subforumq) <= 0){
            bb_error("There is no subforum with the specified id.");
        }
        $subforum = $SQL->fetch_array($subforumq);

        $forumq = $SQL->query("SELECT `id`,`disablepc` FROM `".$database['prefix']."forums` WHERE `id`='$sid' ORDER BY `order`,`id`");
        while($forum = $SQL->fetch_array($forumq)){
            $topicq = $SQL->query("SELECT `id` FROM `".$database['prefix']."topics` WHERE `fid`='".$forum['id']."'");
            while($topic = $SQL->fetch_array($topicq)){
                $tid = $topic['id'];

                $SQL->query("DELETE FROM `".$database['prefix']."subscriptions` WHERE `tid`='$tid'");

                $pollq = $SQL->query("SELECT `id` FROM `".$database['prefix']."polls` WHERE `tid`='$tid'");
                while($poll = $SQL->fetch_array($pollq)){
                    $pollid = $poll['id'];
                    $SQL->query("DELETE FROM `".$database['prefix']."polls` WHERE `id`='$pollid' LIMIT 1");
                    $SQL->query("DELETE FROM `".$database['prefix']."pollvotes` WHERE `pollid`='$pollid'");
                    $SQL->query("DELETE FROM `".$database['prefix']."polloptions` WHERE `pollid`='$pollid'");
                }

                $postq = $SQL->query("SELECT `id`,`posterid`,`attachmentid` FROM `".$database['prefix']."posts` WHERE `tid`='$tid'");
                $posts = $SQL->num_rows($postq);
                while($post = $SQL->fetch_array($postq)){
                    $pid = $post['id'];
                    if($post['attachmentid'] != ""){
                        $SQL->query("DELETE FROM `".$database['prefix']."attachments` WHERE `id`='".$post['attachmentid']."' LIMIT 1");
                    }

                    if($forum['disablepc'] != 1){
                        $exist = $SQL->query("SELECT `id` FROM `".$database['prefix']."users` WHERE `id`='".$post['posterid']."'");
                        if($SQL->num_rows($exist) > 0){
                            $SQL->query("UPDATE `".$database['prefix']."users` SET `posts`=posts-1 WHERE `id`='".$post['posterid']."'");
                        }
                    }
                    $SQL->query("DELETE FROM `".$database['prefix']."posts` WHERE `id`='$pid' LIMIT 1");
                }
                $SQL->query("DELETE FROM `".$database['prefix']."topics` WHERE `id`='$tid' LIMIT 1");
                $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `posts`=posts-$posts, `topics`=topics-1");
            }
        }
        $SQL->query("DELETE FROM `".$database['prefix']."forums` WHERE `id`='$sid' LIMIT 1");

        if($subforum['updateparent'] == 1){
            $recentq = $SQL->query("SELECT t.id,t.title,t.lpdate,t.lpuserid,t.lpusername FROM `".$database['prefix']."topics` AS t LEFT JOIN `".$database['prefix']."forums` AS f ON(f.id = '".$subforum['parent']."') LEFT JOIN `".$database['prefix']."forums` AS s ON(s.parent='".$subforum['parent']."' AND s.updateparent='1') WHERE t.fid=f.id OR t.fid=s.id ORDER BY t.lpdate DESC LIMIT 1");
            if($SQL->num_rows($recentq) <= 0){
                $SQL->query("UPDATE `".$database['prefix']."forums` SET `lpdate`=NULL,`lptopicid`=NULL,`lptopicname`=NULL,`lpuserid`=NULL,`lpusername`=NULL WHERE `id`='".$subforum['parent']."'");
            }else{
                $recent = $SQL->fetch_array($recentq);
                $SQL->query("UPDATE `".$database['prefix']."forums` SET `lpdate`='".$recent['lpdate']."',`lptopicid`='".$recent['id']."',`lptopicname`='".$recent['title']."',`lpuserid`='".$recent['lpuserid']."',`lpusername`='".$recent['lpusername']."' WHERE `id`='".$subforum['parent']."'");
            }
        }
          
        die_header("Location: admin-forums.php?a=manageforums&msg=Subforum+deleted+succesfully");
    break;
    case 'addsforumform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Add Subforum";

        $fid = prepValue($_GET['id']);
        if($fid == "" || !is_numeric($fid)){
            bb_error("Forum not speified");
        }

        $forumq = $SQL->query("SELECT `id` FROM `".$database['prefix']."forums` WHERE `id`='$fid' AND `class`='forum'");
        if($SQL->num_rows($forumq) <= 0){
            bb_error("There is no forum with the specified id.");
        }

        eval("\$cpinclude = \"".$template->templates['122']."\";");
        $user->updateActive("Adding a Subforum");
    break;
    case 'addsforum':
        $_POST = prepValue($_POST);

        $fid = prepValue($_GET['id']);
        if($fid == "" || !is_numeric($fid)){
            bb_error("Forum not speified");
        }

        $forumq = $SQL->query("SELECT `id` FROM `".$database['prefix']."forums` WHERE `id`='$fid' AND `class`='forum'");
        if($SQL->num_rows($forumq) <= 0){
            bb_error("There is no category with the specified id.");
        }

        $SQL->query("INSERT INTO `".$database['prefix']."forums` (`class`,`name`,`description`,`parent`,`order`,`disablepc`,`updateparent`) VALUES('subforum', '".$_POST['name']."', '".$_POST['description']."', '$fid', '".$_POST['order']."', '".$_POST['disablepc']."', '".$_POST['updateparent']."')");

        die_header("Location: admin-forums.php?a=manageforums&msg=Subforum+added+succesfully");
    break;
    case 'movesforumform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Move Subforum";

        $sid = prepValue($_GET['id']);
        if($sid == "" || !is_numeric($sid)){
            bb_error("subforum not speified");
        }

        $subforumq = $SQL->query("SELECT f.name AS fname, f.id as fid, s.name FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS s ON(s.id='$sid' AND s.class='subforum') WHERE s.parent=f.id AND f.class='forum'");
        if($SQL->num_rows($subforumq) <= 0){
            bb_error("There is no subforum with the specified id.");
        }

        $subforum = $SQL->fetch_array($subforumq);

        $foptq = $SQL->query("SELECT id AS fid,`name` FROM `".$database['prefix']."forums` WHERE `class`='forum' AND `id`!='".$subforum['fid']."' ORDER BY `order`,`id`");
        while($foption = $SQL->fetch_array($foptq)){
            $foptions .= $template->templates['90'];
            $foptions = stripslashes($foptions);

            $foptions = $template->cacheArray($foptions, $foption);
        }
        $foption = $template->releaseCache();
        eval("\$foptions = \"".addslashes($foptions)."\";");

        eval("\$cpinclude = \"".$template->templates['123']."\";");
        $user->updateActive("Moving a Subforum");
    break;
    case 'movesforum':
        $_POST = prepValue($_POST);

        $sid = prepValue($_GET['id']);
        if($sid == "" || !is_numeric($sid)){
            bb_error("Subforum not speified");
        }

        $subforumq = $SQL->query("SELECT f.id FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS s ON(s.id='$sid' AND s.class='subforum') WHERE f.id='".$_POST['parent']."' AND f.class='forum'");
        if($SQL->num_rows($subforumq) <= 0){
            bb_error("The subforum or forum specified does not exist.");
        }

        $SQL->query("UPDATE `".$database['prefix']."forums` SET `parent`='".$_POST['parent']."' WHERE `id`='$sid'");

        die_header("Location: admin-forums.php?a=manageforums&msg=Subforum+moved+succesfully");
    break;
    default:
        die_header("Location: admin-forums.php?a=manageforums");
    break;
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$include = \"".$template->templates['85']."\";");
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>