<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: admin-templates.php,v 1.11 2005/06/28 20:14:54 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "admin-templates");

//# Setting templates and requiring core
$bb_templates = '1,12,85,124,125,126,127,128,129,130,131,132,133,134,143';
require("core.php");

if($user->userdata['admin_cp'] != 1){
    bb_error("You do not have permission to use the administrator control panel.");
}

$action = prepValue($_GET['a']);

$breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"admin-templates.php\">AdminCP</a>";

//# Admin Message
if($_GET['msg'] != ""){
    $msg = str_replace("+", " ", $_GET['msg']);
    $msg = prepValue($msg);
    eval("\$admin_message = \"".$template->getTemplate('143')."\";");
}

//# Switchboard
switch($action){
    case 'managetemps':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Manage Templates";

        //# Setting skin to edit
        if(prepValue($_GET['skinid']) != ""){
            $skinid = prepValue($_GET['skinid']);
            $_SESSION['acp_skinid'] = $skinid;
        } else {
           $skinid = $_SESSION['acp_skinid'];
        }
        if($skinid == "" || $skinid == NULL){
            $skinid = $config['skindefault'];
            $_SESSION['acp_skinid'] = $skinid;
        }

        //# Grabbing skins
        $skinarea = "";
        $grabskins = $SQL->query("SELECT * FROM `".$database['prefix']."skins` ORDER BY `name` DESC");
        while($skin = $SQL->fetch_array($grabskins)){
            if($skin['id'] == $skinid){
                $currentskin['id'] = $skin['id'];
                $currentskin['name'] = stripslashes($skin['name']);
            }
            $skinarea .= $template->getTemplate('127');
            $skinarea = stripslashes($skinarea);
            $skin['name'] = stripslashes($skin['name']);
            if($skinid == $skin['id']){
                $skin['selected'] = $template->getVar('skinarea_currentskin');
            } else {
                $skin['selected'] = "";
            }
            $skinarea = $template->cacheArray($skinarea, $skin);
        }
        $skin = $template->releaseCache();
        eval("\$skinarea = \"".addslashes($skinarea)."\";");

        //# Grabbing templates
        $templatearea = "";
        $grabtemplates = $SQL->query("SELECT * FROM `".$database['prefix']."templates` WHERE `skinid` = '$skinid' ORDER BY `label` ASC");
        while($temp = $SQL->fetch_array($grabtemplates)){
            $templatearea .= $template->getTemplate('125');
            $templatearea = stripslashes($templatearea);
            $temp['label'] = stripslashes($temp['label']);
            $templatearea = $template->cacheArray($templatearea, $temp);
        }
        $temp = $template->releaseCache();
        eval("\$templatearea = \"".addslashes($templatearea)."\";");

        //# Grabbing global tempvars
        $tempvararea = "";
        $grabtempvars = $SQL->query("SELECT * FROM `".$database['prefix']."tempvars` WHERE `skinid` = '$skinid' AND `scope` = 'global' ORDER BY `id` ASC");
        while($var = $SQL->fetch_array($grabtempvars)){
            $tempvararea .= $template->getTemplate('129');
            $var['value'] = str_replace('<', '&lt;', $var['value']);
            $var['value'] = str_replace('>', '&gt;', $var['value']);
            $tempvararea = stripslashes($tempvararea);
            $tempvararea = $template->cacheArray($tempvararea, $var);
        }
        $var = $template->releaseCache();
        eval("\$tempvararea = \"".addslashes($tempvararea)."\";");

        //# Grabbing current skin details
        $grabcurrentskin = $SQL->query("SELECT * FROM `".$database['prefix']."skins` WHERE `id` = '".$skinid."'");
        $skin = $SQL->fetch_array($grabcurrentskin);

        eval("\$cpinclude = \"".$template->getTemplate('124')."\";");
    break;
    case 'addform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Add Template";

        $skinid = prepValue($_GET['skinid']);
        eval("\$cpinclude = \"".$template->getTemplate('128')."\";");
    break;
    case 'add':
        $id = prepValue($_POST['id']);
        $skinid = prepValue($_GET['skinid']);
        $label = prepValue($_POST['label']);
        $temp = addslashes($_POST['temp']);
        if($id == "" || $label == "" || $temp == ""){
            bb_error("You didn't input an id/label/template.");
        }
        $inserttemplate = $SQL->query("INSERT INTO `".$database['prefix']."templates` (`id`,`skinid`,`label`,`template`) VALUES ('$id','$skinid','$label','$temp')");
        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Template+was+successfully+added.");
    break;
    case 'addvarform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Add Template Variable";

        $skinid = prepValue($_GET['skinid']);
        $scope = prepValue($_GET['scope']);
        if($scope == "global"){
            $templateid = "";
        } else if($scope = "local") {
            $templateid = prepValue($_GET['templateid']);
        } else {
            bb_error("Invalid variable scope.");
        }
        eval("\$cpinclude = \"".$template->getTemplate('130')."\";");
    break;
    case 'addvar':
        $skinid = prepValue($_GET['skinid']);
        $scope = prepValue($_GET['scope']);
        $id = prepValue($_POST['id']);
        $value = addslashes($_POST['value']);
        if($scope == "global"){
            $templateid = "";
        } else if($scope = "local") {
            $templateid = prepValue($_GET['templateid']);
        } else {
            bb_error("Invalid variable scope.");
        }
        if($value == "" || $id == ""){
            bb_error("You didn't enter an id/value for the variable.");
        }
        $SQL->query("INSERT INTO `".$database['prefix']."tempvars` (`id`, `skinid`, `scope`, `templateid`, `value`) VALUES ('$id', '$skinid', '$scope', '$templateid', '$value')");
        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Template+variable+was+successfully+added.");
    break;
    case 'editform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Template";

        $skinid = prepValue($_GET['skinid']);
        $id = prepValue($_GET['templateid']);
        $grabtemplate = $SQL->query("SELECT * FROM `".$database['prefix']."templates` WHERE `id` = '$id' AND `skinid` = '$skinid'");
        $temp = $SQL->fetch_array($grabtemplate);
        $temp['template'] = stripslashes($temp['template']);
        $temp['template'] = str_replace('&','&amp;', $temp['template']);
        $temp['template'] = str_replace('<','&lt;', $temp['template']);
        $temp['template'] = str_replace('>','&gt;', $temp['template']);

        //# Grabbing global tempvars
        $tempvararea = "";
        $grabtempvars = $SQL->query("SELECT * FROM `".$database['prefix']."tempvars` WHERE `skinid` = '$skinid' AND `scope` = 'local' AND `templateid` = '".$temp['id']."' ORDER BY `id` ASC");
        while($var = $SQL->fetch_array($grabtempvars)){
            $tempvararea .= $template->getTemplate('129');
            $tempvararea = stripslashes($tempvararea);
            $tempvararea = $template->cacheArray($tempvararea, $var);
        }
        $var = $template->releaseCache();
        eval("\$tempvararea = \"".addslashes($tempvararea)."\";");

        eval("\$cpinclude = \"".$template->getTemplate('126')."\";");
    break;
    case 'edit':
        $temp = $_POST['temp'];
        $skinid = prepValue($_GET['skinid']);
        $templateid = prepValue($_GET['templateid']);
        $label = prepValue($_POST['label']);
        $temp = str_replace('&lt;', '<', $temp);
        $temp = str_replace('&gt;', '>', $temp);
        $temp = str_replace('&amp;', '&', $temp);
        $temp = addslashes(addslashes($temp));

        $query = $SQL->query("UPDATE `".$database['prefix']."templates` SET `label` = '$label', `template` = '$temp' WHERE `id` = '$templateid' AND `skinid` = '$skinid'");
        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Template+was+successfully+updated.");
    break;
    case 'editvarform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Template Variable";

        $id = prepValue($_GET['varid']);
        $skinid = prepValue($_GET['skinid']);
        $scope = prepValue($_GET['scope']);
        $templateid = prepValue($_GET['templateid']);
        if($scope == 'local'){
            $grabvar = $SQL->query("SELECT * FROM `".$database['prefix']."tempvars` WHERE `id` = '$id' AND `skinid` = '$skinid' AND `scope` = 'local' AND `templateid` = '$templateid'");
        } else {
            $grabvar = $SQL->query("SELECT * FROM `".$database['prefix']."tempvars` WHERE `id` = '$id' AND `skinid` = '$skinid' AND `scope` = 'global'");
        }
        $var = $SQL->fetch_array($grabvar);
        $var['value'] = stripslashes($var['value']);
        $var['value'] = str_replace('&','&amp;', $var['value']);
        $var['value'] = str_replace('<','&lt;', $var['value']);
        $var['value'] = str_replace('>','&gt;', $var['value']);
        eval("\$cpinclude = \"".$template->getTemplate('131')."\";");
    break;
    case 'editvar':
        $value = $_POST['value'];
        $skinid = prepValue($_GET['skinid']);
        $id = prepValue($_GET['varid']);
        $scope = prepValue($_GET['scope']);
        $templateid = prepValue($_GET['templateid']);
        $value = str_replace('&lt;', '<', $value);
        $value = str_replace('&gt;', '>', $value);
        $value = str_replace('&amp;', '&', $value);
        $value = addslashes($value);
        if($scope == 'local'){
            $query = $SQL->query("UPDATE `".$database['prefix']."tempvars` SET `value` = '$value' WHERE `id` = '$id' AND `skinid` = '$skinid' AND `scope` = 'local' AND `templateid` = '$templateid'");
        } else {
            $query = $SQL->query("UPDATE `".$database['prefix']."tempvars` SET `value` = '$value' WHERE `id` = '$id' AND `skinid` = '$skinid' AND `scope` = 'global'");
        }
        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Template+variable+was+successfully+updated.");
    break;
    case 'delete':
        $templateid = prepValue($_GET['templateid']);
        $skinid = prepValue($_GET['skinid']);
        $query = $SQL->query("DELETE FROM `".$database['prefix']."templates` WHERE `id` = '$templateid' AND `skinid` = '$skinid'");
        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Template+was+successfully+deleted.");
    break;
    case 'deletevar':
        $id = prepValue($_GET['varid']);
        $skinid = prepValue($_GET['skinid']);
        $scope = prepValue($_GET['scope']);
        $templateid = prepValue($_GET['templateid']);
        if($scope == 'local'){
            $query = $SQL->query("DELETE FROM `".$database['prefix']."tempvars` WHERE `id` = '$id' AND `skinid` = '$skinid' AND `scope` = 'local' AND `templateid` = '$templateid'");
        } else {
            $query = $SQL->query("DELETE FROM `".$database['prefix']."tempvars` WHERE `id` = '$id' AND `skinid` = '$skinid' AND `scope` = 'global'");
        }
        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Template+variable+was+successfully+deleted.");
    break;
    case 'exportskin':
        //# Grabbing skin data
        $skinid = prepValue($_GET['skinid']);
        $grabskindata = $SQL->query("SELECT * FROM `".$database['prefix']."skins` WHERE `id` = '$skinid'");
        if($SQL->num_rowS($grabskindata) < 1){
            bb_error("Specified skin doesn't exist.");
        }
        $skin = $SQL->fetch_array($grabskindata);

        //# Generating header
        $output = "<skinheader>\n";
        $output .= "<skinname>".$skin['name']."</skinname>\n";
        $output .= "<skinauthor>".$skin['author']."</skinauthor>\n";
        $output .= "<skinversion>".$skin['skinversion']."</skinversion>\n";
        $output .= "<scriptversion>".$skin['scriptversion']."</scriptversion>\n";
        $output .= "</skinheader>\n";

        //# Generating template data
        $output .= "<skindata>\n";
        $grabtemplatedata = $SQL->query("SELECT * FROM `".$database['prefix']."templates` WHERE `skinid` = '$skinid' ORDER BY `id` ASC");
        while($temp = $SQL->fetch_array($grabtemplatedata)){
            $output .= "<querystring>INSERT INTO `%prefix%templates` (`id`, `skinid`, `label`, `template`) VALUES ('".$temp['id']."', '%skinid%', '".addslashes($temp['label'])."', '".addslashes($temp['template'])."')</querystring>\n";
        }
        $grabtempvardata = $SQL->query("SELECT * FROM `".$database['prefix']."tempvars` WHERE `skinid` = '$skinid'");
        while($var = $SQL->fetch_array($grabtempvardata)){
            $output .= "<querystring>INSERT INTO `%prefix%tempvars` (`id`, `skinid`, `scope`, `templateid`, `value`) VALUES ('".$var['id']."', '%skinid%', '".$var['scope']."', '".$var['templateid']."', '".addslashes($var['value'])."')</querystring>\n";
        }
        $output .= "</skindata>";

        //# Output headers
        header("Expires: ".gmdate("D, d M Y H:i:s", time()+60)." GMT");
        header("Last-Modified: ".gmdate("D, d M Y H:i:s", time())." GMT");
        header("Cache-Control: no-store, no-cache, must-revalidate");
        header("Cache-Control: post-check=0, pre-check=0", false);
        header("Pragma: no-cache");
        header("Content-Type: application/octet-stream");
        header("Content-Disposition: attachment; filename=".$skin['name'].".bbs");
        echo $output;
        die();
    break;
    case 'importskinform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Import Skin";

        eval("\$cpinclude = \"".$template->getTemplate('132')."\";");
    break;
    case 'importskin':
        if(!is_uploaded_file($_FILES['skinfile']['tmp_name'])){
           bb_error("Skin importation failed.");
        }

        $fp = fopen($_FILES['skinfile']['tmp_name'], "r");
        $data = fread($fp, filesize($_FILES['skinfile']['tmp_name']));
        fclose($fp);
        //# Skin type (pre 1.3.0, post 1.3.0)
        if(strpos($data, "<skinheader>") !== false){
            //# Header details
            preg_match("/\<skinname\>(.+)\<\/skinname\>/", $data, $skinname);
            $skinname = str_replace("<skinname>", "", $skinname[0]);
            $skinname = str_replace("</skinname>", "", $skinname);
            preg_match("/\<skinauthor\>(.+)\<\/skinauthor\>/", $data, $skinauthor);
            $skinauthor = str_replace("<skinauthor>", "", $skinauthor[0]);
            $skinauthor = str_replace("</skinauthor>", "", $skinauthor);
            preg_match("/\<skinversion\>(.+)\<\/skinversion\>/", $data, $skinversion);
            $skinversion = str_replace("<skinversion>", "", $skinversion[0]);
            $skinversion = str_replace("</skinversion>", "", $skinversion);
            preg_match("/\<scriptversion\>(.+)\<\/scriptversion\>/", $data, $scriptversion);
            $scriptversion = str_replace("<scriptversion>", "", $scriptversion[0]);
            $scriptversion = str_replace("</scriptversion>", "", $scriptversion);

            //# Data
            preg_match("/\<skindata\>(.+)\<\/skindata\>/s", $data, $skindata);
            $skindata = str_replace("<skindata>", "", $skindata[0]);
            $skindata = str_replace("</skindata>", "", $skindata);

            //# Creating skin
            $insertskin = $SQL->query("INSERT INTO `".$database['prefix']."skins` (`id`, `name`, `author`, `skinversion`, `scriptversion`) VALUES ('', '$skinname', '$skinauthor', '$skinversion', '$scriptversion')");
        } else {
            //# Header details
            preg_match("/\<skinname\>(.+?)\<\/skinname\>/", $data, $skinname);
            $skinname = str_replace("<skinname>", "", $skinname[0]);
            $skinname = str_replace("</skinname>", "", $skinname);

            //# Data
            preg_match("/\<skindata\>(.+?)\<\/skindata\>/", $data, $skindata);
            $skindata = str_replace("<skindata>", "", $skindata[0]);
            $skindata = str_replace("</skindata>", "", $skindata);

            //# Creating skin
            $insertskin = $SQL->query("INSERT INTO `".$database['prefix']."skins` (`id`, `name`) VALUES ('', '$skinname')");
        }

        //# Grabbing new skin details
        $grabskinid = $SQL->query("SELECT `id` FROM `".$database['prefix']."skins` ORDER BY `id` DESC LIMIT 1");
        $skin = $SQL->fetch_array($grabskinid);

        //# Running template and tempvar data queries
        $skindata = str_replace("%prefix%", $database['prefix'], $skindata);
        $skindata = str_replace("%skinid%", $skin['id'], $skindata);
        $queries = explode("</querystring>", $skindata);
        foreach($queries as $query){
            $query = str_replace("<querystring>", "", $query);
            if(strpos($query, "INSERT") != NULL){
                $insertdata = $SQL->query($query);
            }
        }
        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Skin+was+successfully+imported.");
    break;
    case 'deleteskin':
        $skinid = prepValue($_GET['skinid']);
        if($skinid == $config['skindefault']){
            bb_error("Can't delete the default skin. Please set a new default if you would like to delete this skin.");
        }
        $delskin = $SQL->query("DELETE FROM `".$database['prefix']."skins` WHERE `id` = '$skinid'");
        $deltemps = $SQL->query("DELETE FROM `".$database['prefix']."templates` WHERE `skinid` = '$skinid'");
        $delvars = $SQL->query("DELETE FROM `".$database['prefix']."tempvars` WHERE `skinid` = '$skinid'");

        $updateusers = $SQL->query("UPDATE `".$database['prefix']."users` SET `skin`='".$config['skindefault']."' WHERE `skin`='$skinid'");

        $_SESSION['acp_skinid'] = $config['skindefault'];

        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Skin+was+successfully+removed.");
    break;
    case 'createskinform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Create New Skin";

        //# Grabbing skins
        $skinarea = "";
        $grabskins = $SQL->query("SELECT * FROM `".$database['prefix']."skins` ORDER BY `name` DESC");
        while($skin = $SQL->fetch_array($grabskins)){
            if($skin['id'] == $skinid){
                $currentskin['id'] = $skin['id'];
                $currentskin['name'] = stripslashes($skin['name']);
            }
            $skinarea .= $template->getTemplate('127');
            $skinarea = stripslashes($skinarea);
            $skin['name'] = stripslashes($skin['name']);
            $skin['selected'] = "";
            $skinarea = $template->cacheArray($skinarea, $skin);
        }
        $skin = $template->releaseCache();
        eval("\$skinarea = \"".addslashes($skinarea)."\";");

        eval("\$cpinclude = \"".$template->getTemplate('133')."\";");
    break;
    case 'createskin':
        $skinname = prepValue($_POST['skinname']);
        $skinbase = prepValue($_POST['skinbase']);

        $createskin = $SQL->query("INSERT INTO `".$database['prefix']."skins` (`id`, `name`) VALUES ('', '$skinname')");
        $grabskinid = $SQL->query("SELECT * FROM `".$database['prefix']."skins` ORDER BY `id` DESC LIMIT 1");
        $skin = $SQL->fetch_array($grabskinid);
        $skinid = $skin['id'];

        $grabbasetemplates = $SQL->query("SELECT * FROM `".$database['prefix']."templates` WHERE `skinid` = '$skinbase' ORDER BY `id` ASC");
        while($temp = $SQL->fetch_array($grabbasetemplates)){
            $insert = $SQL->query("INSERT INTO `".$database['prefix']."templates` (`id`, `skinid`, `label`, `template`) VALUES ('".$temp['id']."', '$skinid', '".addslashes($temp['label'])."', '".addslashes($temp['template'])."')");
        }

        $grabbasetempvars = $SQL->query("SELECT * FROM `".$database['prefix']."tempvars` WHERE `skinid` = '$skinbase'");
        while($var = $SQL->fetch_array($grabbasetempvars)){
            $insert = $SQL->query("INSERT INTO `".$database['prefix']."tempvars` (`id`, `skinid`, `scope`, `templateid`, `value`) VALUES ('".$var['id']."', '$skinid', '".$var['scope']."', '".$var['templateid']."', '".addslashes($var['value'])."')");
        }

        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Skin+was+successfully+created.");
    break;
    case 'editskinform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Skin";

        $skinid = prepValue($_GET['skinid']);
        $grabskindata = $SQL->query("SELECT * FROM `".$database['prefix']."skins` WHERE `id` = '".$skinid."'");
        $skin = $SQL->fetch_array($grabskindata);
        eval("\$cpinclude = \"".$template->getTemplate('134')."\";");
    break;
    case 'editskin':
        $skinid = prepValue($_GET['skinid']);
        $name = prepValue($_POST['name']);
        $author = prepValue($_POST['author']);
        $skinversion = prepValue($_POST['skinversion']);
        $scriptversion = prepValue($_POST['scriptversion']);
        if($name == ""){
             bb_error("You didn't enter at least a skin name.");
        }
        $updateskin = $SQL->query("UPDATE `".$database['prefix']."skins` SET `name` = '$name', `author` = '$author', `skinversion` = '$skinversion', `scriptversion` = '$scriptversion' WHERE `id` = '$skinid'");
        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps&msg=Skin+was+successfully+updated.");
    break;
    default:
        die_header("Location: ".$config['boardurl']."admin-templates.php?a=managetemps");
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$include = \"".$template->templates['85']."\";");
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>