<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: admin-users.php,v 1.17 2005/07/06 00:25:57 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/

 
//# File ID
define("FILEID", "admin-users");

//# Templates:
$bb_templates = '1,12,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,143';
require("core.php");

if($user->userdata['admin_cp'] != 1){
    bb_error("You do not have permission to use the administrator control panel.");
}

$breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"admin-users.php\">AdminCP</a>";

//# Admin Message
if($_GET['msg'] != ""){
    $msg = str_replace("+", " ", $_GET['msg']);
    $msg = prepValue($msg);
    eval("\$admin_message = \"".$template->getTemplate('143')."\";");
}

//# Switchboard
switch(prepValue($_GET['a'])){
    case 'manageperms': //the page where it shows all of the forums and you click one
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Manage Permissions";

        $permq=$SQL->query("SELECT p.id, g.name AS gname, f.name AS fname
                            FROM `".$database['prefix']."permissions` AS p
                            LEFT JOIN `".$database['prefix']."usergroups` AS g ON(g.id=p.gid)
                            LEFT JOIN `".$database['prefix']."forums` AS f ON(f.id=p.fid)
                            ORDER BY p.id DESC");
        if($SQL->num_rows($permq)<=0){
            eval("\$permissions=\"".$template->templates['87']."\";");
        }else{
            $checks=0;
            while($perm=$SQL->fetch_array($permq)){
                $permissions.=stripslashes($template->templates['88']);
                $checks++;
                $permissions = $template->cacheArray($permissions, $perm);
            }
            $perm = $template->releaseCache();
            eval("\$permissions = \"".addslashes($permissions)."\";");
        }

        eval("\$cpinclude = \"".$template->templates['86']."\";");
        $user->updateActive("Managing Permissions");
    break;
    case 'editpermsform': //where you edit the permissiosn for a selected forum
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Permissions";

        $permnumq = $SQL->query("SELECT * FROM `".$database['prefix']."permissions`");
        $permnum = $SQL->num_rows($permnumq);
        $ids="";
        if($_GET['ids']!=""){
            $ids=prepValue($_GET['ids']);
        }else{
            for($i=0; $i<$permnum; $i++){
                if($_POST['n'.$i]!=""){
                    $ids.=$_POST['n'.$i].",";
                }
            }
            $ids=substr($ids, 0, -1);
        }

        if($ids==""){
            bb_error("You did not select any permissions to edit.");
        }
        
        if(isset($_POST['delete']) || $_POST['delete']!=""){
            die_header("Location: admin-users.php?a=deleteperms&ids=$ids");
        }

        $pids = str_replace(',', "','", $ids);

        $permq=$SQL->query("SELECT * FROM `".$database['prefix']."permissions` WHERE (`id` IN('$pids'))");
        while($perm=$SQL->fetch_array($permq)){
            $permopts.=stripslashes($template->templates['93']);

            foreach($perm as $key => $value){
                if($key != "id" && $key != "fid" && $key != "gid"){
                    if($value=='0' || $value==''){
                        $perm[$key]="selected";
                    }else if($value=='1'){
                        $perm[$key]="";
                    }
                }
            }

            $latestcid = "";
            $latestfid = "";
            $foptq = $SQL->query("SELECT c.id AS cid, c.name AS cname, c.class AS cclass, f.id AS fid, f.name AS fname, f.class AS fclass, s.id AS sid, s.name AS sname, s.class AS sclass FROM `".$database['prefix']."forums` AS c LEFT JOIN `".$database['prefix']."forums` AS f ON(f.parent = c.id AND f.class = 'forum') LEFT JOIN `".$database['prefix']."forums` AS s ON(s.parent = f.id AND s.class = 'subforum') WHERE c.class = 'category' ORDER BY c.order,f.order,f.id,s.order,s.id");
            while($grab = $SQL->fetch_array($foptq)){
                if($grab['cid'] != $latestcid && $grab['cid'] != ""){
                    $perm['foptions'] .= $template->templates['90'];
                    $perm['foptions'] = stripslashes($perm['foptions']);
                    $foption['name'] = $grab['cname'];
                    $foption['disabled'] = "disabled";
                    $perm['foptions'] = $template->cacheArray($perm['foptions'], $foption, "foptions");
                    $latestcid = $grab['cid'];
                    $foption['disabled'] = "";
                }
                if($grab['fid'] != $latestfid && $grab['fid'] != ""){
                    $perm['foptions'] .= $template->templates['90'];
                    $perm['foptions'] = stripslashes($perm['foptions']);
                    $foption['fid'] = $grab['fid'];
                    $foption['name'] = "&nbsp;&nbsp;&nbsp;".$grab['fname'];
                    if($foption['fid']==$perm['fid']){
                        $foption['selected']="selected";
                    }
                    $latestfid = $grab['fid'];
                    $perm['foptions'] = $template->cacheArray($perm['foptions'], $foption, "foptions");
                }
                $foption['selected']="";
                if($grab['sid'] != ""){
                    $perm['foptions'] .= $template->templates['90'];
                    $perm['foptions'] = stripslashes($perm['foptions']);
                    $foption['fid'] = $grab['sid'];
                    $foption['name'] = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".$grab['sname'];
                    if($foption['fid']==$perm['fid']){
                        $foption['selected']="selected";
                    }
                    $latestfid = $grab['fid'];
                    $perm['foptions'] = $template->cacheArray($perm['foptions'], $foption, "foptions");
                }
                $foption['selected']="";
            }
            $foption = $template->releaseCache("foptions");
            eval("\$perm[foptions] = \"".addslashes($perm['foptions'])."\";");

            $goptq=$SQL->query("SELECT `id`,`name` FROM `".$database['prefix']."usergroups` ORDER BY `id` DESC"); 
            while($goption=$SQL->fetch_array($goptq)){
                $perm['goptions'] .= $template->templates['91'];
                $perm['goptions'] = stripslashes($perm['goptions']);

                $goption['selected']="";
                $goption['name']=stripslashes($goption['name']);
                if($goption['id']==$perm['gid']){
                    $goption['selected']="selected";
                }
                $perm['goptions'] = $template->cacheArray($perm['goptions'], $goption, "goptions");
            }
            $goption = $template->releaseCache("goptions");
            eval("\$perm[goptions] = \"".addslashes($perm['goptions'])."\";");

            $permopts = $template->cacheArray($permopts, $perm);
        }
        $perm = $template->releaseCache();
        eval("\$permopts = \"".addslashes($permopts)."\";");

        eval("\$cpinclude = \"".$template->templates['92']."\";");
        $user->updateActive("Editing Permissions");
    break;
    case 'editperms': //edit is the action
        prepValue($_POST);

        if($_POST['ids']==""){
            bb_error("You did not select any permissions to edit.");
        }

        $pids = explode(',', $_POST['ids']);
        for($i=0; $i<count($pids); $i++){
            $SQL->query("UPDATE `".$database['prefix']."permissions` SET `fid`='".$_POST['fid'.$pids[$i]]."', `gid`='".$_POST['gid'.$pids[$i]]."', `view_topic`='".$_POST['view_topic'.$pids[$i]]."', `view_forum`='".$_POST['view_forum'.$pids[$i]]."', `post_reply`='".$_POST['post_reply'.$pids[$i]]."', `post_topic`='".$_POST['post_topic'.$pids[$i]]."', `post_poll`='".$_POST['post_poll'.$pids[$i]]."', `post_attachments`='".$_POST['post_attachments'.$pids[$i]]."', `vote_poll`='".$_POST['vote_poll'.$pids[$i]]."', `edit_own`='".$_POST['edit_own'.$pids[$i]]."', `edit_others`='".$_POST['edit_others'.$pids[$i]]."', `delete_own`='".$_POST['delete_own'.$pids[$i]]."', `delete_others`='".$_POST['delete_others'.$pids[$i]]."', `lock_topics`='".$_POST['lock_topics'.$pids[$i]]."', `stick_topics`='".$_POST['stick_topics'.$pids[$i]]."', `move_topics`='".$_POST['move_topics'.$pids[$i]]."', `use_locked`='".$_POST['use_locked'.$pids[$i]]."' WHERE `id`='".$pids[$i]."'");
        }

        die_header("Location: admin-users.php?a=manageperms&msg=Permssions+edited+succesfully");
    break;
    case 'addpermsform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Add Permissions";

        $latestcid = "";
        $latestfid = "";
        $foptq = $SQL->query("SELECT c.id AS cid, c.name AS cname, c.class AS cclass, f.id AS fid, f.name AS fname, f.class AS fclass, s.id AS sid, s.name AS sname, s.class AS sclass FROM `".$database['prefix']."forums` AS c LEFT JOIN `".$database['prefix']."forums` AS f ON(f.parent = c.id AND f.class = 'forum') LEFT JOIN `".$database['prefix']."forums` AS s ON(s.parent = f.id AND s.class = 'subforum') WHERE c.class = 'category' ORDER BY c.order,f.order,f.id,s.order,s.id");
        while($grab = $SQL->fetch_array($foptq)){
            if($grab['cid'] != $latestcid && $grab['cid'] != ""){
                $foptions .= $template->templates['90'];
                $foptions = stripslashes($foptions);
                $foption['name'] = $grab['cname'];
                $foption['disabled'] = "disabled";
                $foptions = $template->cacheArray($foptions, $foption);
                $latestcid = $grab['cid'];
                $foption['disabled'] = "";
            }
            if ($grab['fid'] != $latestfid && $grab['fid'] != "") {
                $foptions .= $template->templates['90'];
                $foptions = stripslashes($foptions);
                $foption['fid'] = $grab['fid'];
                $foption['name'] = "&nbsp;&nbsp;&nbsp;".$grab['fname'];
                $latestfid = $grab['fid'];
                $foptions = $template->cacheArray($foptions, $foption);
            }
            if ($grab['sid'] != "") {
                $foptions .= $template->templates['90'];
                $foptions = stripslashes($foptions);
                $foption['fid'] = $grab['sid'];
                $foption['name'] = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".$grab['sname'];
                $latestfid = $grab['fid'];
                $foptions = $template->cacheArray($foptions, $foption);
            }
        }
        $foption = $template->releaseCache();
        eval("\$foptions = \"".addslashes($foptions)."\";");

        $goptq=$SQL->query("SELECT `id`,`name` FROM `".$database['prefix']."usergroups` ORDER BY `id` DESC");
        while($goption=$SQL->fetch_array($goptq)){
            $goptions .= $template->templates['91'];
            $goptions = stripslashes($goptions);

            $goption['name']=stripslashes($goption['name']);
            $goptions = $template->cacheArray($goptions, $goption);
        }
        $goption = $template->releaseCache();
        eval("\$goptions = \"".addslashes($goptions)."\";");

        eval("\$cpinclude = \"".$template->templates['89']."\";");
        $user->updateActive("Adding Permissions");
    break;
    case 'addperms':
        $_POST=prepValue($_POST);
        $SQL->query("INSERT INTO `".$database['prefix']."permissions` (`id`, `fid`, `gid`, `view_topic`, `view_forum`, `post_reply`, `post_topic`, `post_poll`, `post_attachments`, `vote_poll`, `edit_own`, `edit_others`, `delete_own`, `delete_others`, `lock_topics`, `stick_topics`, `move_topics`, `use_locked`) VALUES('', '".$_POST['fid']."', '".$_POST['gid']."', '".$_POST['view_topic']."', '".$_POST['view_forum']."', '".$_POST['post_reply']."', '".$_POST['post_topic']."', '".$_POST['post_poll']."', '".$_POST['post_attachments']."', '".$_POST['vote_poll']."', '".$_POST['edit_own']."', '".$_POST['edit_others']."', '".$_POST['delete_own']."', '".$_POST['delete_others']."', '".$_POST['lock_topics']."', '".$_POST['stick_topics']."', '".$_POST['move_topics']."', '".$_POST['use_locked']."')");

        die_header("Location: admin-users.php?a=manageperms&msg=Permssions+added+succesfully");
    break;
    case 'deleteperms':
        $pids = prepValue($_GET['ids']);

        if($pids==""){
            bb_error("You did not select any permissions to delete.");
        }

        $pids = str_replace(',', "','", $pids);
        $SQL->query("DELETE FROM `".$database['prefix']."permissions` WHERE (`id` IN('$pids'))");
        
        die_header("Location: admin-users.php?a=manageperms&msg=Permssions+deleted+succesfully");
    break;
    case 'manageuser':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Manage Users";

        eval("\$cpinclude = \"".$template->templates['94']."\";");
        $user->updateActive("Managing Users");
    break;
    case 'edituserform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Users";

        $username=prepValue($_POST['user']);
        if($username==""){
            $username=prepValue($_GET['user']);
            if($username==""){
                bb_error("You did specify a user to edit.");
            }
        }

        $exist=$SQL->query("SELECT * FROM `".$database['prefix']."users` WHERE `username`='$username'");
        if($SQL->num_rows($exist)<=0){
            bb_error("The user you specified does not exist.");
        }
        $userdata=$SQL->fetch_array($exist);

        $goptq=$SQL->query("SELECT `id`,`name` FROM `".$database['prefix']."usergroups` ORDER BY `id` DESC"); 
        while($goption=$SQL->fetch_array($goptq)){
            $userdata['goptions'] .= $template->templates['91'];
            $userdata['goptions'] = stripslashes($userdata['goptions']);

            $goption['selected']="";
            $goption['name']=stripslashes($goption['name']);
            if($goption['id']==$userdata['gid']){
                $goption['selected']="selected";
            }
            $userdata['goptions'] = $template->cacheArray($userdata['goptions'], $goption, "goptions");
        }
        $goption = $template->releaseCache("goptions");
        eval("\$userdata[goptions] = \"".addslashes($userdata['goptions'])."\";");

        $soptq=$SQL->query("SELECT * FROM `".$database['prefix']."skins` ORDER BY `id` DESC"); 
        while($soption=$SQL->fetch_array($soptq)){
            $userdata['soptions'] .= $template->templates['96'];
            $userdata['soptions'] = stripslashes($userdata['soptions']);

            $soption['selected']="";
            $soption['name']=stripslashes($soption['name']);
            if($soption['id']==$userdata['skin']){
                $soption['selected']="selected";
            }
            $userdata['soptions'] = $template->cacheArray($userdata['soptions'], $soption, "soptions");
        }
        $soption = $template->releaseCache("soptions");
        eval("\$userdata[soptions] = \"".addslashes($userdata['soptions'])."\";");

        $day[$userdata['bday']] = "selected";
        $month[$userdata['bmonth']] = "selected";

        $userdata['offset'] = "n" . $userdata['offset'];
        $userdata['offset'] = str_replace("-", "minus", $userdata['offset']);
        $userdata['offset'] = str_replace(".", "point", $userdata['offset']);
        $offset[$userdata['offset']] = "selected";

        $parseurls[$userdata['parseurls']] = "selected";
        $viewsiggies[$userdata['viewsiggies']] = "selected";
        $viewavatars[$userdata['viewavatars']] = "selected";
        $viewhistory[$userdata['viewhistory']] = "selected";
        $subscribe[$userdata['subscribe']] = "selected";
        $emailifpm[$userdata['emailifpm']] = "selected";
        $notificationifpm[$userdata['notificationifpm']] = "selected";
        $hideemail[$userdata['hideemail']] = "selected";
        $censor[$userdata['censor']] = "selected";
        $disableemoticons[$userdata['disableemoticons']] = "selected";
        $banned[$userdata['banned']] = "selected";

        $avrules['kilobytes'] = round($config['avatarbytes'] / 1024,2);
        $extensions = explode(",",$config['avatarextensions']);
        $extnum = count($extensions);
        for ($loop = 0; $loop < $extnum; $loop ++) {
            $extensions[$loop] = substr($extensions[$loop],1);
            $avrules['extensions'] .= "<b>" . $extensions[$loop] . "</b>";
            if (($loop + 1) != $extnum) {
                $avrules['extensions'] .= ", ";
            }
            if (($loop + 2) == $extnum) {
                $avrules['extensions'] .= "and ";
            }
        }

        if(file_exists($config[avatarpath] . $userdata['avatar'])){
            $userdata['avatar'] = $config[avatarpath] . $userdata['avatar'];
        }

        eval("\$cpinclude = \"".$template->templates['95']."\";");
        $user->updateActive("Editing a User");
    break;
    case 'edituser':
        $id = prepValue($_GET['id']);
        $password = md5($_POST['pass1']);
        $_POST=prepValue($_POST);

        $exist = $SQL->query("SELECT `id` FROM `".$database['prefix']."users` WHERE `id`='$id'");
        if($SQL->num_rows($exist)<=0){
            bb_error("The specified user does not exist.");
        }
        $users = $SQL->fetch_array($exist);

        if($_POST['avatarurl'] != "" && $_FILES['avatar']['name'] != ""){
            bb_error("You can only upload or link to a file. You cannot do both.");
        }

        if ($_FILES['avatar']['name'] != "") {
            if ($_FILES['avatar']['size'] > $config['avatarbytes']) {
                bb_error("The file is to large, the maximum size is <b>" . $config['avatarbytes'] . "</b> bytes.");
            }
            $ext = strtolower(substr($_FILES['avatar']['name'], strrpos($_FILES['avatar']['name'], ".")));
            $allowedexts = explode(',', $config['uploadext']);
            $allowed = 0;
            foreach($allowedexts as $exts){
                if ($ext == $exts) {
                    $allowed = 1;
                }
            }
            if ($allowed != 1) {
                bb_error("The extension is not allowed.");
            }

            $path = str_replace("admin-users.php", $config['avatarpath'], $_SERVER['SCRIPT_FILENAME']);
            $avatar = $path . $users['id'] . $ext;
            $file = $users['id'] . $ext;
            if (!move_uploaded_file($_FILES['avatar']['tmp_name'], $avatar)) {
                bb_error("The file is to large, the maximum size is <b>" . $config['avatarbytes'] . "</b> bytes.");
            }
            list($width, $height) = getimagesize($file);
            if ($width > $config['avatarwidth'] || $height > $config['avatarheight']) {
                unlink($file);
                bb_error("The dimensions of the image are too large.");
            }
            $existcheck = explode(",",$config['avatarextensions']);
            foreach($existcheck as $exts) {
                if ($exts != $ext) {
                    if (is_file($config['avatarpath'] . $users['id'] . $exts)) {
                        unlink($config['avatarpath'] . $users['id'] . $exts);
                    }
                }
            }
            $_POST['avatar'] = $users['id'] . $ext;
        }else if($_POST['avatarurl'] != ""){
            $avatar = $_POST['avatarurl'];
            $ext = substr($avatar, strrpos($avatar, "."));
            $allowedexts = explode(',', $config['uploadext']);
            $allowed = 0;
            foreach($allowedexts as $exts){
                if ($ext == $exts) {
                    $allowed = 1;
                }
            }
            if ($allowed != 1) {
                bb_error("The extension is not allowed.");
            }
            list($width, $height) = getimagesize($avatar);
            if ($width > $config['avatarwidth'] || $height > $config['avatarheight']) {
                bb_error("The dimensions of the image are too large.");
            }
            $existcheck = explode(",",$config['avatarextensions']);
            foreach($existcheck as $exts) {
                if (is_file($config['avatarpath'] . $users['id'] . $exts)) {
                    unlink($config['avatarpath'] . $users['id'] . $exts);
                }
            }
            $_POST['avatar'] = $_POST['avatarurl'];
        }

        if($_POST['pass1'] != "" || $_POST['pass2'] != ""){
            if($_POST['pass1'] != $_POST['pass2']){
                bb_error("The new passwords did not match.");
            }
            $passq = "`password`='$password',";
        }

        if($_POST['avatarurl'] != "" || $_FILES['avatar']['name'] != ""){
            $avq = "`avatar`='".$_POST['avatar']."',";
        }

        $SQL->query("UPDATE `".$database['prefix']."users` SET 
                    `gid`='".$_POST['gid']."', `skin`='".$_POST['skin']."', `username`='".$_POST['username']."',
                    $passq `email`='".$_POST['email']."', $avq
                    `title`='".$_POST['title']."', `location`='".$_POST['location']."', `interests`='".$_POST['interests']."',
                    `occupation`='".$_POST['occupation']."', `pagename`='".$_POST['pagename']."', `pageurl`='".$_POST['pageurl']."',
                    `aim`='".$_POST['aim']."', `icq`='".$_POST['icq']."', `msn`='".$_POST['msn']."',
                    `yim`='".$_POST['yim']."', `bday`='".$_POST['bday']."', `bmonth`='".$_POST['bmonth']."',
                    `byear`='".$_POST['byear']."', `signature`='".$_POST['signature']."', `offset`='".$_POST['offset']."',
                    `parseurls`='".$_POST['parseurls']."', `viewsiggies`='".$_POST['viewsiggies']."', `viewavatars`='".$_POST['viewavatars']."',
                    `viewhistory`='".$_POST['viewhistory']."', `subscribe`='".$_POST['subscribe']."', `emailifpm`='".$_POST['emailifpm']."',
                    `notificationifpm`='".$_POST['notificationifpm']."', `hideemail`='".$_POST['hideemail']."', `censor`='".$_POST['censor']."',
                    `disableemoticons`='".$_POST['disableemoticons']."', `posts`='".$_POST['posts']."', `postsperpage`='".$_POST['postsperpage']."',
                    `topicsperpage`='".$_POST['topicsperpage']."', `membersperpage`='".$_POST['membersperpage']."', `banned`='".$_POST['banned']."' WHERE `id`='$id'");

         die_header("Location: admin-users.php?a=manageuser&msg=User+edited+successfully");
    break;
    case 'deleteuser':
        $username=prepValue($_GET['user']);
        if($username==""){
            $username=prepValue($_POST['user']);
            if($username==""){
                bb_error("You did specify a user to delete.");
            }
        }

        $exist=$SQL->query("SELECT `id`,`avatar` FROM `".$database['prefix']."users` WHERE `username`='$username'");
        if($SQL->num_rows($exist)<=0){
            bb_error("The user you specified does not exist.");
        }

        $avatar = $SQL->fetch_array($exist);
        if(file_exists($config['avatarpath'].$avatar['avatar']) && $avatar['avatar']!=""){
            unlink($config['avatarpath'].$avatar['avatar']);
        }

        $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `members`=members-1");
        $wasnew = $SQL->query("SELECT `newestuid` FROM `".$database['prefix']."boardstats` WHERE `newestuser`='$username'");
        if($SQL->num_rows($wasnew) > 0){
            $newestq = $SQL->query("SELECT `id`,`username` FROM `".$database['prefix']."users` WHERE `active`='1' ORDER BY `joindate` DESC LIMIT 1");
            if($SQL->num_rows($newestq) > 0){
                $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `newestuid`=NULL `newestuser`=NULL");
            }else{
                $newest = $SQL->fetch_array($newestq);
                $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `newestuid`='".$newest['id']."' `newestuser`='".$newest['username']."'");
            }
        }

        $SQL->query("DELETE FROM `".$database['prefix']."users` WHERE `username`='$username' LIMIT 1");
        die_header("Location: admin-users.php?a=manageuser&msg=$username+was+succesfully+deleted");
    break;
    case 'manageusergroups':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Manage Usergroups";

        $groupq=$SQL->query("SELECT `id`,`name`,`style` FROM `".$database['prefix']."usergroups` ORDER BY `id` ASC");
        if($SQL->num_rows($groupq)<=0){
            eval("\$groups=\"".$template->templates['98']."\";");
        }else{
            $checks=0;
            while($group=$SQL->fetch_array($groupq)){
                $groups.=stripslashes($template->templates['99']);
                $checks++;
                $groups = $template->cacheArray($groups, $group);
            }
            $group = $template->releaseCache();
            eval("\$groups = \"".addslashes($groups)."\";");
        }

        eval("\$cpinclude = \"".$template->templates['97']."\";");
        $user->updateActive("Managing Usergroups");
    break;
    case 'editusergroupsform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit Usergroups";

        $groupnumq = $SQL->query("SELECT * FROM `".$database['prefix']."usergroups`");
        $groupnum = $SQL->num_rows($groupnumq);
        $ids="";
        if($_GET['ids']!=""){
            $ids=prepValue($_GET['ids']);
        }else{
            for($i=0; $i<$groupnum; $i++){
                if($_POST['n'.$i]!=""){
                    $ids.=$_POST['n'.$i].",";
                }
            }
            $ids=substr($ids, 0, -1);
        }

        if($ids==""){
            bb_error("You did not select any usergroups to edit.");
        }
        
        if(isset($_POST['delete']) || $_POST['delete']!=""){
            die_header("Location: admin-users.php?a=deleteusergroups&ids=$ids");
        }

        $gids = str_replace(',', "','", $ids);

        $groupq=$SQL->query("SELECT * FROM `".$database['prefix']."usergroups` WHERE (`id` IN('$gids'))");
        while($group=$SQL->fetch_array($groupq)){
            $groupopts.=stripslashes($template->templates['101']);

            foreach($group as $key => $value){
                if($key != "id" && $key != "style" && $key != "name" && $key != "navtemp"){
                    if($value=='0' || $value==''){
                        $group[$key]="selected";
                    }else if($value=='1'){
                        $group[$key]="";
                    }
                }
            }
            $groupopts = $template->cacheArray($groupopts, $group);
        }
        $group = $template->releaseCache();
        eval("\$groupopts = \"".addslashes($groupopts)."\";");

        eval("\$cpinclude = \"".$template->templates['100']."\";");
        $user->updateActive("Editing a Usergroup");
    break;
    case 'editusergroups':
        prepValue($_POST);

        if($_POST['ids']==""){
            bb_error("You did not select any usergroups to edit.");
        }

        $gids = explode(',', $_POST['ids']);
        for($i=0; $i<count($gids); $i++){
            $SQL->query("UPDATE `".$database['prefix']."usergroups` SET 
                        `name`='".$_POST['name'.$gids[$i]]."', `style`='".$_POST['style'.$gids[$i]]."', `view_topic`='".$_POST['view_topic'.$gids[$i]]."',
                        `view_forum`='".$_POST['view_forum'.$gids[$i]]."', `post_reply`='".$_POST['post_reply'.$gids[$i]]."', `post_topic`='".$_POST['post_topic'.$gids[$i]]."',
                        `post_poll`='".$_POST['post_poll'.$gids[$i]]."', `post_attachments`='".$_POST['post_attachments'.$gids[$i]]."', `vote_poll`='".$_POST['vote_poll'.$gids[$i]]."',
                        `edit_own`='".$_POST['edit_own'.$gids[$i]]."', `edit_others`='".$_POST['edit_others'.$gids[$i]]."', `delete_own`='".$_POST['delete_own'.$gids[$i]]."',
                        `delete_others`='".$_POST['delete_others'.$gids[$i]]."', `lock_topics`='".$_POST['lock_topics'.$gids[$i]]."', `stick_topics`='".$_POST['stick_topics'.$gids[$i]]."',
                        `move_topics`='".$_POST['move_topics'.$gids[$i]]."', `use_locked`='".$_POST['use_locked'.$gids[$i]]."', `admin_cp`='".$_POST['admin_cp'.$gids[$i]]."',
                        `view_ip`='".$_POST['view_ip'.$gids[$i]]."', `navtemp`='".$_POST['navtemp'.$gids[$i]]."' WHERE `id`='".$gids[$i]."'");
        }

        die_header("Location: admin-users.php?a=manageusergroups&msg=Usergroups+edited+succesfully");
    break;
    case 'addusergroupsform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Add Usergroups";

        eval("\$cpinclude = \"".$template->templates['102']."\";");
        $user->updateActive("Adding a Usergroup");
    break;
    case 'addusergroups':
        $_POST=prepValue($_POST);
        $SQL->query("INSERT INTO `".$database['prefix']."usergroups` (`id`, `name`, `style`, `view_topic`, `view_forum`, `post_reply`, `post_topic`, `post_poll`, `post_attachments`, `vote_poll`, `edit_own`, `edit_others`, `delete_own`, `delete_others`, `lock_topics`, `stick_topics`, `move_topics`, `use_locked`, `view_ip`, `admin_cp`, `navtemp`) VALUES('', '".$_POST['name']."', '".$_POST['style']."', '".$_POST['view_topic']."', '".$_POST['view_forum']."', '".$_POST['post_reply']."', '".$_POST['post_topic']."', '".$_POST['post_poll']."', '".$_POST['post_attachments']."', '".$_POST['vote_poll']."', '".$_POST['edit_own']."', '".$_POST['edit_others']."', '".$_POST['delete_own']."', '".$_POST['delete_others']."', '".$_POST['lock_topics']."', '".$_POST['stick_topics']."', '".$_POST['move_topics']."', '".$_POST['use_locked']."', '".$_POST['view_ip']."', '".$_POST['admin_cp']."', '".$_POST['navtemp']."')");

        die_header("Location: admin-users.php?a=manageusergroups&msg=Usergroup+added+succesfully");
    break;
    case 'deleteusergroups':
        $gids = prepValue($_GET['ids']);

        if($gids==""){
            bb_error("You did not select any usergroups to delete.");
        }

        $gids = str_replace(',', "','", $gids);
        $SQL->query("DELETE FROM `".$database['prefix']."usergroups` WHERE (`id` IN('$gids'))");
        
        die_header("Location: admin-users.php?a=manageusergroups&msg=Usergroups+deleted+succesfully");
    break;
    case 'awaitingactivationform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Users Awaiting Activation";

        $awaitq=$SQL->query("SELECT `id`,`username` FROM `".$database['prefix']."users` WHERE `active`='0' ORDER BY `id` ASC");
        if($SQL->num_rows($awaitq)<=0){
            eval("\$awaiting=\"".$template->templates['104']."\";");
        }else{
            $checks=0;
            while($await=$SQL->fetch_array($awaitq)){
                $awaiting.=stripslashes($template->templates['105']);
                $checks++;
                $awaiting = $template->cacheArray($awaiting, $await);
            }
            $await = $template->releaseCache();
            eval("\$awaiting = \"".addslashes($awaiting)."\";");
        }

        eval("\$cpinclude = \"".$template->templates['103']."\";");
        $user->updateActive("Managing Users that are Awaiting Activation");
    break;
    case 'awaitingactivation':
        $awaitnumq = $SQL->query("SELECT * FROM `".$database['prefix']."users` WHERE `active`='0'");
        $awaitnum = $SQL->num_rows($awaitnumq);
        $ids="";
        if($_GET['ids']!=""){
            $ids=prepValue($_GET['ids']);
        }else{
            for($i=0; $i<$awaitnum; $i++){
                if($_POST['n'.$i]!=""){
                    $ids.=$_POST['n'.$i].",";
                }
            }
            $ids=substr($ids, 0, -1);
        }

        if($ids==""){
            bb_error("You did not select any users to activate.");
        }
        
        $uids = explode(",", $ids);
        foreach($uids as $uid){
            $mailinfo = $SQL->query("SELECT `username`,`email` FROM `".$database['prefix']."users` WHERE `id`='$uid'");
            $mail = $SQL->fetch_array($mailinfo);

            if(isset($_POST['activate']) || $_POST['activate']!=""){
                $updateq = $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `members` = `members`+1, `newestuid`='$uid', `newestuser` = '".$mail['username']."'");
                $config['emailapprove'] = str_replace("%boardurl%", $config['boardurl'], $config['emailapprove']);
                bb_sendmail($mail['email'], "Your account on ".$config['boardname']." has been activated", $config['emailapprove']);
            }else{
                $config['emaildecline'] = str_replace("%boardurl%", $config['boardurl'], $config['emaildecline']);
                bb_sendmail($mail['email'], "Your account on ".$config['boardname']." has been denied", $config['emaildecline']);
            }
        }

        if(isset($_POST['delete']) || $_POST['delete']!=""){
            die_header("Location: admin-users.php?a=deleteusers&ids=$ids");
        }

        $ids = str_replace(',', "','", $ids);
        $SQL->query("UPDATE `".$database['prefix']."users` SET `active`='1' WHERE (`id` IN('$ids'))");

        die_header("Location: admin-users.php?a=awaitingactivationform&msg=Users+activated+succesfully");
    break;
    case 'deleteusers':
        $ids = prepValue($_GET['ids']);

        if($ids==""){
            bb_error("You did not select any users to delete.");
        }

        $ids = str_replace(',', "','", $ids);

        $avatarq = $SQL->query("SELECT `avatar` FROM `".$database['prefix']."users` WHERE (`id` IN('$rids'))");
        while($avatar = $SQL->fetch_array($avatarq)){
            if(file_exists($config['avatarpath'].$avatar['avatar']) && $avatar['avatar']!=""){
                unlink($config['avatarpath'].$avatar['avatar']);
            }
        }

        $SQL->query("DELETE FROM `".$database['prefix']."users` WHERE (`id` IN('$ids'))");

        $wasnew = $SQL->query("SELECT `newestuid` FROM `".$database['prefix']."boardstats` WHERE (`newestuid` IN('$ids'))");
        if($SQL->num_rows($wasnew) > 0){
            $newestq = $SQL->query("SELECT `id`,`username` FROM `".$database['prefix']."users` WHERE `active`='1' ORDER BY `joindate` DESC LIMIT 1");
            if($SQL->num_rows($newestq) > 0){
                $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `newestuid`=NULL `newestuser`=NULL");
            }else{
                $newest = $SQL->fetch_array($newestq);
                $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `newestuid`='".$newest['id']."' `newestuser`='".$newest['username']."'");
            }
        }

        die_header("Location: admin-users.php?a=manageuser&msg=User+deleted+succesfully");
    break;
    case 'manageuserranks':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Manage User Ranks";

        $rankq=$SQL->query("SELECT r.id, r.title, g.name AS gname FROM `".$database['prefix']."userranks` AS r LEFT JOIN `".$database['prefix']."usergroups` AS g ON(g.id = r.gid) ORDER BY r.id DESC");
        if($SQL->num_rows($rankq)<=0){
            eval("\$ranks=\"".$template->templates['107']."\";");
        }else{
            $checks=0;
            while($rank=$SQL->fetch_array($rankq)){
                $ranks.=stripslashes($template->templates['108']);
                $checks++;
                $ranks = $template->cacheArray($ranks, $rank);
            }
            $rank = $template->releaseCache();
            eval("\$ranks = \"".addslashes($ranks)."\";");
        }

        eval("\$cpinclude = \"".$template->templates['106']."\";");
        $user->updateActive("Managing Userranks");
    break;
    case 'edituserranksform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Edit User Ranks";

        $ranknumq = $SQL->query("SELECT * FROM `".$database['prefix']."userranks`");
        $ranknum = $SQL->num_rows($ranknumq);
        $ids="";
        if($_GET['ids']!=""){
            $ids=prepValue($_GET['ids']);
        }else{
            for($i=0; $i<$ranknum; $i++){
                if($_POST['n'.$i]!=""){
                    $ids.=$_POST['n'.$i].",";
                }
            }
            $ids=substr($ids, 0, -1);
        }

        if($ids==""){
            bb_error("You did not select any user ranks to edit.");
        }
        
        if(isset($_POST['delete']) || $_POST['delete']!=""){
            die_header("Location: admin-users.php?a=deleteuserranks&ids=$ids");
        }

        $gids = str_replace(',', "','", $ids);

        $rankq=$SQL->query("SELECT * FROM `".$database['prefix']."userranks` WHERE (`id` IN('$gids'))");
        while($rank=$SQL->fetch_array($rankq)){
            $rankopts.=stripslashes($template->templates['110']);

            $goptq=$SQL->query("SELECT `id`,`name` FROM `".$database['prefix']."usergroups` ORDER BY `id` DESC"); 
            while($goption=$SQL->fetch_array($goptq)){
                $rank['goptions'] .= $template->templates['91'];
                $rank['goptions'] = stripslashes($rank['goptions']);

                $goption['selected']="";
                $goption['name']=stripslashes($goption['name']);
                if($goption['id']==$rank['gid']){
                    $goption['selected']="selected";
                }
                $rank['goptions'] = $template->cacheArray($rank['goptions'], $goption, "goptions");
            }
            $goption = $template->releaseCache("goptions");
            eval("\$rank[goptions] = \"".addslashes($rank['goptions'])."\";");

            $rank['dispimage'] = $template->getVar('imagepath') . $rank['image'];

            $rankopts = $template->cacheArray($rankopts, $rank);
        }
        $rank = $template->releaseCache();
        eval("\$rankopts = \"".addslashes($rankopts)."\";");

        eval("\$cpinclude = \"".$template->templates['109']."\";");
        $user->updateActive("Editing a Usergroup");
    break;
    case 'edituserranks':
        prepValue($_POST);

        if($_POST['ids']==""){
            bb_error("You did not select any user ranks to edit.");
        }

        $rids = explode(',', $_POST['ids']);
        for($i=0; $i<count($rids); $i++){
            if($_FILES['image'.$rids[$i]]['name']!=""){
                $path = str_replace("admin-users.php", $template->getVar('imagepath'), $_SERVER['SCRIPT_FILENAME']);
                $file = $path . str_replace(' ', '', strtolower(basename($_FILES['image'.$rids[$i]]['name'])));
                $filename = str_replace(' ', '', strtolower(basename($_FILES['image'.$rids[$i]]['name'])));

                if(file_exists($template->getVar('imagepath').$filename)){
                    bb_error("A file with that name already exists. Please rename it, and upload again.");
                }

                $oldnameq = $SQL->query("SELECT `image` FROM `".$database['prefix']."userranks` WHERE `id`='".$rids[$i]."'");
                $oldname = $SQL->fetch_array($oldnameq);
                if(file_exists($template->getVar('imagepath').$oldname['image']) && $oldname['image']!=""){
                    unlink($template->getVar('imagepath').$oldname['image']);
                }

                if(!is_writable($template->getVar('imagepath'))){
                    bb_error("The directory ".$template->getVar('imagepath')." is not writable. Please chmod it to 777 using ftp.");
                }

                if(!move_uploaded_file($_FILES['image'.$rids[$i]]['tmp_name'], $file)){
                    bb_error("An unexpected error has occured with the file upload, please try again.");
                }

                $SQL->query("UPDATE `".$database['prefix']."userranks` SET `gid`='".$_POST['gid'.$rids[$i]]."', `title`='".$_POST['title'.$rids[$i]]."', `image`='$filename', `minposts`='".$_POST['minposts'.$rids[$i]]."', `maxposts`='".$_POST['maxposts'.$rids[$i]]."' WHERE `id`='".$rids[$i]."'");
            }else{
                $SQL->query("UPDATE `".$database['prefix']."userranks` SET `gid`='".$_POST['gid'.$rids[$i]]."', `title`='".$_POST['title'.$rids[$i]]."', `minposts`='".$_POST['minposts'.$rids[$i]]."', `maxposts`='".$_POST['maxposts'.$rids[$i]]."' WHERE `id`='".$rids[$i]."'");
            }
        }

        die_header("Location: admin-users.php?a=manageuserranks&msg=User+ranks+edited+succesfully");
    break;
    case 'adduserranksform':
        $breadcrumbs .= $template->getVar('crumbsseperator') . "Add User Ranks";

        $goptq=$SQL->query("SELECT `id`,`name` FROM `".$database['prefix']."usergroups` ORDER BY `id` DESC"); 
        while($goption=$SQL->fetch_array($goptq)){
            $rank['goptions'] .= $template->templates['91'];
            $rank['goptions'] = stripslashes($rank['goptions']);

            $goption['name']=stripslashes($goption['name']);
            $rank['goptions'] = $template->cacheArray($rank['goptions'], $goption, "goptions");
        }
        $goption = $template->releaseCache("goptions");
        eval("\$rank[goptions] = \"".addslashes($rank['goptions'])."\";");

        $rank['imagepath'] = $template->getVar('imagepath');

        eval("\$cpinclude = \"".$template->templates['111']."\";");
        $user->updateActive("Adding a Usergroup");
    break;
    case 'adduserranks':
        $_POST=prepValue($_POST);

        if($_FILES['image']['name']!=""){
            $path = str_replace("admin-users.php", $template->getVar('imagepath'), $_SERVER['SCRIPT_FILENAME']);
            $file = $path . str_replace(' ', '', strtolower(basename($_FILES['image']['name'])));
            $filename = str_replace(' ', '', strtolower(basename($_FILES['image']['name'])));

            if(file_exists($template->getVar('imagepath').$filename)){
                bb_error("A file with that name already exists. Please rename it, and upload again.");
            }

            if(!is_writable($template->getVar('imagepath'))){
                bb_error("The directory ".$template->getVar('imagepath')." is not writable. Please chmod it to 777 using ftp.");
            }

            if(!move_uploaded_file($_FILES['image']['tmp_name'], $file)){
                bb_error("An unexpected error has occured with the file upload, please try again.");
            }

            $_POST['image'] = $filename;
        }

        $SQL->query("INSERT INTO `".$database['prefix']."userranks` (`id`, `gid`, `title`, `image`, `minposts`, `maxposts`) VALUES('', '".$_POST['gid']."', '".$_POST['title']."', '".$_POST['image']."', '".$_POST['minposts']."', '".$_POST['maxposts']."')");

        die_header("Location: admin-users.php?a=manageuserranks&msg=User+rank+added+succesfully");
    break;
    case 'deleteuserranks':
        $rids = prepValue($_GET['ids']);

        if($rids==""){
            bb_error("You did not select any user ranks to delete.");
        }

        $rids = str_replace(',', "','", $rids);

        $rankimgq = $SQL->query("SELECT `image` FROM `".$database['prefix']."userranks` WHERE (`id` IN('$rids'))");
        while($rankimg = $SQL->fetch_array($rankimgq)){
            if(file_exists($template->getVar('imagepath').$rankimg['image']) && $rankimg['image']!=""){
                unlink($template->getVar('imagepath').$rankimg['image']);
            }
        }

        $SQL->query("DELETE FROM `".$database['prefix']."userranks` WHERE (`id` IN('$rids'))");

        die_header("Location: admin-users.php?a=manageuserranks&msg=User+ranks+deleted+succesfully");
    break;
    default:
        die_header("Location: admin-users.php?a=manageuser");
    break;
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$include = \"".$template->templates['85']."\";");
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>