<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: board.php,v 1.18 2005/06/29 17:59:34 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "board");

//# Templates:
$bb_templates = '1,3,4,5,6,12,15,16,12,17,27,28,29,60';
require("core.php");

if(isset($_GET['fid'])){
    $fid = prepValue($_GET['fid']);
    if ($fid == "" || !is_numeric($fid)) {
        $fid = 1;
    }
    $fid = round($fid);

    //# Grabbing forum id, name, and type
    $forumq = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS c ON(f.parent = c.id) WHERE f.id='$fid'");
    $exist = $SQL->num_rows($forumq);
    if($exist <= 0){
        bb_error("The forum specified does not exist.");
    }
    $forum = $SQL->fetch_array($forumq);

    //# Breadcrumbs
    if($forum['class'] == "subforum"){
        $forumq = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname,p.id AS pid, p.name AS pname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS p ON(p.id=f.parent) LEFT JOIN `".$database['prefix']."forums` AS c ON(p.parent = c.id) WHERE f.id='$fid'");
        $forum = $SQL->fetch_array($forumq);
        $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$forum[cid]\">$forum[cname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$forum[pid]\">$forum[pname]</a>" . $template->getVar('crumbsseperator') . "$forum[name]";
    } else {
        $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$forum[cid]\">$forum[cname]</a>" . $template->getVar('crumbsseperator') . "$forum[name]";
    }

    //# Grabbing forum permissions
    $user->setForumPerms($fid);

    if($user->getData('view_forum') != 1){
        bb_error("You are not allowed to view this forum.");
    }

    //# Setting unread topics session var
    $time = time();
    $unreadtopics = unserialize($_SESSION['bbunreadtopics']);
    $searchunread = $SQL->query("SELECT `id`, `fid`, `lpdate`, `lpuserid` FROM `".$database['prefix']."topics` WHERE `fid` = '$fid' AND `lpdate` > ".$user->getForumData($fid));
    while($unread = $SQL->fetch_array($searchunread)){
        if($unread['lpuserid'] != $user->getData('id') || ($unread['lpuserid'] == $user->getData('id') && $user->getData('id') == 0)){
            $unreadtopics[$unread['fid']][$unread['id']] = $time;
        }
    }
    $_SESSION['bbunreadtopics'] = serialize($unreadtopics);

    //# Grabbing subforums
    if($forum['class'] != "subforum"){
        $bakforum = $forum;
        $grabsub = $SQL->query("SELECT f.*,u.gid,g.style AS lpuserstyle FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."users` AS u ON (u.id = f.lpuserid) LEFT JOIN `".$database['prefix']."usergroups` AS g ON(g.id = u.gid) WHERE f.parent = '$fid' AND f.class = 'subforum' ORDER BY f.order");
        if($SQL->num_rows($grabsub) > 0){
            $category['id'] = "0&fid=$fid";
            $category['name'] = $forum['name'];
            while($forum = $SQL->fetch_array($grabsub)){
                $forums .= stripslashes($template->templates['4']);
                if($forum['lpdate'] == NULL){
                    $forums = str_replace('$forum[lastpost]', stripslashes($template->templates['6']), $forums);
                    $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconoff');
                } else {
                    //setting icon that says whether or not there's unread posts in the forum
                    if(($user->getForumData($forum['id']) < $forum['lpdate']) && ($forum['lpuserid'] != $user->getData('id'))){
                        $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconon');
                    } elseif(($user->getForumData($forum['id']) < $forum['lpdate']) && ($forum['lpuserid'] == $user->getData('id')) && ($user->getData('id') == 0)) {
                        $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconon');
                    } else {
                        $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconoff');
                    }
                    //setting the lastpost template, different for guests and members
                    if($forum['lpuserid'] != 0){
                        $forums = str_replace('$forum[lastpost]', stripslashes($template->templates['5']), $forums);
                    } else {
                        $forums = str_replace('$forum[lastpost]', stripslashes($template->templates['27']), $forums);
                    }
                    $forum['lpdate'] = gmdate($template->getVar('lpdateformat'), $forum['lpdate'] + ($user->getData('offset') * 3600));
                    $forum['lptopicname'] = stripslashes($forum['lptopicname']);
                    if(strlen($forum['lptopicname']) >= $template->getVar('maxtitlelength')){
                        $forum['lptopicname'] = substr($forum['lptopicname'], 0, $template->getVar('maxtitlelength')) . '...';
                    }
                    $forum['lpusername'] = stripslashes($forum['lpusername']);
                }
                $forums = $template->cacheArray($forums, $forum);
            }
            $forum = $template->releaseCache();
            eval("\$forums = \"".addslashes($forums)."\";");
            eval("\$subarea = \"".$template->cleanTemplate('3')."\";");
        }
        $forum = $bakforum;
    }

    //# Setting the page area; deciding which topics to grab
    $page = prepValue($_GET['page']);
    if ($page == "" || !is_numeric($page)) {
        $page = 1;
    }
    $page = round($page);
    $start = ($page * $user->getData('topicsperpage')) - $user->getData('topicsperpage');
    $lastpageq = $SQL->query("SELECT `id` FROM `".$database['prefix']."topics` WHERE `fid`='".$fid."'");
    $lastpage = $SQL->num_rows($lastpageq);
    $pagevars = array();
    $pagevars['totalpages'] = ceil($lastpage / $user->getData('topicsperpage'));
    $pagevars['first'] = "";
    $pagevars['middle'] = "";
    $pagevars['last'] = "";
    if(($page - 3) >= 2){
        $pagevars['first'] = "<a href=\"board.php?fid=$fid&page=1\">".$template->getVar('firstpagetext')."</a> ... ";
        for($i = $page - 3; $i < $page; $i++){
            $pagevars['middle'] .= "<a href=\"board.php?fid=$fid&page=$i\">$i</a>, ";
        }
    } else {
        for($i = 1; $i < $page; $i++){
            $pagevars['middle'] .= "<a href=\"board.php?fid=$fid&page=$i\">$i</a>, ";
        }
    }
    $pagevars['middle'] .= $page;
    if(($page + 3) < $pagevars['totalpages']){
        $pagevars['last'] = " ... <a href=\"board.php?fid=$fid&page=$pagevars[totalpages]\">".$template->getVar('lastpagetext')."</a>";
        for($i = $page + 1; $i < $page + 4; $i++){
            $pagevars['middle'] .= " , <a href=\"board.php?fid=$fid&page=$i\">$i</a>";
        }
    } else {
        for($i = $page + 1; $i <= $pagevars['totalpages']; $i++){
            $pagevars['middle'] .= ", <a href=\"board.php?fid=$fid&page=$i\">$i</a>";
        }
    }
    $choosepage = $pagevars['first'] . $pagevars['middle'] . $pagevars['last'];

    if($pagevars['totalpages'] < 2){
        $choosepage = "";
    }

    if($config['remembertopicloc'] == 1){
        $lastweek = time()-604800;
        if(is_array($user->lasttopicviews)){
            foreach($user->lasttopicviews as $key => $when){
                if($when < $lastweek){
                    unset($user->lasttopicviews[$key]);
                }
            }
        }
    }

    //# Grabbing topics
    $grabtopics = $SQL->query("SELECT t.*, i.value AS posticon, p.id AS pollid, u.gid AS lpusergid, g.style AS lpuserstyle, a.gid AS authorgid, ag.style AS authorstyle FROM
                               `".$database['prefix']."topics` AS t LEFT JOIN
                               `".$database['prefix']."posticons` AS i ON (i.id = t.iconid) LEFT JOIN
                               `".$database['prefix']."polls` AS p ON (p.tid = t.id) LEFT JOIN
                               `".$database['prefix']."users` AS u ON (u.id = t.lpuserid) LEFT JOIN
                               `".$database['prefix']."usergroups` AS g ON (g.id = u.gid) LEFT JOIN
                               `".$database['prefix']."users` AS a ON (t.authorid = a.id) LEFT JOIN
                               `".$database['prefix']."usergroups` AS ag ON (a.gid = ag.id)
                               WHERE t.fid='$fid' ORDER BY t.sticky DESC,t.lpdate DESC LIMIT $start, ".$user->getData('topicsperpage')."");
    $counttopics = $SQL->num_rows($grabtopics);
    if($counttopics <= 0){
        $topics = stripslashes($template->templates['17']);
    }
    while($topic = $SQL->fetch_array($grabtopics)){
        $topics .= stripslashes($template->templates['16']);
        $topic['title'] = stripslashes($topic['title']);
        $topic['description'] = stripslashes($topic['description']);
        $topic['lpdate'] = gmdate($template->getVar('lpdateformat'), $topic['lpdate'] + ($user->getData('offset') * 3600));
        //Getting the pages
        $topic['page'] = "";
        if($topic['replies'] + 1 > $user->getData('postsperpage')){
            $pages = $topic['replies'] + 1;
            $pages = ceil($pages / $user->getData('postsperpage'));
            $topic['page'] = $template->getVar('pages_begin');
            if ($pages <= 5) {
                for ($loop = 1; $loop <= $pages; $loop++) {
                    $topic['page'] .= "<a href=\"read.php?tid=".$topic['id']."&page=$loop\">$loop</a>";
                    if ($loop != $pages) {
                        $topic['page'] .= ", ";
                    }
                }
            } else {
                $nexttolast = $pages - 1;
                for ($loop = 1; $loop <= 3; $loop ++) {
                    $topic['page'] .= "<a href=\"read.php?tid=".$topic['id']."&page=$loop\">$loop</a>";
                    if ($loop != 3) {
                        $topic['page'] .= ", ";
                    }
                }
                substr($topic['page'],0,-2);
                $topic['page'] .= "...<a href=\"read.php?tid=".$topic['id']."&page=$nexttolast\">$nexttolast</a>, <a href=\"read.php?tid=".$topic['id']."&page=$pages\">$pages</a>";
            }
            $topic['page'] .= $template->getVar('pages_end');
        }

        if($user->getLastTopicView($topic['id']) != 0 && $config['remembertopicloc'] == 1){
            $topic['gotopost'] = "gototime&time=".$user->getLastTopicView($topic['id']);
        }else{
            $topic['gotopost'] = "lastpost";
        }

        //Checking if topic is read or unread
        $unreadtopics = unserialize($_SESSION['bbunreadtopics']);
        if($unreadtopics[$topic['fid']][$topic['id']] != 0 || $unreadtopics[$topic['fid']][$topic['id']] > $user->getForumData($fid)) {
            if($topic['locked'] == 1){
                $topic['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconon_locked');
            } else {
                $topic['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconon');
            }
        } else {
            if($topic['locked'] == 1){
                $topic['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconoff_locked');
            } else {
                $topic['status'] = $template->getVar('imagepath') ."/". $template->getVar('iconoff');
            }
        }
        //Setting topic post icon (if it has one)
        if($topic['posticon'] != ""){
            $topic['icon'] = "<img src=\"".$config['posticonpath']."/".$topic['posticon']."\" alt=\"\" />";
        }
        //setting sticky, moved, and poll text, if necessary
        if($topic['sticky'] == 1){
            $topic['stickytext'] = $template->getVar('stickytext');
        }
        if($topic['moved'] == 1){
            $topic['movedtext'] = $template->getVar('movedtext');
        }
        if($topic['pollid'] != 0){
            $topic['polltext'] = $template->getVar('polltext');
        }
        //Setting lastpost template, different for guests and members
        if($topic['lpuserid'] != 0){
            $topics = str_replace('$topic[lastpost]', $template->templates['28'], $topics);
        } else {
            $topics = str_replace('$topic[lastpost]', $template->templates['29'], $topics);
        }
        $topics = $template->cacheArray($topics, $topic);
    }
    $topic = $template->releaseCache();
    eval("\$topics = \"".addslashes($topics)."\";");
    eval("\$include = \"".$template->templates['15']."\";"); // main include

    //# Updating last visit date for current forum
    $user->setForumData($fid, time());

    //# Updating active table
    $user->updateActive("Viewing Forum: <a href=\"board.php?fid=$forum[id]\">$forum[name]</a>");
} elseif(isset($_GET['cid'])) {
    $cid = prepValue($_GET['cid']);
    $status = 0;

    //# Grabbing Categories and Forums, and their permissions
    $grabquery = $SQL->query("SELECT c.id AS cid, c.name AS cname, c.description AS cdescription, f.*, p.view_forum, u.gid, g.style AS lpuserstyle FROM
                              `".$database['prefix']."forums` AS c LEFT JOIN
                              `".$database['prefix']."forums` AS f ON ( f.parent = c.id ) LEFT JOIN
                              `".$database['prefix']."permissions` AS p ON (p.fid = f.id AND p.gid = '".$user->getData('gid')."') LEFT JOIN
                              `".$database['prefix']."users` AS u ON (f.lpuserid = u.id) LEFT JOIN
                              `".$database['prefix']."usergroups` AS g ON (u.gid = g.id)
                              WHERE c.class = 'category' AND f.class = 'forum' AND c.id = '$cid' ORDER BY c.order,f.order");
    if($SQL->num_rows($grabquery) < 1){
        bb_error("Category doesn't exist.");
    }

    $latestcid = NULL;
    while($grab = $SQL->fetch_array($grabquery)){
        if($grab['cid'] == $latestcid){
            $status = 1;
        } else {
            $status = 0;
        }
        switch ($status){
            //If there's a category, go through the whole process
            case 0:
                if(($grab['id'] == "") || ($grab['view_forum'] == '0')){
                    break;
                }
                $include = stripslashes($template->cleanTemplate('3'));
                $category['id'] = $grab['cid'];
                $category['name'] = $grab['cname'];
                $category['description'] = $grab['cdescription'];
                $forums = "";
            //If there's only a forum, just do the forum process
            case 1:
                $forums .= $template->templates['4'];
                $forums = stripslashes($forums);
                $forum = $grab; //setting the forum array
                if($forum['lpdate'] == NULL){
                    $forums = str_replace('$forum[lastpost]', stripslashes($template->templates['6']), $forums);
                    $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconoff');
                } else {
                    //setting icon that says whether or not there's unread posts in the forum
                    if(($user->getForumData($forum['id']) < $forum['lpdate']) && ($forum['lpuserid'] != $user->getData('id'))){
                        $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconon');
                    } elseif(($user->getForumData($forum['id']) < $forum['lpdate']) && ($forum['lpuserid'] == $user->getData('id')) && ($user->getData('id') == 0)) {
                        $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconon');
                    } else {
                        $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconoff');
                    }
                    //setting the lastpost template, different for guests and members
                    if($forum['lpuserid'] != 0){
                        $forums = str_replace('$forum[lastpost]', stripslashes($template->templates['5']), $forums);
                    } else {
                        $forums = str_replace('$forum[lastpost]', stripslashes($template->templates['27']), $forums);
                    }
                    $forum['lpdate'] = gmdate($template->getVar('lpdateformat'), $forum['lpdate'] + ($user->getData('offset') * 3600));
                    $forum['lptopicname'] = stripslashes($forum['lptopicname']);
                    if(strlen($forum['lptopicname']) >= $template->getVar('maxtitlelength')){
                        $forum['lptopicname'] = substr($forum['lptopicname'], 0, $template->getVar('maxtitlelength')) . '...';
                    }
                    $forum['lpusername'] = stripslashes($forum['lpusername']);
                }
                $latestcid = $grab['cid'];
                $forums = $template->cacheArray($forums, $forum, "forum");
            break;
        }
    }
    $include = str_replace('$forums', $forums, $include);
    $forum = $template->releaseCache("forum");
    eval("\$include = \"".addslashes($include)."\";");

    //# Updating active table
    $user->updateActive("Viewing Category: <a href=\"board.php?cid=".$category['id']."\">".$category['name']."</a>");

    //# Setting breadcrumbs
    $breadcrumbs .= $template->getVar('crumbsseperator') . $category['name'];
} else {
    die_header($config['boardurl']."index.php");
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>