<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: user.class.php,v 1.16 2005/07/06 00:26:16 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


class User {
    var $userdata = array();
    var $forumdata = array();
    var $lasttopicviews = array();
    var $anon;

    //# Loads the user data into the class
    function loadUser(){
        global $SQL, $config, $database;
        if(isset($_COOKIE[$config['ckprefix'].'user'])){
            list($this->userdata['id'], $this->userdata['password'], $this->anon) = explode('&&', $_COOKIE[$config['ckprefix'].'user']);

            $this->userdata['id'] = htmlspecialchars($this->userdata['id'], ENT_QUOTES);
            $this->userdata['id'] = addslashes($this->userdata['id']);
            $this->userdata['password'] = htmlspecialchars($this->userdata['password'], ENT_QUOTES);
            $this->userdata['password'] = addslashes($this->userdata['password']);
            $this->anon = htmlspecialchars($this->anon, ENT_QUOTES);
            $this->anon = addslashes($this->anon);

            $userconfigq = $SQL->query("SELECT u.*, g.name, g.style, g.view_topic, g.view_forum, g.post_reply, g.post_topic, 
                                               g.post_poll, g.post_attachments, g.vote_poll, g.edit_own, g.edit_others, g.delete_own,
                                               g.delete_others, g.lock_topics, g.stick_topics, g.move_topics, g.use_locked, g.admin_cp,
                                               g.view_ip, g.navtemp, r.title AS ranktitle, r.image AS rankimage, p.id AS unreadpm, 
                                               a.dateline AS lastactive, a.forumdata, a.lastpost, a.lasttopicviews, a.ip, a.anon, a.status AS active_status
                                               FROM `".$database['prefix']."users` AS u 
                                               LEFT JOIN `".$database['prefix']."usergroups` AS g ON(u.gid = g.id) 
                                               LEFT JOIN `".$database['prefix']."userranks` AS r ON(r.gid = g.id AND r.minposts <= u.posts AND r.maxposts >= u.posts) 
                                               LEFT JOIN `".$database['prefix']."pmessages` AS p ON(p.status='inbox' AND p.read='0' AND p.toid=u.id) 
                                               LEFT JOIN `".$database['prefix']."active` AS a ON (a.userid = u.id)
                                               WHERE u.id='".$this->userdata['id']."' AND u.password='".$this->userdata['password']."'");
            $checkuser = $SQL->num_rows($userconfigq);
            if($checkuser < 1){
                setcookie($config['ckprefix']."user", "", time(), $config['cookiepath'], $config['cookiedomain']);
                header("Location: ".$config['boardurl']."index.php");
                die();
            } else {
                $this->userdata = $SQL->fetch_array($userconfigq);
            }
            if($this->userdata['title'] == ""){
                $this->userdata['title'] = $this->userdata['ranktitle'];
            }
        } else {
            $this->userdata['id'] = 0;
            $permq = $SQL->query("SELECT g.id AS gid, g.name, g.style, g.view_topic, g.view_forum, g.post_reply, g.post_topic,
                                  g.post_poll, g.post_attachments, g.vote_poll, g.edit_own, g.edit_others, g.delete_own,
                                  g.delete_others, g.lock_topics, g.stick_topics, g.move_topics, g.use_locked, g.admin_cp, 
                                  g.view_ip, g.navtemp, a.dateline AS lastactive, a.forumdata, a.lastpost, a.lasttopicviews, a.ip, a.status
                                  FROM `".$database['prefix']."usergroups` AS g 
                                  LEFT JOIN `".$database['prefix']."active` AS a ON (a.userid = 0 AND a.ip = '".$_SERVER['REMOTE_ADDR']."')
                                  WHERE g.id='".$config['guestgid']."'");
            $this->userdata = $SQL->fetch_array($permq);
            $this->userdata['username'] = "Guest";
            $this->userdata['skin'] = $config['skindefault'];
            $this->userdata['offset'] = 0;
            $this->userdata['viewsiggies'] = $config['viewsiggies'];
            $this->userdata['viewavatars'] = $config['viewavatars'];
            $this->userdata['viewhistory'] = $config['viewhistory'];
            $this->userdata['censor'] = $config['censor'];
            $this->userdata['postsperpage'] = $config['postsperpage'];
            $this->userdata['topicsperpage'] = $config['topicsperpage'];
            $this->userdata['membersperpage'] = $config['membersperpage'];
        }
        $this->userdata['lastvisit'] = $_SESSION['lastvisit'];
        $this->forumdata = unserialize(stripslashes($this->userdata['forumdata']));
        $this->lasttopicviews = unserialize(stripslashes($this->userdata['lasttopicviews']));

        if($this->userdata['forumdata'] == NULL){
            $time = time();
            $forumq = $SQL->query("SELECT `id` FROM `".$database['prefix']."forums` WHERE `class` = 'forum' OR `class` = 'subforum'");
            while($grabforums = $SQL->fetch_array($forumq)){
                $this->forumdata[$grabforums['id']] = $time;
            }
        }
    }

    //# Updates the active table
    function updateActive($location){
        global $SQL, $config, $database;
        $location = addslashes($location);
        $srl_forumdata = addslashes(serialize($this->forumdata));
        $srl_lasttopicviews = addslashes(serialize($this->lasttopicviews));
        if($this->userdata['id'] == 0){
            if($this->userdata['ip'] == ""){
                $update = $SQL->query("INSERT INTO `".$database['prefix']."active` (`userid`,`username`,`dateline`,`location`,`forumdata`,`lastpost`,`lasttopicviews`,`ip`,`anon`,`status`) VALUES ('".$this->userdata['id']."','".$this->userdata['username']."','".time()."','$location','$srl_forumdata','".$this->userdata['lastpost']."','$srl_lasttopicviews','".$_SERVER['REMOTE_ADDR']."','".$this->anon."', 'guest')", true);
            } else {
                $update = $SQL->query("UPDATE `".$database['prefix']."active` SET `username` = '$username',`dateline`='".time()."',`location`='$location',`forumdata` = '$srl_forumdata',`lastpost` = '".$this->userdata['lastpost']."',`lasttopicviews` = '$srl_lasttopicviews',`status` = 'guest' WHERE `userid`='".$this->userdata['id']."' AND `ip`='".$_SERVER['REMOTE_ADDR']."'");
            }
        } else {
            if($this->userdata['ip'] == ""){
                $update = $SQL->query("INSERT INTO `".$database['prefix']."active` (`userid`,`username`,`dateline`,`location`,`forumdata`,`lastpost`,`lasttopicviews`,`ip`,`anon`,`status`) VALUES ('".$this->userdata['id']."','".$this->userdata['username']."','".time()."','$location','$srl_forumdata','".$this->userdata['lastpost']."','$srl_lasttopicviews','".$_SERVER['REMOTE_ADDR']."','".$this->anon."', 'logged')", true);
            } else {
                $update = $SQL->query("UPDATE `".$database['prefix']."active` SET `username` = '".$this->userdata['username']."',`dateline`='".time()."',`location`='$location',`forumdata` = '$srl_forumdata',`lastpost` = '".$this->userdata['lastpost']."',`lasttopicviews` = '$srl_lasttopicviews',`status` = 'logged' WHERE `userid`='".$this->userdata['id']."'");
            }
        }
    }

    //# Returns specified user data
    function getData($data){
        return $this->userdata[$data];
    }

    //# Sets the specified data in the user data array
    function setData($key, $data){
        $this->userdata[$key] = $data;
    }

    //# Changes the user's permissions to that of the specified forum's
    function setForumPerms($fid){
        global $SQL, $database;
        $grabpermissions = $SQL->query("SELECT * FROM `".$database['prefix']."permissions` WHERE `fid` = '".$fid."'");
        while($permissions = $SQL->fetch_array($grabpermissions)){
            if(($permissions['gid'] == $this->getData('gid')) && ($permissions['gid'] != NULL)){
                foreach($permissions as $key => $value){
                    if(($key != 'id') && ($key != 'fid') && ($key != 'gid')){
                        $this->userdata[$key] = $value;
                    }
                }
            }
        }
    }

    //# Returns the last visit date of the specified forum
    function getForumData($fid){
        if($this->forumdata[$fid] == NULL){
            $this->forumdata[$fid] = 0;
        }
        return $this->forumdata[$fid];
    }

    //# Sets the last visit date of the specified forum
    function setForumData($fid, $value){
        $this->forumdata[$fid] = $value;
    }

    //# Returns the last view date of the specified topic
    function getLastTopicView($tid){
        if($this->lasttopicviews[$tid] == NULL){
            $this->lasttopicviews[$tid] = 0;
        }
        return $this->lasttopicviews[$tid];
    }

    //# Sets the last view date of the specified topic
    function setLastTopicView($tid, $value){
        $this->lasttopicviews[$tid] = $value;
    }
 }
?>