<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: index.php,v 1.13 2005/06/23 00:53:19 mokkan Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "index");

//# Templates:
$bb_templates = '1,2,3,4,5,6,7,8,9,10,27,67';
require("core.php");

//# Setting breadcrumbs
$breadcrumbs .= $template->getVar('crumbsseperator')."Index";

//# Updating active table
$user->updateActive("Viewing Index");

//# Grabbing categories and forums
$latestcid = NULL;
$grabquery = $SQL->query("SELECT c.id AS cid, c.name AS cname, c.description AS cdescription, f.*, p.view_forum, u.gid, g.style AS lpuserstyle FROM `".$database['prefix']."forums` AS c LEFT JOIN `".$database['prefix']."forums` AS f ON ( f.parent = c.id AND f.class = 'forum') LEFT JOIN `".$database['prefix']."permissions` AS p ON(p.fid = f.id AND p.gid = '".$user->getData('gid')."') LEFT JOIN `".$database['prefix']."users` AS u ON (f.lpuserid = u.id) LEFT JOIN `".$database['prefix']."usergroups` AS g ON(g.id = u.gid) WHERE c.class = 'category' ORDER BY c.order,f.order");
while($grab = $SQL->fetch_array($grabquery)){
    if($grab['cid'] == $latestcid){
        $status = 1;
    } else {
        $status = 0;
    }
    switch ($status){
        //If there's a category, go through the whole process
        case 0:
            if(($grab['id'] == "") || ($grab['view_forum'] == '0')){
                break;
            }
            if($latestcid != NULL){
                $categories = $template->cacheArray($categories, $category, "category");
                $categories = str_replace('$forums', $forums, $categories);
            }
            $categories .= $template->templates['3'];
            $categories = stripslashes($categories);
            $category['id'] = $grab['cid'];
            $category['name'] = $grab['cname'];
            $category['description'] = $grab['cdescription'];
            $forums = "";
        //If there's only a forum, just do the forum process
        case 1:
            $forums .= $template->templates['4'];
            $forums = stripslashes($forums);
            $forum = $grab; //setting the forum array
            if($forum['lpdate'] == NULL){
                $forums = str_replace('$forum[lastpost]', stripslashes($template->templates['6']), $forums);
                $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconoff');
            } else {
                //Setting icon that says whether or not there's unread posts in the forum
                if(($user->getForumData($forum['id']) < $forum['lpdate']) && ($forum['lpuserid'] != $user->getData('id'))){
                    $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconon');
                } elseif(($user->getForumData($forum['id']) < $forum['lpdate']) && ($forum['lpuserid'] == $user->getData('id')) && ($user->getData('id') == 0)) {
                    $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconon');
                } else {
                    $forum['icon'] = $template->getVar('imagepath')."/".$template->getVar('iconoff');
                }
                //setting the lastpost template, different for guests and members
                if($forum['lpuserid'] != 0){
                    $forums = str_replace('$forum[lastpost]', stripslashes($template->templates['5']), $forums);
                } else {
                    $forums = str_replace('$forum[lastpost]', stripslashes($template->templates['27']), $forums);
                }
                $forum['lpdate'] = gmdate($template->getVar('lpdateformat'), $forum['lpdate'] + ($user->getData('offset') * 3600));
                $forum['lptopicname'] = stripslashes($forum['lptopicname']);
                if(strlen($forum['lptopicname']) >= $template->getVar('maxtitlelength')){
                    $forum['lptopicname'] = substr($forum['lptopicname'], 0, $template->getVar('maxtitlelength')) . '...';
                }
                $forum['lpusername'] = stripslashes($forum['lpusername']);
            }
            $latestcid = $grab['cid'];
            $forums = $template->cacheArray($forums, $forum, "forum");
        break;
    }
}
$categories = str_replace('$forums', $forums, $categories);
$categories = $template->cacheArray($categories, $category, "category");
$category = $template->releaseCache("category");
$forum = $template->releaseCache("forum");
eval("\$categories = \"".addslashes($categories)."\";");

//# Online users
$online['guests'] = 0;
$online['members'] = 0;
$online['anon'] = 0;
$activeq = $SQL->query("SELECT a.*,u.gid,g.style FROM `".$database['prefix']."active` AS a LEFT JOIN `".$database['prefix']."users` AS u ON (a.userid = u.id) LEFT JOIN `".$database['prefix']."usergroups` AS g ON (g.id = u.gid) WHERE a.status != 'unlogged' AND a.dateline > ".(time() - 900));
while($active = $SQL->fetch_array($activeq)){
    if($active['userid'] == 0){
        $online['guests']++;
    } elseif($active['anon'] == 0) {
        $online['members']++;
        $online['users'] .= "$sep<a href=\"member.php?a=viewprof&uid=$active[userid]\" style=\"$active[style]\">$active[username]</a>";
        $sep = $template->getVar('onlineuserseperator');
    } else {
        $online['anon']++;
    }
    $online['overall']++;
}

//# Birthdays
$day = gmdate("j", time()+(3600 * $user->getData('offset')));
$month = gmdate("n", time());
$year = gmdate("Y", time());
$bdayq = $SQL->query("SELECT u.id,u.username,u.byear,g.style FROM `".$database['prefix']."users` AS u LEFT JOIN `".$database['prefix']."usergroups` AS g ON (u.gid = g.id) WHERE u.bday='$day' AND u.bmonth='$month'");
$bdaycount = $SQL->num_rows($bdayq);
if($bdaycount > 0){
    while($bdays = $SQL->fetch_array($bdayq)){
        $birthdayinc .= $sep2 . stripslashes($template->templates['8']);
        $age = $year - $bdays['byear'];
        eval("\$birthdayinc = \"".addslashes($birthdayinc)."\";");
        $sep2 = $template->getVar('bdayseperator');
    }
} else {
    $birthdayinc = $template->templates['9'];
}

//# Grabbing board stats
$statsq = $SQL->query("SELECT s.*,u.gid,g.style AS newestuserstyle FROM `".$database['prefix']."boardstats` AS s LEFT JOIN `".$database['prefix']."users` AS u ON (u.id = s.newestuid) LEFT JOIN `".$database['prefix']."usergroups` AS g ON (g.id = u.gid)");
$stats = $SQL->fetch_array($statsq);
if ($online['overall'] > $stats['mostonline']) {
    $stats['mostonlinedate'] = time();
    $stats['mostonline'] = $online['overall'];
    $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `mostonline`='".$stats['mostonline']."',`mostonlinedate`='".$stats['mostonlinedate']."'");
}
$stats['mostonlinedate'] = gmdate($template->getVar('mostonlineformat'), $stats['mostonlinedate'] + ($user->getData('offset') * 3600));
eval("\$boardstats = \"".$template->templates['7']."\";");

//# Login area
if($user->getData('id') == 0){
    $loginarea = stripslashes($template->templates['10']);
}

//# Build $include
eval("\$include = \"".$template->templates['2']."\";");

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>