<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: member.php,v 1.23 2005/07/06 00:25:57 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "member");

//# Templates:
$bb_templates = '1,11,12,42,43,44,45,48,53,57,60,67,76,77,144';
require("core.php");

//# Switchboard to tell the program what to do
switch(prepValue($_GET['a'])){
    case 'logform': //login form
        //# Updating active table
        $user->updateActive("Logging In");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator')."Login";

        $include = stripslashes($template->templates['53']);
        eval("\$include = \"".addslashes($include)."\";");
    break;
    case 'login': //login action
        if((!$_POST['username']) || (!$_POST['password'])){
            bb_error("You didn't input a username/password.");
        }
        $username = $_POST['username'];
        $password = md5($_POST['password']);
        $checkq = $SQL->query("SELECT `id`,`active` FROM `".$database['prefix']."users` WHERE `username`='".$username."' AND `password`='$password'");
        $checkuser = $SQL->num_rows($checkq);
        if($checkuser > 0){
            $grabuser = $SQL->fetch_array($checkq);
            if ($grabuser['active'] == 0) {
                bb_error("This account is not yet active.");
            }
            if ($_POST['remember'] == 1) {
                $time = time() + 31536000;
            }
            setcookie($config['ckprefix']."user", $grabuser['id']."&&".$password."&&".$_POST['anon'], $time, $config['cookiepath'], $config['cookiedomain']);
            $del = $SQL->query("DELETE FROM `".$database['prefix']."active` WHERE `userid`='0' AND `ip`='".$_SERVER['REMOTE_ADDR']."'");
            die_header("Location: index.php");
        } else {
            bb_error("Invalid username/password.<br>If you have forgotten your password, you can reset it <a href=\"member.php?a=forgotpass\">here</a>.");
        }
    break;
    case 'logout': //logout action
        setcookie($config['ckprefix']."user","", time() - 1, $config['cookiepath'], $config['cookiedomain']);
        $update = $SQL->query("UPDATE `".$database['prefix']."active` SET `status` = 'unlogged' WHERE `userid`='".$user->getData('id')."'");
        die_header("Location: index.php");
    break;
    case 'regform'://register form
        //# Updating active table
        $user->updateActive("Registering");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator')."Register";

        if ($config['regtype'] != "3") {
            $include = stripslashes($template->templates['11']);
        } else {
            $include = stripslashes($template->templates['81']);
        }

        eval("\$include = \"".addslashes($include)."\";");
    break;
    case 'register'://register action
        $offlimits = explode(' ', stripslashes($config['badcharpool']));
        $username = str_replace($offlimits, '', $_POST['username']);
        $email1 = $_POST['email1'];
        $email2 = $_POST['email2'];

        if(($username == "") || ($email1 == "") || ($email2 == "") || ($email1 != $email2)){
            bb_error("Not all fields were filled in, or were filled in incorrectly.");
        }

        if(!preg_match("/^[a-zA-Z0-9\_\-\.]+\@[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,4}$/i", $email1)){
            bb_error("Invalid email address.");
        }

        $checkq = $SQL->query("SELECT `username`, `email` FROM `".$database['prefix']."users` WHERE `username`='$username' OR `email`='$email1'");
        $check = $SQL->num_rows($checkq);
        if ($check > 0) {
            bb_error("Someone with that username or email address already exists.");
        }

        if ($config['regtype'] != 3) {
            $pw1 = $_POST['pw1'];
            $pw2 = $_POST['pw2'];

            if(($pw1 == "") || ($pw2 == "") || ($pw1 != $pw2)){
                bb_error("Not all fields were filled in, or were filled in incorrectly.");
            }
            $password = md5($pw1);
        }

        if ($config['regtype'] == 1) {
            $regq = $SQL->query("INSERT INTO `".$database['prefix']."users` (`id`,`gid`,`skin`,`username`,`password`,`email`,`joindate`,`parseurls`,`viewsiggies`,`viewavatars`,`viewhistory`,`subscribe`,`emailifpm`,`notificationifpm`,`hideemail`,`censor`,`disableemoticons`,`posts`,`active`,`postsperpage`,`topicsperpage`,`membersperpage`) VALUES ('','".$config['defaultgid']."','".$config['skindefault']."','$username','$password','$email1','".time()."','".$config['parseurls']."','".$config['viewsiggies']."','".$config['viewavatars']."','".$config['viewhistory']."','0','1','1','0','".$config['censor']."','".$config['disableemoticons']."','0','1','".$config['postsperpage']."','".$config['topicsperpage']."','".$config['membersperpage']."')");
            $grabid = $SQL->query("SELECT `id` FROM `".$database['prefix']."users` WHERE `username` = '$username'");
            $grab = $SQL->fetch_array($grabid);
            $updateq = $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `members` = `members`+1, `newestuid`='$grab[id]', `newestuser` = '$username'");

            $cellhead = "Thank you...";
            $breadcrumbs .= $template->getVar('crumbsseperator')."Thank you...";
            $cellmessage = "Thanks for registering as $username, you may now login.<br><a href=\"index.php\">Back to Index</a>";
            $include = stripslashes($template->templates['12']);
            eval("\$include = \"".addslashes($include)."\";");
        } elseif ($config['regtype'] == 2) {
            $validator = md5(mt_rand()+time());
            $regq = $SQL->query("INSERT INTO `".$database['prefix']."users` (`id`,`gid`,`skin`,`username`,`password`,`email`,`joindate`,`parseurls`,`viewsiggies`,`viewavatars`,`viewhistory`,`subscribe`,`emailifpm`,`notificationifpm`,`hideemail`,`censor`,`disableemoticons`,`posts`,`active`,`validate`,`postsperpage`,`topicsperpage`,`membersperpage`) VALUES ('','".$config['defaultgid']."','".$config['skindefault']."','$username','$password','$email1','".time()."','".$config['parseurls']."','".$config['viewsiggies']."','".$config['viewavatars']."','".$config['viewhistory']."','0','1','1','0','".$config['censor']."','".$config['disableemoticons']."','0','0','$validator','".$config['postsperpage']."','".$config['topicsperpage']."','".$config['membersperpage']."')");

            $mailinfo = $SQL->query("SELECT u.id, a.email FROM `".$database['prefix']."users` AS u LEFT JOIN `".$database['prefix']."users` AS a ON(a.id=1) WHERE u.username='$username'");
            $mail = $SQL->fetch_array($mailinfo);
            $config['emaillink'] = str_replace("%boardurl%", $config['boardurl'], $config['emaillink']);
            $config['emaillink'] = str_replace("%id%", $validator, $config['emaillink']);

            bb_sendmail($email1, "Acitvation for ". $config['boardname'], $config['emaillink']);

            $cellhead = "Thank you...";
            $breadcrumbs .= $template->getVar('crumbsseperator')."Thank you...";
            $cellmessage = "Thanks for registering as $username, Check your email for an activation link, click it, and then you will be able to login.<br><a href=\"index.php\">Back to Index</a>";
            $include = stripslashes($template->templates['12']);
            eval("\$include = \"".addslashes($include)."\";");
        } elseif ($config['regtype'] == 3) {
            $pw = "";
            while (strlen($pw) < 8) {
                $cap = rand(0, 2);
                if ($cap == 1) {
                    $char = chr(rand(65, 90));
                } else {
                    $char = chr(rand(97, 122));
                }
                $pw .= $char;
            }
            $password = md5($pw);

            $regq = $SQL->query("INSERT INTO `".$database['prefix']."users` (`id`,`gid`,`skin`,`username`,`password`,`email`,`joindate`,`parseurls`,`viewsiggies`,`viewavatars`,`viewhistory`,`subscribe`,`emailifpm`,`notificationifpm`,`hideemail`,`censor`,`disableemoticons`,`posts`,`active`,`postsperpage`,`topicsperpage`,`membersperpage`) VALUES ('','".$config['defaultgid']."','".$config['skindefault']."','$username','$password','$email1','".time()."','".$config['parseurls']."','".$config['viewsiggies']."','".$config['viewavatars']."','".$config['viewhistory']."','0','1','1','0','".$config['censor']."','".$config['disableemoticons']."','0','1','".$config['postsperpage']."','".$config['topicsperpage']."','".$config['membersperpage']."')");
            $grabid = $SQL->query("SELECT `id` FROM `".$database['prefix']."users` WHERE `username` = '$username'");
            $grab = $SQL->fetch_array($grabid);
            $updateq = $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `members` = `members`+1, `newestuid`='$grab[id]', `newestuser` = '$username'");

            $mailinfo = $SQL->query("SELECT `email` FROM `".$database['prefix']."users` WHERE `id`='1'");
            $mail = $SQL->fetch_array($mailinfo);
            $config['emailpass'] = str_replace("%boardurl%", $config['boardurl'], $config['emailpass']);
            $config['emailpass'] = str_replace("%password%", $pw, $config['emailpass']);

            bb_sendmail($email1, "Password for your account on ".$config['boardname'], $config['emailpass']);

            $cellhead = "Thank you...";
            $breadcrumbs .= $template->getVar('crumbsseperator')."Thank you...";
            $cellmessage = "Thanks for registering as $username, Check your email for a password to login with. You can change your password after you login.<br><a href=\"index.php\">Back to Index</a>";
            $include = stripslashes($template->templates['12']);
            eval("\$include = \"".addslashes($include)."\";");
        } elseif ($config['regtype'] == 4) {
            $regq = $SQL->query("INSERT INTO `".$database['prefix']."users` (`id`,`gid`,`skin`,`username`,`password`,`email`,`joindate`,`parseurls`,`viewsiggies`,`viewavatars`,`viewhistory`,`subscribe`,`emailifpm`,`notificationifpm`,`hideemail`,`censor`,`disableemoticons`,`posts`,`active`,`postsperpage`,`topicsperpage`,`membersperpage`) VALUES ('','".$config['defaultgid']."','".$config['skindefault']."','$username','$password','$email1','".time()."','".$config['parseurls']."','".$config['viewsiggies']."','".$config['viewavatars']."','".$config['viewhistory']."','0','1','1','0','".$config['censor']."','".$config['disableemoticons']."','0','0','".$config['postsperpage']."','".$config['topicsperpage']."','".$config['membersperpage']."')");

            $mailinfo = $SQL->query("SELECT u.id, a.email FROM `".$database['prefix']."users` AS u LEFT JOIN `".$database['prefix']."users` AS a ON(a.id=1) WHERE u.username='$username'");
            $mail = $SQL->fetch_array($mailinfo);
            $config['adminapprove'] = str_replace("%username%", $username, $config['adminapprove']);

            bb_sendmail($mail['email'], "Acitvation for ".$username." on ".$config['boardname'], $config['adminapprove']);

            $cellhead = "Thank you...";
            $breadcrumbs .= $template->getVar('crumbsseperator')."Thank you...";
            $cellmessage = "Thanks for registering as $username, you will recive an email later stating whether or not the admin will allow you to join the site, if so, you will be able to login as soon as you recive the email stating so.<br><a href=\"index.php\">Back to Index</a>";
            $include = stripslashes($template->templates['12']);
            eval("\$include = \"".addslashes($include)."\";");

        }

        if ($config['sendpm'] == 1) {
            $pminfo = $SQL->query("SELECT u.id AS uid, a.id AS aid, a.username AS admin FROM `".$database['prefix']."users` AS u LEFT JOIN `".$database['prefix']."users` AS a ON(a.id=1) WHERE u.username='$username'");
            $pm = $SQL->fetch_array($pminfo);
            $config['pmmsg'] = str_replace("%boardname%", $config['boardname'], $config['pmmsg']);
            $sendpm = $SQL->query("INSERT INTO `".$database['prefix']."pmessages` VALUES('','".$pm['aid']."','".$pm['admin']."','".$pm['uid']."','$username','".$config['pmsub']."','".$config['pmmsg']."','".time()."','".$config['parseurls']."','".$config['disableemoticons']."','0','inbox')");
        }
    break;
    case 'viewprof'://view profile
        if ($_GET['uid'] == 0) {
            bb_error("The guest user doesn't actually exist, its more a state of n00bness.");
        }

        $grabinfo = $SQL->query("SELECT u.*,g.name FROM `".$database['prefix']."users` AS u LEFT JOIN `".$database['prefix']."usergroups` AS g ON (u.gid = g.id) WHERE u.id='".prepValue($_GET['uid'])."' AND u.active='1'");
        $profile = $SQL->fetch_array($grabinfo);
        if ($profile['username'] == "") {
            bb_error("The user does not exist.");
        }
        $profile['joined'] = gmdate($template->getVar('joindateformat'), $profile['joindate']+(3600 * $user->getData('offset')));
        if(($profile['byear'] < 1970) && ($profile['byear'] > 0)){
            $profile['birthday'] = "$profile[bday].$profile[bmonth].$profile[byear]";
        } elseif($profile['byear'] >= 1970) {
            $profile['birthday'] = date($template->getVar('bdayformat'), mktime(0, 0, 0,$profile['bmonth'], $profile['bday'], $profile['byear']));
        } else {
            $profile['birthday'] = "";
        }
        if(strtolower(substr($profile['avatar'], 0, 7)) != "http://"){
            $profile['avatar'] = $config['avatarpath'] . $profile['avatar'];
        }
        $profile['pavg'] = (!empty($profile['posts']) && $summary['posts'] != "0") ? round($profile['posts'] / ceil((time() - $profile['joindate']) / 60 / 60 / 24), 2) : "0.00";
        $profile['avatar'] = (empty($profile['avatar'])) ? "" : "<img src=\"".$profile['avatar']."\" alt=\"".$profile['username']."'s Avatar\" />";

        //# Update active and set breadcrumbs
        $user->updateActive("Viewing ".$profile['username']."'s Profile");
        $breadcrumbs .= $template->getVar('crumbsseperator').$profile['username']."'s Profile";
        $include = stripslashes($template->templates['48']);
        eval("\$include = \"".addslashes($include)."\";");
    break;
    case 'listmembers'://view member list
        //# Updating active table
        $user->updateActive("Viewing Member List");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator')."Member List";
        $_POST = prepValue($_POST);
        $_GET = prepValue($_GET);

        if ($_POST['orderby'] != "") {
            $orderby = strtolower(urldecode($_POST['orderby']));
        }else{
            $orderby = strtolower(urldecode($_GET['orderby']));
        }
        if($_POST['sort'] != ""){
            $sort = strtolower(urldecode($_POST['sort']));
        }else{
            $sort = strtolower(urldecode($_GET['sort']));
        }
        if($_POST['limit'] != ""){
            $limit = strtolower(urldecode($_POST['limit']));
        }else{
            $limit = strtolower(urldecode($_GET['limit']));
        }

        $letter = $_GET['letter'];
        $page = $_GET['page'];

        if($orderby == "usergroup"){
            $orderby = "gid";
        }
        if($orderby == "e-mail"){
            $orderby = "email";
        }
        if($orderby == "homepage"){
            $orderby = "pagename";
        }
        if($orderby == "join date"){
            $orderby = "joindate";
        }
        if($orderby != "username" && $orderby != "gid" && $orderby != "email" && $orderby != "pagename" && $orderby != "joindate" && $orderby != "posts"){
            $orderby = "username";
        }

        if($sort == "decending"){
            $sort = "desc";
        }
        if($sort == "ascending"){
            $sort = "asc";
        }
        if($sort != "asc" && $sort != "desc") {
            $sort = "asc";
        }

        if ($limit == "" || !is_numeric($limit)) {
            $limit = $user->getData('membersperpage');
        }
        if ($letter == "") {
            $letter = "!= ''";
        } else {
            $tmpletter = strtolower(urldecode(stripslashes($letter[0])));
            $letter = "LIKE '".$letter."%'";
        }
        if ($page == "" || !is_numeric($page)) {
            $page = 1;
        }
        $page = round($page);
        $start = ($page * $limit) - $limit;
        if($start < 0){
            $start=0;
        }

        $letter = urldecode(stripslashes($letter));
        $letters = "<a href=\"member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&page=$page\">All</a> - ";
        for ($alpha = "a"; ; $alpha++) {
            if($alpha == $tmpletter){
                if ($alpha == "z") {
                    $letters .= "z";
                    break;
                } else {
                    $letters .= "$alpha - ";
                }
            }else{
                if ($alpha == "z") {
                    $letters .= "<a href=\"member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&letter=z&page=$page\">z</a>";
                    break;
                } else {
                    $letters .= "<a href=\"member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&letter=$alpha&page=$page\">$alpha</a> - ";
                }
            }
        }

        $listq = $SQL->query("SELECT u.*, g.style AS userstyle FROM `".$database['prefix']."users` AS u LEFT JOIN `".$database['prefix']."usergroups` AS g ON (g.id = u.gid) WHERE u.username $letter AND u.active='1' ORDER BY u.$orderby $sort LIMIT $start, $limit");
        while($member = $SQL->fetch_array($listq)) {
            $members .= stripslashes($template->templates['43']);
            $member['joindate'] = date($template->getVar('joindateformat'), $member['joindate']);
            $members = $template->cacheArray($members, $member);
        }
        $member = $template->releaseCache();
        eval("\$members = \"".addslashes($members)."\";");

        $lastq = $SQL->query("SELECT u.id FROM `".$database['prefix']."users` AS u LEFT JOIN `".$database['prefix']."usergroups` AS g ON (g.id = u.gid) WHERE u.username $letter AND u.active='1'");
        $lastpage = $SQL->num_rows($lastq);

        $letter = str_replace("LIKE ", "", $letter);
        $letter = str_replace("'", "", $letter);
        $letter = str_replace("%", "", $letter);
        $letter = str_replace("!=", "", $letter);
        $letter = str_replace(" ", "", $letter);

        if($lastpage <= 0){
            eval("\$members = \"".$template->templates['144']."\";");
        }
        $lastpage = ceil($lastpage / $limit);

        if ($page > $lastpage) {
            die_header("Location: member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&letter=$letter&page=$lastpage");
        }
        $pagevars = array();
        $pagevars['totalpages'] = $lastpage;
        $pagevars['first'] = "";
        $pagevars['middle'] = "";
        $pagevars['last'] = "";
        if(($page - 3) >= 2){
            $pagevars['first'] = "<a href=\"member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&letter=$letter&page=1\">".$template->getVar('firstpagetext')."</a> ... ";
            for($i = $page - 3; $i < $page; $i++){
                $pagevars['middle'] .= "<a href=\"member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&letter=$letter&page=$i\">$i</a>, ";
            }
        } else {
            for($i = 1; $i < $page; $i++){
                $pagevars['middle'] .= "<a href=\"member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&letter=$letter&page=$i\">$i</a>, ";
            }
        }
        $pagevars['middle'] .= $page;
        if(($page + 3) < $pagevars['totalpages']){
            $pagevars['last'] = " ... <a href=\"member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&letter=$letter&page=$pagevars[totalpages]\">".$template->getVar('lastpagetext')."</a>";
            for($i = $page + 1; $i < $page + 4; $i++){
                $pagevars['middle'] .= ", <a href=\"member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&letter=$letter&page=$i\">$i</a>";
            }
        } else {
            for($i = $page + 1; $i <= $pagevars['totalpages']; $i++){
                $pagevars['middle'] .= ", <a href=\"member.php?a=listmembers&orderby=$orderby&sort=$sort&limit=$limit&letter=$letter&page=$i\">$i</a>";
            }
        }
        $choosepage = $pagevars['first'] . $pagevars['middle'] . $pagevars['last'];
        if($pagevars['totalpages'] < 2){
            $choosepage = "";
        }

        $ob[$orderby] = "selected";
        $s[$sort] = "selected";
        $l[$limit] = "selected";
        $include = stripslashes($template->templates['42']);
        eval("\$include = \"".addslashes($include)."\";");
    break;
    case 'onlinemembers'://view online member list
        //# Updating active table
        $user->updateActive("Viewing Online Member List");

        //# Setting breadcrumbs
        $breadcrumbs .= $template->getVar('crumbsseperator')."Online Member List";
        $_POST = prepValue($_POST);
        $_GET = prepValue($_GET);

        if ($_POST['orderby'] != "") {
            $orderby = $_POST['orderby'];
        }else{
            $orderby = $_GET['orderby'];
        }
        if($_POST['sort'] != ""){
            $sort = $_POST['sort'];
        }else{
            $sort = $_GET['sort'];
        }
        if($_POST['limit'] != ""){
            $limit = $_POST['limit'];
        }else{
            $limit = $_GET['limit'];
        }
        $page = $_GET['page'];

        if($orderby == "usergroup"){
            $orderby = "gid";
        }
        if($orderby == "e-mail"){
            $orderby = "email";
        }
        if($orderby == "homepage"){
            $orderby = "pagename";
        }
        if($orderby == "join date"){
            $orderby = "joindate";
        }
        if($orderby != "username" && $orderby != "gid" && $orderby != "email" && $orderby != "pagename" && $orderby != "joindate" && $orderby != "posts"){
            $orderby = "username";
        }

        if($sort == "decending"){
            $sort = "desc";
        }
        if($sort == "ascending"){
            $sort = "asc";
        }
        if($sort != "asc" && $sort != "desc") {
            $sort = "asc";
        }

        if ($limit == "" || !is_numeric($limit)) {
            $limit = $user->getData('membersperpage');
        }
        if ($page == "" || !is_numeric($page)) {
            $page = 1;
        }

        $page = round($page);
        $start = ($page * $limit) - $limit;
        if($start < 0){
            $start=0;
        }

        $grabtime = time() - 900;
        $listq = $SQL->query("SELECT a.*, u.gid, g.style AS userstyle FROM
                              `".$database['prefix']."active` AS a LEFT JOIN
                              `".$database['prefix']."users` AS u ON (u.id = a.userid) LEFT JOIN
                              `".$database['prefix']."usergroups` AS g ON (g.id = u.gid)
                              WHERE a.anon != '1' AND a.status != 'unlogged' AND a.dateline > $grabtime ORDER BY $orderby $sort LIMIT $start, $limit");
        while($omember = $SQL->fetch_array($listq)) {
            if($omember['userid'] != 0){
                $onlinemembers .= stripslashes($template->templates['45']);
            } else {
                $onlinemembers .= stripslashes($template->templates['76']);
            }
            $omember['dateline'] = date("g:iA ".$template->getVar('joindateformat')."", $omember['dateline']);

            if($user->getdata('view_ip') != 1){
                $omember['ip'] = "<i>hidden</i>";
            }

            $onlinemembers = $template->cacheArray($onlinemembers, $omember);
        }
        $omember = $template->releaseCache();
        eval("\$onlinemembers = \"".addslashes($onlinemembers)."\";");

        $lastq = $SQL->query("SELECT `userid` FROM `".$database['prefix']."active` WHERE `anon` != '1' AND `status` != 'unlogged' AND `dateline` > '$grabtime'");
        $lastpage = $SQL->num_rows($lastq);
        $lastpage = ceil($lastpage / $limit);

        if ($page > $lastpage) {
            die_header("Location: member.php?a=onlinemembers&orderby=$orderby&sort=$sort&limit=$limit&page=$lastpage");
        }
        $pagevars = array();
        $pagevars['totalpages'] = $lastpage;
        $pagevars['first'] = "";
        $pagevars['middle'] = "";
        $pagevars['last'] = "";
        if(($page - 3) >= 2){
            $pagevars['first'] = "<a href=\"member.php?a=onlinemembers&orderby=$orderby&sort=$sort&limit=$limit&page=1\">".$template->getVar('firstpagetext')."</a> ... ";
            for($i = $page - 3; $i < $page; $i++){
                $pagevars['middle'] .= "<a href=\"member.php?a=onlinemembers&orderby=$orderby&sort=$sort&limit=$limit&page=$i\">$i</a>, ";
            }
        } else {
            for($i = 1; $i < $page; $i++){
                $pagevars['middle'] .= "<a href=\"member.php?a=onlinemembers&orderby=$orderby&sort=$sort&limit=$limit&page=$i\">$i</a>, ";
            }
        }
        $pagevars['middle'] .= $page;
        if(($page + 3) < $pagevars['totalpages']){
            $pagevars['last'] = " ... <a href=\"member.php?a=onlinemembers&orderby=$orderby&sort=$sort&limit=$limit&page=$pagevars[totalpages]\">".$template->getVar('lastpagetext')."</a>";
            for($i = $page + 1; $i < $page + 4; $i++){
                $pagevars['middle'] .= ", <a href=\"member.php?a=onlinemembers&orderby=$orderby&sort=$sort&limit=$limit&page=$i\">$i</a>";
            }
        } else {
            for($i = $page + 1; $i <= $pagevars['totalpages']; $i++){
                $pagevars['middle'] .= ", <a href=\"member.php?a=onlinemembers&orderby=$orderby&sort=$sort&limit=$limit&page=$i\">$i</a>";
            }
        }
        $choosepage = $pagevars['first'] . $pagevars['middle'] . $pagevars['last'];
        if($pagevars['totalpages'] < 2){
            $choosepage = "";
        }

        $ob[$orderby] = "selected";
        $s[$sort] = "selected";
        $l[$limit] = "selected";
        $include = stripslashes($template->templates['44']);
        eval("\$include = \"".addslashes($include)."\";");
    break;
    case 'validate':
        $validateq = $SQL->query("SELECT `id`,`username`,`validate` FROM `".$database['prefix']."users` WHERE `validate`='".$_GET['id']."'");
        $u = $SQL->fetch_array($validate);

        if ($u['validate'] != $_GET['id']) {
            bb_error("You have input an invalid activation key, or this account is already activated.");
        }

        $updateq = $SQL->query("UPDATE `".$database['prefix']."boardstats` SET `members` = `members`+1, `newestuid`='".$u['id']."', `newestuser` = '".$u['username']."'");
        $allow = $SQL->query("UPDATE `".$database['prefix']."users` SET `active`='1',`validate`=NULL WHERE `validate`='".$_GET['id']."'");

        $cellhead = "Account Activated";
        $breadcrumbs .= $template->getVar('crumbsseperator')."Account Activation";
        $cellmessage = "Your account, ".$u['username'].", is now activated. You may now login.<br><a href=\"index.php\">Back to Index</a>";
        $include = stripslashes($template->templates['12']);
        eval("\$include = \"".addslashes($include)."\";");
    break;
    case 'forgotpass':
        $breadcrumbs .= $template->getVar('crumbsseperator')."Forgot Password";
        $include = stripslashes($template->templates['77']);
        eval("\$include = \"".addslashes($include)."\";");
    break;
    case 'emailpass':
        $username = prepValue($_POST['username']);
        $emailquery = $SQL->query("SELECT a.email AS adminmail, u.email FROM `".$database['prefix']."users` AS a LEFT JOIN `".$database['prefix']."users` AS u ON(u.username='$username') WHERE a.id='1'");
        $email = $SQL->fetch_array($emailquery);
        if($email['email'] == ""){
            bb_error("The username you specified does not exist.");
        }

        $consonants = array("b","c","d","f","g","h","j","k","l","m","n","p","r","s","t","v","w","x","y","z");
        $vowels = array("a","e","i","o","u","y");
        $password = "";
        $mtime = explode(" ", microtime());
        $mtime = $mtime[1] + $mtime[0];
        mt_srand($mtime);
        while(strlen($password)<8){
            $password .= $consonants[mt_rand(0, 19)];
            $password .= $vowels[mt_rand(0, 5)];
        }

        $config['emailpass'] = str_replace("%boardurl%", $config['boardurl'], $config['emailpass']);
        $config['emailpass'] = str_replace("%password%", $password, $config['emailpass']);

        bb_sendmail($email['email'], "Password for your account on ".$config['boardname'], $config['emailpass']);

        $passupdate = $SQL->query("UPDATE `".$database['prefix']."users` SET `password`='".md5($password)."' WHERE `username`='$username'");

        $cellhead = "<center>Password Reset</center>";
        $breadcrumbs .= $template->getVar('crumbsseperator')."Thank you...";
        $cellmessage = "You password has been changed. Check your email for your new password to login with. You can change your password after you login.<br><a href=\"index.php\">Back to Index</a>";
        $include = stripslashes($template->templates['12']);
        eval("\$include = \"".addslashes($include)."\";");
    break;
    default: //in case nothing is specified, go to index
        die_header("Location: index.php");
    break;
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>