<?php
/*
+-----------------------------------------------------------
|  BirdBoard v1.0.0 Beta
|  $Id: post.php,v 1.14 2005/07/06 18:32:13 relpats_eht Exp $
|  ===========================
|  Developers: Michael Swiger <mokkan@users.sourceforge.net>
|              Elisamuel Resto <user00265@users.sourceforge.net>
|              relpats_eht <relpats_eht@users.sourceforge.net>
|  Site: http://www.birdboard.org
|  Copyright (c)2004-2005 BirdBoard Devs
|
|  ===========================
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
+-----------------------------------------------------------
*/


//# File ID
define("FILEID", "post");

//# Templates:
$bb_templates = '1,12,18,19,20,23,25,34,35,36,46,47,60,67';
require("core.php");

//# Turning action _GET vars into normal vars
$a = prepValue($_GET['a']);
$pa = prepValue($_GET['pa']);

//# Is there a preview?
if(isset($_POST['preview'])){
    $_POST = prepValue($_POST);
    //grabbing the post icon
    $grabicon = $SQL->query("SELECT * FROM `".$database['prefix']."posticons` WHERE `id` = '".prepValue($_POST['icon'])."'");
    $previcon = $SQL->fetch_array($grabicon);

    //building the preview
    $post['title'] = addslashes(addslashes($_POST['title']));
    $message = addslashes(addslashes($_POST['message']));

    //censoring bad words if needed
    if($user->getData('censor') == 1){
        $message = censor($message);
    }

    //parsing emoticons in post
    $grabemoticons = $SQL->query("SELECT `id`,`emoticon`,`image` FROM `".$database['prefix']."emoticons`");
    while($grab = $SQL->fetch_array($grabemoticons)){
        $emoticons[$grab['id']] = $grab['emoticon'];
        $emoticonimages[$grab['id']] = "<img src=\"$config[emoticonpath]$grab[image]\" alt=\"$grab[emoticon]\" />";
    }
    if($_POST['disableemoticons'] == 0){
        $message = parse_emoticons($message, $emoticons, $emoticonimages, $config['emoticonsperpost']);
    }

    //replacing newlines and tabs with html friendly characters
    $message = parse_breaks($message);
    //calling the function to parse bbcode
    $message = parse_bbcode($message);
    //parsing backslash replacments
    $message = str_replace("/me","<font color='#DD0000'>".$user->getData('username')."</font>",$message);
    $message = str_replace("/maim","<font color='#DD0000'>".$user->getData('aim')."</font>",$message);
    $message = str_replace("/mmsn","<font color='#DD0000'>".$user->getData('msn')."</font>",$message);
    $message = str_replace("/micq","<font color='#DD0000'>".$user->getData('icq')."</font>",$message);
    $message = str_replace("/myim","<font color='#DD0000'>".$user->getData('yim')."</font>",$message);
    $message = str_replace("/you","<font color='#007700'>".$user->getData('username')."</font>",$message);
    $message = str_replace("/ygroup","<font color='#007700'>".$user->getData('name')."</font>",$message);
    $message = str_replace("/ybday","<font color='#007700'>".$user->getData('bday').".".$user->getData('bmonth').".".$user->getData('byear')."</font>",$message);

    //autoparsing urls in post
    if($_POST['parseurls'] == 1){
        $message = parse_urls($message);
    }

    //setting the actual preview
    if(($post['title'] != "") || ($_POST['icon'] != "")){
        if($_POST['icon'] != ""){
            $post['icon'] = "<img src=\"$config[posticonpath]".$previcon['value']."\" alt=\"\" />";
        }
        eval("\$preview = \"".$template->cleanTemplate('23') . addslashes($message)."\";");
    } else {
        $preview  = $message;
    }

    eval("\$post['preview'] = \"".$template->templates['34']."\";");
    $post['preview'] = stripslashes($post['preview']);
    //prepping everything to go back to the form
    $a = "postform";
    $post['titlevalue'] = addslashes($_POST['title']);
    $post['messagevalue'] = addslashes($_POST['message']);
    $post['descriptionvalue'] = addslashes($_POST['description']);
    $preview = 1;
}

switch($a){
    case 'postform': //forms for new topic and reply
        $post['timeleft'] = ($user->getData('lastpost') + $config['floodlimit']) - time();
        if($pa == "topic"){
            $fid = prepValue($_GET['fid']);
            $query = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS c ON(f.parent = c.id) WHERE f.id='$fid'");
            $exist = $SQL->num_rows($query);
            if($exist <= 0){
                bb_error("The specified forum does not exist.");
            }
            $crumbdata = $SQL->fetch_array($query);

            //# Grabbing forum permissions
            $user->setForumPerms($fid);

            //# Breadcrumbs
            if($crumbdata['class'] == "subforum"){
                $forumq = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname,p.id AS pid, p.name AS pname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS p ON(p.id=f.parent) LEFT JOIN `".$database['prefix']."forums` AS c ON(p.parent = c.id) WHERE f.id='$fid'");
                $forum = $SQL->fetch_array($forumq);
                $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$forum[cid]\">$forum[cname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$forum[pid]\">$forum[pname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$forum[id]\">$forum[name]</a>" . $template->getVar('crumbsseperator') . "Post New Topic";
            } else {
                $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$crumbdata[cid]\">$crumbdata[cname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[id]\">$crumbdata[name]</a>" . $template->getVar('crumbsseperator') . "Post New Topic";
            }

            //# Updating active table
            $user->updateActive('Posting a new topic');

            if($user->getData('post_topic') != 1){
                bb_error("You aren't allowed to post new topics.");
            }
            $form_template = '19';
            $onload = "onLoad=\"floodtime($post[timeleft], \'Topic\')\"";
        } elseif($pa == "reply") {
            $tid = prepValue($_GET['tid']);
            $query = $SQL->query("SELECT t.id AS tid,t.title AS tname,t.locked,f.id AS fid,f.name AS fname,f.class,c.id AS cid,c.name AS cname FROM `".$database['prefix']."topics` AS t LEFT JOIN `".$database['prefix']."forums` AS f ON (t.fid = f.id) LEFT JOIN `".$database['prefix']."forums` AS c ON (f.parent = c.id) WHERE t.id = '$tid'");
            $exist = $SQL->num_rows($query);
            if($exist <= 0){
                bb_error("The specified topic does not exist.");
            }
            $crumbdata = $SQL->fetch_array($query);

            //# Breadcrumbs
            if($crumbdata['class'] == "subforum"){
                $forumq = $SQL->query("SELECT f.id,f.name,f.class,c.id AS cid,c.name AS cname,p.id AS pid, p.name AS pname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS p ON(p.id=f.parent) LEFT JOIN `".$database['prefix']."forums` AS c ON(p.parent = c.id) WHERE f.id='".$crumbdata['fid']."'");
                $forum = $SQL->fetch_array($forumq);
                $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$forum[cid]\">$forum[cname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$forum[pid]\">$forum[pname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$forum[id]\">$forum[name]</a>" . $template->getVar('crumbsseperator') . "<a href=\"read.php?tid=$crumbdata[tid]\">$crumbdata[tname]</a>" . $template->getVar('crumbsseperator') . "Post Reply";
            } else {
                $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$crumbdata[cid]\">$crumbdata[cname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[fid]\">$crumbdata[fname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"read.php?tid=$crumbdata[tid]\">$crumbdata[tname]</a>" . $template->getVar('crumbsseperator') . "Post Reply";
            }

            //# Updating active table
            $user->updateActive('Posting a new reply');

            if($crumbdata['locked'] == 1 && $user->getData('use_locked') != 1){
                bb_error("You aren't allowed to post replies in a locked topic.");
            }

            if($user->getData('post_reply') != 1){
                bb_error("You aren't allowed to post replies.");
            }
            $form_template = '18';
            //Check for quotes
            $pid = prepValue($_GET['pid']);
            if ((is_numeric($pid)) && ($pid != "")){
                $quotq = $SQL->query("SELECT `postername`,`message` FROM `".$database['prefix']."posts` WHERE `tid`='$tid' AND `id`='$pid'");
                $quotd = $SQL->fetch_array($quotq);
                $quote = "[quote=".$quotd['postername']."]".$quotd['message']."[/quote]";
            }
            $onload = "onLoad=\"floodtime($post[timeleft], \'Reply\')\"";
        } else {
            bb_error("No action specified.");
        }
        $grabemoticons = $SQL->query("SELECT `id`,`emoticon`,`image` FROM `".$database['prefix']."emoticons` LIMIT ".$template->getVar('emoticonsshown'));
        $counter = 0;
        while($grab = $SQL->fetch_array($grabemoticons)){
            if($counter == $template->getVar('emoticonsrow')){
                $post['emoticons'] .= "<br>";
                $counter = 0;
            }
            $post['emoticons'] .= "$spacer<a href=\"javascript:addEmoticon('$grab[emoticon]')\"><img src=\"$config[emoticonpath]$grab[image]\" border=\"0\" alt=\"$grab[emoticon]\" /></a>";
            $spacer = " ";
            $counter++;
        }
        $post['iconchecked'] = "checked";
        $grabposticons = $SQL->query("SELECT `id`,`value` FROM `".$database['prefix']."posticons`");
        while($grab = $SQL->fetch_array($grabposticons)){
            $ischecked = "";
            if($_POST['icon'] == $grab['id']){
                $ischecked = "checked";
                $post['iconchecked'] = "";
            }
            $post['icons'] .= "<input type=\"radio\" name=\"icon\" value=\"$grab[id]\" $ischecked><img src=\"$config[posticonpath]$grab[value]\" alt=\"\" /> ";
        }
        if($preview == 1){
            if($_POST['parseurls'] == 1){
                $checked['parseurls'] = "checked";
            }
            if($_POST['disableemoticons'] == 1){
                $checked['disableemoticons'] = "checked";
            }
            if($_POST['disablesiggy'] == 1){
                $checked['disablesiggy'] = "checked";
            }
            if($_POST['attachpoll'] == 1){
                $checked['attachpoll'] = "checked";
            }
        } elseif($user->getData('id') != 0) {
            if($user->getData('parseurls') == 1){
                $checked['parseurls'] = "checked";
            }
            if($user->getData('disableemoticons') == 1){
                $checked['disableemoticons'] = "checked";
            }
        } else {
            if($config['parseurls'] == 1){
                $checked['parseurls'] = "checked";
            }
            if($config['disableemoticons'] == 1){
                $checked['disableemoticons'] = "checked";
            }
        }

        if($user->getData('viewhistory') == 1){
            $grabemoticons = $SQL->query("SELECT `id`,`emoticon`,`image` FROM `".$database['prefix']."emoticons`");
            while($grab = $SQL->fetch_array($grabemoticons)){
                $emoticons[$grab['id']] = $grab['emoticon'];
                $emoticonimages[$grab['id']] = "<img src=\"$config[emoticonpath]$grab[image]\" alt=\"$grab[emoticon]\" />";
            }
            $prevstartq = $SQL->query("SELECT `id` FROM `".$database['prefix']."posts` WHERE `tid`='$tid'");
            $prevstart = $SQL->num_rows($prevstartq);
            $prevstart -= $user->getData('postsperpage');
            if($prevstart < 0){
                $prevstart = 0;
            }
            $grabprev = $SQL->query("SELECT * FROM `".$database['prefix']."posts` WHERE `tid`='$tid' ORDER BY `id` ASC LIMIT $prevstart, ".$user->getData('postsperpage')."");
            while ($prevpost = $SQL->fetch_array($grabprev)){
                $prevposts = stripslashes($prevposts);
                $prevposts = stripslashes($template->templates['47']) . $prevposts;

                //Prepping Message for Output
                if($prevpost['disableemoticons'] == 0){
                    $prevpost['message'] = parse_emoticons($prevpost['message'], $emoticons, $emoticonimages, $config['emoticonsperpost']);
                }
                $prevpost['message'] = addslashes(addslashes(addslashes($prevpost['message'])));
                $prevpost['message'] = parse_breaks($prevpost['message']);
                $prevpost['message'] = parse_bbcode($prevpost['message']);
                if($user->getData('censor') == 1){
                    $prevpost['message'] = censor($prevpost['message']);
                }

                $prevposts = $template->cacheArray($prevposts, $prevpost);
            }
            $prevpost = $template->releaseCache();
            eval("\$prevposts = \"".addslashes($prevposts)."\";");
            eval("\$post[history] = \"".$template->templates['46']."\";");
            $post['history'] = stripslashes($post['history']);
        }
        $post['maxfilesize'] = filesize_format($config['uploadbytes']);
        $post['extensions'] = $config['uploadext'];
        $post['javascript'] = $template->templates['20'];
        eval("\$include = \"".$template->templates[$form_template]."\";");
        $include = stripslashes($include);
    break;
    case 'postaction': //post actions for replies and topics
        $pa = prepValue($_GET['pa']);
        if($pa == "topic"){
            $fid = prepValue($_GET['fid']);

            //# Setting forum permissions
            $user->setForumPerms($fid);

            if($user->getData('post_topic') != 1){
                bb_error("You aren't allowed to post new topics.");
            }
            if($_POST['title'] == ""){ //is there a title for the topic?
                bb_error("You didn't input a title.");
            }
            if($_GET['fid'] == "") { //is there a forum for the topic to be posted in?
                bb_error("No forum specified.");
            }

            //# Updating active table
            $user->updateActive('Posting a new topic');

            //# Grabbing forum info
            $grabforum = $SQL->query("SELECT * FROM `".$database['prefix']."forums` WHERE `id` = '$fid'");
            $forum = $SQL->fetch_array($grabforum);
            $exist = $SQL->num_rows($grabforum);
            if($exist < 1){
                bb_error("The specified forum does not exist.");
            }
        } elseif($pa == "reply") {
            $tid = prepValue($_GET['tid']);

            //# Grabbing forum info
            $grabforum = $SQL->query("SELECT t.locked AS topic_locked, f.* FROM `".$database['prefix']."topics` AS t LEFT JOIN `".$database['prefix']."forums` AS f ON (t.fid = f.id) WHERE t.id = '$tid'");
            $forum = $SQL->fetch_array($grabforum);
            $locked = $forum['topic_locked'];

            //# Setting forum permissions
            $user->setForumPerms($forum['id']);

            //# Checking if the topic can be posted in
            if($SQL->num_rows($grabforum) < 1){
                bb_error("The specified topic does not exist.");
            }
            if($locked == 1 && $user->getData('use_locked') != 1){
                bb_error("You aren't allowed to post replies in a locked topic.");
            }
            if($user->getData('post_reply') != 1){
                bb_error("You aren't allowed to post replies.");
            }
            if($tid == ""){
                bb_error("No topic specified.");
            }

            //# Updating active table
            $user->updateActive('Posting a reply');
        } else {
            bb_error("No action specified.");
        }
        if($_POST['message'] == ""){ //is there message for the topic?
            bb_error("You didn't input a message.");
        }
        $now = time();
        $floodend = $user->getData('lastpost') + $config['floodlimit'];
        if ($floodend > $now) {
            $secleft = ($floodend - $now) % 60;
            $minleft = floor(($floodend - $now) / 60);
            bb_error("The flood limit is activated. Please wait $minleft minutes and $secleft seconds before you post again.");
        }

        //# Attachments
        $attachid = 0;
        if(is_uploaded_file($_FILES['attachment']['tmp_name'])){ //is there an attached file?
            if($_FILE['attachment']['size'] > $config['uploadbytes']){ //checking if the attachment is too big or not
                bb_error("File is too big.");
            } elseif(strlen($_FILE['attachment']['name'] > 100)) { //checking if the filename will fit in db
                bb_error("File name is too big.");
            } else { //checking if file extension is valid
                $fileextension = strtolower(substr($_FILES['attachment']['name'], strrpos($_FILES['attachment']['name'], ".")));
                $extensions = explode(',', $config['uploadext']);
                foreach($extensions as $ext){
                    if($fileextension == $ext){
                        $clear = 1;
                    }
                    $msg = "File extension not allowed.";
                }
                if($user->getData('post_attachments') != 1){
                    $clear = 0;
                    $msg = "You are not allowed to post attachments.";
                }
                if($clear != 1){
                    bb_error($msg);
                }
                $uploadfile = str_replace("post.php", "temp/", $_SERVER['SCRIPT_FILENAME']) . str_replace(' ', '', strtolower(basename($_FILES['attachment']['name'])));
                move_uploaded_file($_FILES['attachment']['tmp_name'], $uploadfile);
                $handle = fopen($uploadfile, "rb");
                $attachmentcontent = "";
                while (!feof($handle)) {
                   $attachmentcontent .= fread($handle, 1024);
                }
                fclose($handle);
                $insertattachment = $SQL->query("INSERT INTO `".$database['prefix']."attachments` (`id`,`name`,`size`,`content`,`downloads`,`date`) VALUES('','".$_FILES['attachment']['name']."','".$_FILES['attachment']['size']."','".$SQL->escape_string($attachmentcontent)."','0','".time()."')");
                $grabattachid = $SQL->query("SELECT `id` FROM `".$database['prefix']."attachments` ORDER BY `id` DESC LIMIT 1");
                $tempfetch = $SQL->fetch_array($grabattachid);
                $attachid = $tempfetch['id'];
                unlink($uploadfile);
            }
        }

        //# Post insertation
        $title = prepValue($_POST['title']);
        $message = prepValue($_POST['message']);
        $icon = $_POST['icon'];
        if($pa == "topic"){
            $fid = prepValue($_GET['fid']);
            $description = prepValue($_POST['description']);
            $insert = $SQL->query("INSERT INTO `".$database['prefix']."topics` (`id`,`fid`,`authorid`,`authorname`,`iconid`,`title`,`description`,`views`,`replies`,`lpdate`,`lpuserid`,`lpusername`,`locked`,`sticky`,`moved`) VALUES ('','$fid','".$user->getData('id')."','".$user->getData('username')."','$icon','$title','$description','0','0','".time()."','".$user->getData('id')."','".$user->getData('username')."', '0', '0', '0')");
            $getidq = $SQL->query("SELECT `id` FROM `".$database['prefix']."topics` ORDER BY `id` DESC LIMIT 1");
            $grab = $SQL->fetch_array($getidq);
            $tid = $grab['id'];
            if($user->getData('subscribe') == 1 && $user->getData('id') != 0){
                $grabsubs = $SQL->query("INSERT INTO `".$database['prefix']."subscriptions` (`tid`,`userid`) VALUES('".$tid."','".$user->getData('id')."')");
            }
            $forumstatsq = "UPDATE `".$database['prefix']."forums` SET `lpdate`='".time()."', `lptopicid`='$tid', `lptopicname`='$title', `lpuserid`='".$user->getData('id')."', `lpusername`='".$user->getData('username')."', `topics` = topics + 1, `posts` = posts + 1 WHERE `id`='$fid'";
            if($forum['updateparent'] == 1){
                $forumstatsq2 = $SQL->query("UPDATE `".$database['prefix']."forums` SET `lpdate`='".time()."', `lptopicid`='$tid', `lptopicname`='$title', `lpuserid`='".$user->getData('id')."', `lpusername`='".$user->getData('username')."', `topics` = topics + 1, `posts` = posts + 1 WHERE `id`='".$forum['parent']."'");
            }
            $boardstatsq = "UPDATE `".$database['prefix']."boardstats` SET `posts` = posts + 1, `topics` = topics + 1";
            if($_POST['attachpoll'] == 1){
                $location = "post.php?a=attachpoll&pa=pollform&tid=$tid";
            } else {
                $location = "read.php?tid=$tid&a=lastpost";
            }
        } elseif($pa == "reply"){
            $grabtopic = $SQL->query("SELECT `id`,`fid`,`title` FROM `".$database['prefix']."topics` WHERE `id`='$tid'");
            $topic = $SQL->fetch_array($grabtopic);
            $tid = $topic['id'];
            $forumstatsq = "UPDATE `".$database['prefix']."forums` SET `lpdate`='".time()."',`lptopicid`='$tid', `lptopicname`='".$topic['title']."', `lpuserid`='".$user->getData('id')."', `lpusername`='".$user->getData('username')."', `posts` = posts + 1 WHERE `id`='$topic[fid]'";
            if($forum['updateparent'] == 1){
                $forumstatsq2 = $SQL->query("UPDATE `".$database['prefix']."forums` SET `lpdate`='".time()."',`lptopicid`='$tid', `lptopicname`='".$topic['title']."', `lpuserid`='".$user->getData('id')."', `lpusername`='".$user->getData('username')."', `posts` = posts + 1 WHERE `id`='".$forum['parent']."'");
            }

            $mailinfo = $SQL->query("SELECT `email` FROM `".$database['prefix']."users` WHERE id='1'");
            $admin = $SQL->fetch_array($mailinfo);
            $subsquery = $SQL->query("SELECT u.username, u.email FROM `".$database['prefix']."subscriptions` AS s LEFT JOIN `".$database['prefix']."users` AS u ON(s.userid=u.id) WHERE s.tid='".$tid."'");
            while($sub = $SQL->fetch_array($subsquery)){
                $config['subscriptionmail'] = str_replace("%boardurl%", $config['boardurl'], $config['subscriptionmail']);
                $config['subscriptionmail'] = str_replace("%tid%", $tid, $config['subscriptionmail']);
                $config['subscriptionmail'] = str_replace("%ttile%", $topic['title'], $config['subscriptionmail']);
                bb_sendmail($sub['email'], "There has been a reply to ".$topic['title'], $config['subscriptionmail']);
            }

            $boardstatsq = "UPDATE `".$database['prefix']."boardstats` SET `posts` = posts + 1";
            $updatetopicstats = $SQL->query("UPDATE `".$database['prefix']."topics` SET `replies`=replies+1,`lpdate`='".time()."',`lpuserid`='".$user->getData('id')."',`lpusername`='".$user->getData('username')."' WHERE `id`='$tid'");
            $location = "read.php?tid=$tid&a=lastpost";
        }
        if(($user->getData('id') != 0) && ($forum['disablepc'] != 1)){
            $updateuserposts = $SQL->query("UPDATE `".$database['prefix']."users` SET `posts`=posts+1 WHERE `id`='".$user->getData('id')."'");
        }

        $insertpost = $SQL->query("INSERT INTO `".$database['prefix']."posts` (`id`,`tid`,`posterid`,`postername`,`iconid`,`title`,`message`,`dateline`,`ip`,`parseurls`,`disableemoticons`,`disablesiggy`,`attachmentid`) VALUES ('','$tid','".$user->getData('id')."','".$user->getData('username')."','$icon','$title','$message','".time()."','".$_SERVER['REMOTE_ADDR']."','".$_POST['parseurls']."','".$_POST['disableemoticons']."','".$_POST['disablesiggy']."','$attachid')");
        $updateforumstats = $SQL->query($forumstatsq);
        $updateboardstats = $SQL->query($boardstatsq);
        $SQL->query("UPDATE `".$database['prefix']."active` SET `lastpost` = '".time()."' WHERE `userid`='".$user->getdata('id')."' AND `ip`='".$_SERVER['REMOTE_ADDR']."'");

        //# Redirect them to their post
        die_header("Location: ".$config['boardurl'].$location);
    break;
    case 'attachpoll': //polls
        $tid = prepValue($_GET['tid']);

        //# Setting breadcrumbs
        $getcrumbdata = $SQL->query("SELECT t.fid,f.id,f.name,c.id AS cid,c.name AS cname FROM `".$database['prefix']."forums` AS f LEFT JOIN `".$database['prefix']."forums` AS c ON(f.parent = c.id) LEFT JOIN `".$database['prefix']."topics` AS t ON (t.fid = f.id) WHERE t.id='$tid'");
        $crumbdata = $SQL->fetch_array($getcrumbdata);
        $breadcrumbs .= $template->getVar('crumbsseperator') . "<a href=\"board.php?cid=$crumbdata[cid]\">$crumbdata[cname]</a>" . $template->getVar('crumbsseperator') . "<a href=\"board.php?fid=$crumbdata[id]\">$crumbdata[name]</a>" . $template->getVar('crumbsseperator') . "Attach Poll";

        //# Grabbing forum permissions
        $user->setForumPerms($crumbdata['id']);

        //# Checking if user has permission to post the poll
        if($user->getData('post_poll') != 1){
            bb_error("You aren't allowed to post polls.");
        }

        //# Checking if there's a topic to attach the poll to
        if($tid == ""){
            bb_error("No topic specified.");
        }
        $grabtopicinfo = $SQL->query("SELECT `authorid` FROM `".$database['prefix']."topics` WHERE `id` = '".prepValue($_GET['tid'])."'");
        $topic = $SQL->fetch_array($grabtopicinfo);
        $topicexists = $SQL->num_rows($grabtopicinfo);
        if($topicexists < 1){
            bb_error("No topic specified.");
        }

        //# Again, checking user's permissions to attach poll
        if(($topic['authorid'] != $user->getData('id') && $user->getData('edit_others') != 1) || ($topic['authorid'] == $user->getData('id') && $user->getData('edit_own') != 1)){
            bb_error("You aren't allowed to attach a poll to this topic.");
        }

        if($pa == "pollform"){ //attach poll form
            for($c = 0; $c < $config['maxpolloptions']; $c++){
                 $poll['options'] .= $template->templates['36'];
                 $poll['options'] = stripslashes($poll['options']);
                 $option['name'] = $c + 1;
                 eval("\$poll['options'] = \"".addslashes($poll[options])."\";");
            }
            $poll['options'] = stripslashes($poll['options']);
            eval("\$include = \"".$template->templates['35']."\";");
        } elseif($pa == "pollaction") { //attach poll action
            //# Check if poll already exists for this thread
            $grabtid = $SQL->query("SELECT `tid` FROM `".$database['prefix']."polls` WHERE `tid` = '$tid'");
            $checkpollexists = $SQL->num_rows($grabtid);
            if($checkpollexists > 0){
                bb_error("This topic already has a poll.");
            }
            $insertpoll = $SQL->query("INSERT INTO `".$database['prefix']."polls` (`id`,`tid`,`title`,`multichoice`,`totalvotes`) VALUES ('', '".prepValue($_GET['tid'])."','".prepValue($_POST['title'])."','".prepValue($_POST['multi'])."','0')");
            $grabpollinfo = $SQL->query("SELECT `id` FROM `".$database['prefix']."polls` ORDER BY `id` DESC LIMIT 1");
            $poll = $SQL->fetch_array($grabpollinfo);
            $pollid = $poll['id'];
            $c = 1;
            while($_POST[$c] != ""){
                $insertoptions = $SQL->query("INSERT INTO `".$database['prefix']."polloptions` (`id`,`pollid`,`name`,`votes`) VALUES ('','$pollid','".prepValue($_POST[$c])."','0')");
                $c++;
            }
            die_header("Location: ".$config['boardurl']."read.php?tid=".prepValue($_GET['tid']));
        } else {
            bb_error("No action specified.");
        }
    break;
    case 'vote':
        $pollid = prepValue($_GET['pollid']);

        //# Grabbing poll data, and checking if the poll exists
        $grabpolldata = $SQL->query("SELECT p.tid,p.multichoice,t.fid FROM `".$database['prefix']."polls` AS p LEFT JOIN `".$database['prefix']."topics` AS t ON (t.id = p.tid) WHERE p.id = '$pollid'");
        if($SQL->num_rows($grabpolldata) < 1){
            bb_error("The specified poll doesn't exist.");
        }
        $poll = $SQL->fetch_array($grabpolldata);

        //# Setting permissions and checking if user has permission to vote
        $user->setForumPerms($poll['fid']);
        if($user->getData('vote_poll') != 1){
            bb_error("You aren't allowed to vote on polls.");
        }

        //# Checking if the user has already voted
        $grabuservote = $SQL->query("SELECT * FROM `".$database['prefix']."pollvotes` WHERE `pollid` = '$pollid' AND `uid` = '".$user->getData('id')."'");
        $checkvotestatus = $SQL->num_rows($grabuservote);
        if($checkvotestatus > 0){
            bb_error("You have already voted on this poll.");
        }

        //# Checking if post is multi or single choice, and then creating the vote
        if($poll['multichoice'] == 1){
            $graboptions = $SQL->query("SELECT * FROM `".$database['prefix']."polloptions` WHERE `pollid` = '$pollid'");
            while($option = $SQL->fetch_array($graboptions)){
                if($_POST[$option['id']] == 1){
                    $updatevotes = $SQL->query("UPDATE `".$database['prefix']."polloptions` SET `votes` = votes + 1 WHERE `id` = '".$option['id']."'");
                    $createvote = $SQL->query("INSERT INTO `".$database['prefix']."pollvotes` (`pollid`,`uid`,`optionid`) VALUES ('$pollid','".$user->getData('id')."','".$option['id']."')");
                    $updatepollvotes = $SQL->query("UPDATE `".$database['prefix']."polls` SET `totalvotes` = totalvotes + 1 WHERE `id` = '$pollid'");
                }
            }
        } else {
            $updatevotes = $SQL->query("UPDATE `".$database['prefix']."polloptions` SET `votes` = votes + 1 WHERE `id` = '".$_POST['option']."'");
            $createvote = $SQL->query("INSERT INTO `".$database['prefix']."pollvotes` (`pollid`,`uid`,`optionid`) VALUES ('$pollid','".$user->getData('id')."','".$_POST['option']."')");
            $updatepollvotes = $SQL->query("UPDATE `".$database['prefix']."polls` SET `totalvotes` = totalvotes + 1 WHERE `id` = '$pollid'");
        }

        die_header("Location: ".$config['boardurl']."read.php?tid=".$poll['tid']);
    break;
    case 'showemoticons':
        echo stripslashes($template->templates['20']);

        $grabemoticons = $SQL->query("SELECT `id`,`emoticon`,`image` FROM `".$database['prefix']."emoticons`");
        while($grab = $SQL->fetch_array($grabemoticons)){
            echo "<a href=\"javascript:remoteEmoticon('$grab[emoticon]')\"><img src=\"$config[emoticonpath]$grab[image]\" border=\"0\" alt=\"$grab[emoticon]\" /></a> ";
        }

        //# Parse and print
        $gzip->stopGZ();
        die();
    break;
    default:
        die_header("Location: ".$config['boardurl']);
}

//# Setting script vars
$script['gzstatus'] = $gzip->checkGZText();
$script['querycount'] = $SQL->counter();
$script['exectime'] = $timer->stopTimer();
$executiontime = $timer->getTimer();
$script['mysqlexectime'] = $SQL->getexectime();
$script['phpexectime'] = $executiontime - $script['mysqlexectime'];
$script['phpexectime'] = round($script['phpexectime'] / ($executiontime / 100));
$script['mysqlexectime'] = round($script['mysqlexectime'] / ($executiontime / 100));

//# Creating output, sending it to the buffer, and releasing the buffer
eval("\$output = \"".$template->templates['1']."\";");
echo stripslashes($output);
$gzip->stopGZ();
?>